/**
 * Created by Z.JM on 2015/9/11.
 */
"use strict";
pfApp
    .config(['$stateProvider', '$urlRouterProvider', '$ionicConfigProvider', function ($stateProvider, $urlRouterProvider, $ionicConfigProvider) {

        //配置ionic平台相关参数 主要针对IOS Android
        $ionicConfigProvider.platform.ios.tabs.style('standard');
        $ionicConfigProvider.platform.ios.tabs.position('bottom');
        $ionicConfigProvider.platform.android.tabs.style('standard');
        $ionicConfigProvider.platform.android.tabs.position('standard');

        $ionicConfigProvider.platform.ios.navBar.alignTitle('center');
        $ionicConfigProvider.platform.android.navBar.alignTitle('center');

        $ionicConfigProvider.platform.ios.backButton.previousTitleText('');
        $ionicConfigProvider.platform.android.backButton.previousTitleText('');

        $ionicConfigProvider.platform.ios.views.transition('ios');
        $ionicConfigProvider.platform.android.views.transition('android');

        $ionicConfigProvider.platform.ios.form.checkbox('circle');
        $ionicConfigProvider.platform.android.form.checkbox('square');

        $ionicConfigProvider.platform.ios.spinner.icon('ios');
        $ionicConfigProvider.platform.android.spinner.icon('android');

        //默认路由
        $urlRouterProvider.otherwise('/tab/home');

    }])
    //配置sec安全
    .config(['$logProvider', '$sceDelegateProvider',
        function ($logProvider, $sceDelegateProvider) {

            $sceDelegateProvider.resourceUrlWhitelist([
                'self',
                _RESTFUL_ENDPOINT_URL_ + "/**"
            ]);
            $logProvider.debugEnabled(true);
        }])
    //懒加载配置
    .config(['OCLazyLoadModulesConstants', '$ocLazyLoadProvider', 'VersionRandomSerialNO',
        function (OCLazyLoadModulesConstants, $ocLazyLoadProvider, VersionRandomSerialNO) {
            //配置异步加载的js文件
            $ocLazyLoadProvider.config(OCLazyLoadModulesConstants);

            $ocLazyLoadProvider.ocLazyLoadDependency = function () {
                var _args = arguments;
                return {
                    dependencies: ['$ocLazyLoad', '$q', 'OCLazyLoadModulesConstants', function ($ocLazyLoad, $q, OCLazyLoadModulesConstants) {
                        var promise = $q.when(1);
                        for (var i = 0, len = _args.length; i < len; i++) {
                            promise = promiseThen(_args[i]);
                        }
                        return promise;

                        function promiseThen(_arg) {
                            if (typeof _arg == 'function')
                                return promise.then(_arg);
                            else
                                return promise.then(function () {
                                    var nowLoad = getRequiredResource(_arg);
                                    if (!nowLoad)
                                        return $.error('Route resolve: Bad resource name [' + _arg + ']');
                                    if (angular.isArray(nowLoad)) {
                                        nowLoad = nowLoad.map(function (url) {
                                            return url += VersionRandomSerialNO;
                                        });
                                    } else if (angular.isString(nowLoad)) {
                                        nowLoad += VersionRandomSerialNO;
                                    }
                                    
                                    return $ocLazyLoad.load(nowLoad);
                                });
                        }

                        function getRequiredResource(name) {
                            if (OCLazyLoadModulesConstants.modules)
                                for (var m in OCLazyLoadModulesConstants.modules)
                                    if (OCLazyLoadModulesConstants.modules[m].name && OCLazyLoadModulesConstants.modules[m].name === name)
                                        return OCLazyLoadModulesConstants.modules[m];
                            return OCLazyLoadModulesConstants.scripts && OCLazyLoadModulesConstants.scripts[name];
                        };
                    }]
                };
            };
        }]);