/**
 * Created by Z.JM on 2015/9/10.
 */

;
"use strict";
angular.module('pfApp')

    /***
     * MobileValidateCodeService.sendMobileValidateCode(MobileValidateCodeTypeConstants.GENERAL, "1511621031") 返回promise；
     * MobileValidateCodeTypeConstants 验证码分类集合
     ***/

    .factory("MobileValidateCodeService", ['$q', '$PFHttpResource', 'RestFulURLConstants', function ($q, $PFHttpResource, RestFulURLConstants) {

        return {
            sendMobileValidateCode: function (paramsters, mobileValidateCodeType) {
                var requestParameter = angular.extend({type: mobileValidateCodeType.type}, paramsters);
                var httpResource = new $PFHttpResource(RestFulURLConstants.publicService.generalMobileValidateCode, requestParameter, {}, {show: false});
                var _q = $q.defer();
                httpResource.then(function (data) {
                    _q.resolve(data);
                }, function (error) {
                    _q.reject(error);
                });
                return _q.promise;
            }
        };

    }])
    //用户信息
    .factory('UserInfoService', ['$rootScope', 'WebStorageConstants', 'localStorageServices', 'sessionStorageServices', '$interval', 'SecurityStrategyConstants', function ($rootScope, WebStorageConstants, localStorageServices, sessionStorageServices, $interval, SecurityStrategyConstants) {
        var userInfo = null;
        var userTokenId = null;
        var powerLevel = 1;

        var sessionTimeOutInterval = null;

        var setUserInfo = function (_userInfo) {
            if (!_userInfo) {
                return;
            }
            $rootScope.isGlobalLogin = true;
            userInfo = _userInfo;
            sessionStorageServices.setStorage(WebStorageConstants.USER_INFO, _userInfo);
            localStorageServices.setStorage(WebStorageConstants.CURRENT_USER_INFO, _userInfo);

            $rootScope._SESSION_TIME_OUT_SECOND = 0;
            $rootScope.IS_SESSION_TIME_OUT = false;

            if (null == sessionTimeOutInterval) {
                sessionTimeOutInterval = $interval(function () {
                    if ($rootScope._SESSION_TIME_OUT_SECOND < Number.MAX_VALUE) {
                        $rootScope._SESSION_TIME_OUT_SECOND++;
                        $rootScope.IS_SESSION_TIME_OUT = SecurityStrategyConstants.SESSION_TIME_OUT < $rootScope._SESSION_TIME_OUT_SECOND ? true : false;
                        if ($rootScope.IS_SESSION_TIME_OUT) {
                            $interval.cancel(sessionTimeOutInterval);
                            sessionTimeOutInterval = null;
                        }
                    }
                }, 1000);
            }
        };

        var resetSessionTimeOut = function () {
            $rootScope._SESSION_TIME_OUT_SECOND = -1;
        };

        var isSessionTimeOut = function () {
            return SecurityStrategyConstants.SESSION_TIME_OUT < $rootScope._SESSION_TIME_OUT_SECOND ? true : false;
        };

        var removeUserInfo = function () {
            userInfo = null;
            userTokenId = null;
            powerLevel = 1;

            sessionStorageServices.rmStorage(WebStorageConstants.USER_INFO);

            var _userInfo = localStorageServices.getStorage(WebStorageConstants.CURRENT_USER_INFO);
            !!_userInfo ? _userInfo.userPassword = null : null;
            localStorageServices.setStorage(WebStorageConstants.CURRENT_USER_INFO, _userInfo);

            $rootScope.isGlobalLogin = false;
            if (null != sessionTimeOutInterval) {
                $interval.cancel(sessionTimeOutInterval);
                sessionTimeOutInterval = null;
            }
        }
        var getUserInfo = function () {
            return userInfo || sessionStorageServices.getStorage(WebStorageConstants.USER_INFO);
        };

        var setUserTokenId = function (_userTokenId) {
            if (!_userTokenId) {
                return;
            }
            userTokenId = _userTokenId;
            sessionStorageServices.setStorage(WebStorageConstants.USER_TOKEN_ID, _userTokenId);
        };

        var getUserTokenId = function () {
            return userTokenId || sessionStorageServices.getStorage(WebStorageConstants.USER_TOKEN_ID);
        };

        var isAuthenUser = function () {
            return (userInfo ? true : false) && (userInfo.userLevel === 'AuthenUser' || false);
        };

        var isRegisterUser = function () {
            return (userInfo ? true : false) && (userInfo.userLevel === 'RegisterUser' || false);
        };

        var isLogin = function () {
            $rootScope.isGlobalLogin = (userInfo && userTokenId) ? true : false;
            return $rootScope.isGlobalLogin;
        };

        var getPowerLevel = function () {
            if (isAuthenUser() && isLogin()) {
                powerLevel = 1 + 2 + 4;
            } else if (isRegisterUser() && isLogin()) {
                powerLevel = 1 + 2;
            } else {
                powerLevel = 1;
            }
            return powerLevel;
        };
        var updateUserInfoAuthen = function () {
            userInfo.userLevel = 'AuthenUser';
            sessionStorageServices.rmStorage(WebStorageConstants.USER_INFO);
            sessionStorageServices.setStorage(WebStorageConstants.USER_INFO, userInfo);
        }
        setUserInfo(sessionStorageServices.getStorage(WebStorageConstants.USER_INFO));
        setUserTokenId(sessionStorageServices.getStorage(WebStorageConstants.USER_TOKEN_ID));
        var setElectronAcct = function (acctNo) {
            sessionStorageServices.setStorage(WebStorageConstants.USER_ACCT_NO, acctNo);
        }
        var getElectronAcct = function () {
            return sessionStorageServices.getStorage(WebStorageConstants.USER_ACCT_NO);
        }
        return {
            setUserInfo: setUserInfo,
            getUserInfo: getUserInfo,
            setUserTokenId: setUserTokenId,
            getUserTokenId: getUserTokenId,
            isAuthenUser: isAuthenUser,
            isRegisterUser: isRegisterUser,
            isLogin: isLogin,
            getPowerLevel: getPowerLevel,
            removeUserInfo: removeUserInfo,
            updateUserInfoAuthen: updateUserInfoAuthen,
            setElectronAcct: setElectronAcct,
            getElectronAcct: getElectronAcct,
            resetSessionTimeOut: resetSessionTimeOut,
            isSessionTimeOut: isSessionTimeOut
        };

    }])
    //手势密码
    .factory('GestureService', ['WebStorageConstants', 'localStorageServices', 'UserInfoService', 'GestureLockConstants',
        function (WebStorageConstants, localStorageServices, UserInfoService, GestureLockConstants) {

            var setGesture = function (password) {
                var oid = (null != UserInfoService.getUserInfo() ? UserInfoService.getUserInfo().oid : "");
                localStorageServices.setStorage(oid + WebStorageConstants.USER_GESTURE_LOCK, verificationFunction(password));
                setVerificationTimes(GestureLockConstants.verificationTimes);
            };

            var getGesture = function () {
                var userInfo = localStorageServices.getStorage(WebStorageConstants.CURRENT_USER_INFO);
                var oid = (null != userInfo ? userInfo.oid : "");
                return localStorageServices.getStorage(oid + WebStorageConstants.USER_GESTURE_LOCK);
            };

            var removeGesture = function () {
                var oid = (null != UserInfoService.getUserInfo() ? UserInfoService.getUserInfo().oid : "");
                localStorageServices.rmStorage(oid + WebStorageConstants.USER_GESTURE_LOCK);
                setVerificationTimes(0);
            };

            var isSetGesture = function () {
                return null == getGesture() ? false : true;
            };

            var verificationFunction = function (password) {
                return password;
            };

            var getVerificationTimes = function () {
                var userInfo = localStorageServices.getStorage(WebStorageConstants.CURRENT_USER_INFO);
                var oid = (null != userInfo ? userInfo.oid : "");
                var times = localStorageServices.getStorage(oid + WebStorageConstants.USER_GESTURE_LOCK + "VERIFICATION_TIMES");
                return parseInt(!!times ? times : "0");
            }

            var setVerificationTimes = function (times) {
                var userInfo = localStorageServices.getStorage(WebStorageConstants.CURRENT_USER_INFO);
                var oid = (null != userInfo ? userInfo.oid : "");
                localStorageServices.setStorage(oid + WebStorageConstants.USER_GESTURE_LOCK + "VERIFICATION_TIMES", times);
                return times;
            }
            return {
                getVerificationTimes: getVerificationTimes,
                setVerificationTimes: setVerificationTimes,
                setGesture: setGesture,
                getGesture: getGesture,
                removeGesture: removeGesture,
                isSetGesture: isSetGesture,
                verificationFunction: verificationFunction
            };
        }])
    //概要展示
    .factory('FeatureGuideService', ['WebStorageConstants', 'localStorageServices', 'FeatureGuideConstants',
        function (WebStorageConstants, localStorageServices, FeatureGuideConstants) {

            function isShowedFeatureGuide() {
                return localStorageServices.getStorage(FeatureGuideConstants.featureGuideKey + "-" + "FEATURE_GUIDE") ? true : false;
            };

            function setFeatureGuideStatus(status) {
                localStorageServices.setStorage(FeatureGuideConstants.featureGuideKey + "-" + "FEATURE_GUIDE", status);
            };

            function getFeatureGuideImages() {
                return FeatureGuideConstants.featureGuideImages || [];
            };

            return {
                getFeatureGuideImages: getFeatureGuideImages,
                isShowedFeatureGuide: isShowedFeatureGuide,
                setFeatureGuideStatus: setFeatureGuideStatus
            };

        }])
    //发送校验码
    .factory('SendValidateCodeService', ['$rootScope', '$state', '$interval', '$timeout', '$ionicLoading', '$window', 'sessionStorageServices', '$PFHttpResource', 'RestFulURLConstants', 'MobileValidateCodeService', 'MobileValidateCodeTypeConstants', '$cordovaToast',
        function ($rootScope, $state, $interval, $timeout, $ionicLoading, $window, sessionStorageServices, Resource, URLConstants, MobileValidateCodeService, MobileValidateCodeTypeConstants, $cordovaToast) {
            /**
             * 发送手机验证码，注：手机号为user.cellphone
             * @type {null}
             */

            var _sendValidateCode = function (obj, type) {
                var sendMobileValidateCodeTnterval = null;

                if (obj.isSending || obj.isSendTimeLimit) {
                    return;
                }

                obj.isSending = true;
                MobileValidateCodeService.sendMobileValidateCode({userAccount: obj.user.cellPhone}, type).then(function (data) {

                    obj.user.verificationCode = parseInt(data.context.result);

                    var timeCount = MobileValidateCodeTypeConstants.BANKPHONECERTIFICATION.timeOut + 1;

                    obj.isSending = false;
                    obj.isSendTimeLimit = true;
                    obj.sendTimeOut = --timeCount + "秒";
                    obj.validateCodeInterval =  sendMobileValidateCodeTnterval = $interval(function () {
                        if (timeCount > 0) {
                            obj.sendTimeOut = --timeCount + "秒";
                        } else {
                            obj.isSendTimeLimit = false;
                            $interval.cancel(sendMobileValidateCodeTnterval);
                            sendMobileValidateCodeTnterval = null;
                        }
                    }, 1000);

                    $cordovaToast.show('验证码已发送，请注意查收', 'long', 'center');

                    if(obj.$on)
                        obj.$on("$destroy", function (event) {
                            if (sendMobileValidateCodeTnterval) {
                                $interval.cancel(sendMobileValidateCodeTnterval);
                            }
                        });

                }, function (error) {
                    obj.isSending = false;
                    obj.isSendTimeLimit = false;
                });
            }
            return {
                sendValidateCode: function (obj, type) {
                    _sendValidateCode(obj, type);
                },
                //清楚对应验证码倒计时缓存
                clearValidateCode: function (id) {
                    var phoneCodeObj = $rootScope.cachedPhoneCodeObj[$state.current.name+id];

                    phoneCodeObj.isSending = false;
                    phoneCodeObj.isSendTimeLimit = false;
                    $interval.cancel(phoneCodeObj.validateCodeInterval);
                }
            }
        }])
    //银行卡类型
    .factory('DistinguishBankTypeService', ['$PFHttpResource', 'RestFulURLConstants', function (Resource, URLConstants) {
        /**
         * g根据银行代码获取银行名称
         * @param bankCode
         * @private
         */
        var _distinguishBankInfo = function (bankCode, obj) {

            var _promise = Resource(URLConstants.publicService.distinguishBankType, {cardno: bankCode});
            _promise.then(function (data) {
                var info = data.context;
                var bankName = info.bankName;
                obj.card.showFlag = true;
                if (bankName) {
                    if ((bankCode == '623072' || bankCode == '622897') && bankName) {
                        obj.card.isThisBank = 'Y';
                    } else if (bankCode != '623072' && bankCode != '622897' && bankName) {
                        obj.card.isThisBank = 'N';
                    }
                    obj.card.banktype = info.bankType;
                    obj.card.bankname = bankName;
                    obj.card.bankCardIcon = info.bankCardIcon;
                } else {
                    obj.card.isThisBank = 'E';
                }
            }, function (data) {
            })
        };
        return {
            distinguishBankType: function (bankCode, obj) {
                return _distinguishBankInfo(bankCode, obj);
            }
        };
    }])
    //问题
    .factory('CommonQuestionService', ['$PFHttpResource', 'RestFulURLConstants',
        function (Resource, URLConstants) {
            /**
             * g根据问题类型获取问题和答案
             * @param questionStyle
             * @private
             */
            var guestion = null;

            var _getQuestions = function (questionType, obj) {
                if (guestion != null) {

                    obj.showQuestion = guestion[questionType];
                } else {
                    var _promise = Resource(URLConstants.commonQuestion, {}, {}, {show: false});
                    _promise.then(function (data) {
                        guestion = data.context;
                        if (guestion) {
                            obj.showQuestion = guestion[questionType];
                        }
                    });
                }
            };

            return {
                getQuestions: function (questionType, obj) {
                    return _getQuestions(questionType, obj);
                }
            };
        }])
    //文件读取
    .factory('FileReaderService', ["$q", function ($q) {

        var onLoad = function (reader, deferred) {
            return function () {
                deferred.resolve(reader.result);
            };
        };

        var onError = function (reader, deferred) {
            return function () {
                deferred.reject(reader.result);
            };
        };

        var readAsBinaryString = function (file) {
            var reader = new FileReader();

            var q = $q.defer();
            reader.onload = onLoad(reader, q);
            reader.onerror = onError(reader, q);
            reader.readAsBinaryString();
            return q.promise;

        };

        var readAsText = function (file) {
            var reader = new FileReader();

            var q = $q.defer();
            reader.onload = onLoad(reader, q);
            reader.onerror = onError(reader, q);
            reader.readAsText();
            return q.promise;
        };

        var readAsDataURL = function (file) {
            var reader = new FileReader();

            var q = $q.defer();
            alert(file);
            reader.onload = onLoad(reader, q);
            reader.onerror = onError(reader, q);
            reader.readAsDataURL();
            return q.promise;
        };

        return {
            readAsBinaryString: readAsBinaryString,
            readAsDataURL: readAsDataURL,
            readAsText: readAsText
        };
    }])
    //路由权限控制计算
    .factory('StatePowerControlService', ['$state', 'UserInfoService', function ($state, UserInfoService) {

        var _q = $q.defer();
        var urlPowerLevel = $state.data && $state.data.$stateLevel ? $state.data.$stateLevel : RouterLevel.AUTHEN_USER;
        var powerLevel = UserInfoService.getPowerLevel();

        if (powerLevel < urlPowerLevel) {
            _q.resolve(urlPowerLevel);
        } else {
            _q.reject(urlPowerLevel);
        }
        return _q.promise;
    }])
    //交易密码
    .factory('$transactionPassword', ['$rootScope', '$ionicModal', '$ionicBackdrop', '$compile', '$q', function ($rootScope, $ionicModal, $ionicBackdrop, $compile, $q) {


        return function (_option) {
            var deferred = $q.defer();
            var option = _option || {};
            option.scope = (option.scope || $rootScope).$new();

            var passwordUnits = [];
            option.scope.__passwordUnitCount = 0;

            option.scope.__closePasswordModal = function () {
                option.scope.transactionPasswordModal.hide();
                deferred.reject({data: passwordUnits.join(''), type: 'CLOSE'});
            };

            option.scope.__inputPassword = function (_value) {
                if (passwordUnits.length < 6) {
                    passwordUnits.push(_value);
                    option.scope.__passwordUnitCount = passwordUnits.length;
                    deferred.notify({data: _value, type: "INPUT"});
                    if (passwordUnits.length === 6) {
                        option.scope.transactionPasswordModal.hide();
                        deferred.resolve(passwordUnits.join(''));
                    }
                }
            };

            option.scope.__deletePassword = function () {
                if (passwordUnits.length > 0) {
                    var deleteValue = passwordUnits.pop();
                    option.scope.__passwordUnitCount = passwordUnits.length;
                    deferred.notify({data: deleteValue, type: 'DELETE'});
                }
            };

            $ionicModal.fromTemplateUrl('templates/transactionPasswordModal.html', {
                animation: "slide-in-up",
                scope: option.scope,
            }).then(function (modal) {
                option.scope.transactionPasswordModal = modal;
                option.scope.transactionPasswordModal.show();

                option.scope.$on('$destroy', function () {
                    option.scope.transactionPasswordModal.remove();
                });

            });

            return deferred.promise;
        };

    }])
    //交易密码加密
    .factory('EncodePassword', ['$timeout', 'UserInfoService', 'DevelopmentModeConstants', '$ionicPopup', '$q',
        function ($timeout, UserInfoService, DevelopmentModeConstants, $ionicPopup, $q) {
            /**
             * 密码加密
             * @param type 10或者11  10：代表无卡加密  11：代表有卡加密
             * @param password 密码
             * @param cardNo   卡号  可以为空（默认电子账号）
             * @returns {*}
             * @private
             */
            var _encrypt = function (type, password, cardNo) {
                return $q(function (resolve, reject) {
                    var params = {};
                    if (type && type != '' && (type != '10' || type != '11')) {
                        if (type === '11') {
                            if (cardNo) {
                                params.acno = cardNo;
                            } else {
                                params.acno = UserInfoService.getElectronAcct();
                            }
                        }
                    } else {
                        var alertPopup = $ionicPopup.alert({
                            title: '温馨提示',
                            template: '加密类型非法!'
                        });
                        return;
                    }
                    if (!password || password == '') {
                        var alertPopup = $ionicPopup.alert({
                            title: '温馨提示',
                            template: '密码不能为空!'
                        });
                        return;
                    }
                    params.tag = type;
                    params.passPlain = password;
                    try {
                        if (!DevelopmentModeConstants.debug) {
                            encode.encodepassword(function (ret) {
                                $timeout(function () {
                                    if (ret.status === '00') {
                                        resolve(ret.midPass);
                                    } else {
                                        reject(ret);
                                    }
                                });
                            }, function (ret) {
                                $timeout(function () {
                                    reject(ret);
                                });
                            }, params);
                        } else {
                            $timeout(function () {
                                resolve(password);
                            });
                        }
                    } catch (e) {
                        $timeout(function () {
                            reject(e);
                        });
                    }

                });
            }
            return {
                encrypt: _encrypt
            }
        }])
    //短信
    .factory('MSGManage', ['GestureService', '$ionicHistory', '$rootScope', '$state', 'RestFulURLConstants', 'UserInfoService', '$ionicPlatform', '$cordovaLocalNotification', '$PFHttpResource', '$ionicPopup',
        function (GestureService, $ionicHistory, $rootScope, $state, URLConstants, UserInfoService, $ionicPlatform, $cordovaLocalNotification, Resource, $ionicPopup) {
            //创建连接
            var socket = null;
            var _wsconnect = function () {

                var userAccount = UserInfoService.getUserInfo().userAccount;
                var url = URLConstants.webScoket.onopen;

                if ('WebSocket' in window) {
                    socket = new WebSocket(url + "?userAccount=" + userAccount);
                } else if ('MozWebSocket' in window) {
                    socket = new MozWebSocket(url + "?userAccount=" + userAccount);
                } else {
                    return;
                }

                socket.onopen = function (ret) {
                }
                socket.onmessage = function (ret) {
                    var sendMsg = new Array();
                    var yddlMsg = new Array();
                    if (ret.data) {
                        var data = angular.fromJson(ret.data);
                        for (var i = 0; i < data.length; i++) {

                            var obj = new Object();
                            obj.id = i;
                            obj.title = data[i].msgTypeName;
                            obj.text = data[i].msgTheme;
                            obj.data = data[i];
                            if (data[i].msgType == 'msg_yddl') {
                                yddlMsg.push(obj);
                            } else {
                                sendMsg.push(obj);
                            }

                        }
                    }
                    if (sendMsg.length > 0) {
                        _sendMsg(sendMsg);
                    }
                    if (yddlMsg.length > 0) {
                        __sendYddl(yddlMsg);
                    }
                }

            }
            //发送消息
            var _sendMsg = function (obj) {
                $ionicPlatform.ready(function () {
                    $cordovaLocalNotification.schedule(obj).then(function (result) {
                    });

                });
            }
            //发送异地登陆消息
            var __sendYddl = function (objs) {
                var alertPopupYddl = $ionicPopup.alert({
                    title: '温馨提示',
                    okText: '确定',
                    okType: 'button-panda',
                    template: objs[0].data.message
                });

                alertPopupYddl.then(function (res) {
                    GestureService.removeGesture();
                    UserInfoService.removeUserInfo();
                    $state.go("tab.home", {goLogin: true});
                });
            }
            $rootScope.$on('$cordovaLocalNotification:click',
                function (event, notification, state) {
                    $state.go("personCenter.messageNotice", {"notification": notification});
                });

            return {
                wsconnect: _wsconnect,
                sendMsg: _sendMsg
            }
        }])
    //统一交易回执展示
    .factory('BusinessConfirmModal', ['$rootScope', '$ionicModal', '$q', '$sce',
        function ($rootScope, $ionicModal, $q, $sce) {


            return function (_parameterObject) {
                var parameterObject = {
                    scope: $rootScope,
                    type: null,
                    header: null,
                    title: null,
                    subTitle: null,
                    message: null,
                    url: 'templates/businessConfirmModal.html'
                }
                parameterObject = angular.extend(parameterObject, _parameterObject, true);
                var scope = parameterObject.scope.$new();

                scope.header = parameterObject.header;
                scope.type = parameterObject.type;
                scope.title = parameterObject.title;
                scope.subTitle = $sce.trustAsHtml(parameterObject.subTitle);
                scope.message = $sce.trustAsHtml(parameterObject.message);
                scope.okText = parameterObject.okText || '完成';
                //自定义样式
                scope.subTitleStyle = angular.extend({'width': '100vw','text-align': 'center','font-size': '5vmin','line-height': '5vmin'},parameterObject.subTitleStyle);

                var deferred = $q.defer();

                $ionicModal.fromTemplateUrl(parameterObject.url, {
                    animation: "slide-in-right",
                    scope: scope
                }).then(function (modal) {
                    scope._businessConfirmModal = modal;
                    scope._businessConfirmModal.show();
                });

                scope._closeBusinessConfirmModal = function () {
                    scope._businessConfirmModal.hide();
                };

                scope.$on('$destroy', function () {
                    scope._businessConfirmModal.remove();
                });

                scope.$on('modal.hidden', function () {
                    deferred.resolve(parameterObject);
                });

                return deferred.promise;
            };
        }])
    //校验工厂
    .factory('ValidateFactory', ['$rootScope', function ($rootScope) {
        function isIdCardNo(num) {
            var factorArr = new Array(7, 9, 10, 5, 8, 4, 2, 1, 6, 3, 7, 9, 10, 5, 8, 4, 2, 1);
            var parityBit = new Array("1", "0", "X", "9", "8", "7", "6", "5", "4", "3", "2");
            var varArray = new Array();
            var intValue;
            var lngProduct = 0;
            var intCheckDigit;
            var intStrLen = num.length;
            var idNumber = num;
            // 判断19位
            if (intStrLen != 18) {
                return false;
            }
            // 检验数字和最后一位字母
            for (var i = 0; i < intStrLen; i++) {
                varArray[i] = idNumber.charAt(i);
                if ((varArray[i] < '0' || varArray[i] > '9') && (i != 17)) {
                    return false;
                } else if (i < 17) {
                    varArray[i] = varArray[i] * factorArr[i];
                }
            }

            //8位日期检查
            var date8 = idNumber.substring(6, 14);
            if (isDate8(date8) == false) {
                return false;
            }
            // calculate the sum of the products
            for (i = 0; i < 17; i++) {
                lngProduct = lngProduct + varArray[i];
            }
            // calculate the check digit
            intCheckDigit = parityBit[lngProduct % 11];
            // check last digit
            if (varArray[17] != intCheckDigit) {
                return false;
            }
            return true;
        };
        /**七日校验规则，考虑闰月闰年*/
        function isDate8(sDate) {
            if (!/^[0-9]{8}$/.test(sDate)) {
                return false;
            }
            var year, month, day;
            year = sDate.substring(0, 4);
            month = sDate.substring(4, 6);
            day = sDate.substring(6, 8);
            var iaMonthDays = [31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31]
            if (year < 1700 || year > 2500) return false
            if (((year % 4 == 0) && (year % 100 != 0)) || (year % 400 == 0)) iaMonthDays[1] = 29;
            if (month < 1 || month > 12) return false
            if (day < 1 || day > iaMonthDays[month - 1]) return false
            return true;
        };
        var _idNoValidate = function (newValue) {
            return isIdCardNo(newValue);
        }
        return {
            idNoValidate: _idNoValidate
        }
    }])
    //功能指引
    .factory('NoviceGuide', ['$rootScope', '$ionicModal', '$q', function ($rootScope, $ionicModal, $q) {

        return function (parametersObject) {
            var deferred = $q.defer();

            var initParametersObject = {
                scope: null,
                url: null
            };
            angular.extend(initParametersObject, parametersObject);
            initParametersObject.scope = (initParametersObject.scope || $rootScope).$new();

            $ionicModal.fromTemplateUrl(initParametersObject.url, {
                scope: initParametersObject.scope
            }).then(function (modal) {
                initParametersObject.scope.modal = modal;
                initParametersObject.scope.modal.show();
            });

            initParametersObject.scope.done = function (result) {
                initParametersObject.scope.modal.hide();
                deferred.resolve(result);
            };

            initParametersObject.scope.$on('$destroy', function () {
                initParametersObject.scope.modal.remove();
            });

            initParametersObject.scope.$on('modal.hidden', function () {

            });


            return deferred.promise;
        };

    }])
    //定位
    .factory('BaiduLocation', ['$timeout', '$rootScope', '$q', '$ionicPlatform', '$cordovaToast', '$ionicPopup',
        function ($timeout, $rootScope, $q, $ionicPlatform, $cordovaToast, $ionicPopup) {

            function getCityCode() {
                var deferred = $q.defer();

                if ($rootScope.isOnline) {
                    $ionicPlatform.ready(function () {
                        try {
                            navigator.locations.getCityCode(function (location) {
                                $timeout(function () {
                                    if (location.status == '00') {
                                        deferred.resolve(location);
                                    } else {
                                        //定位失败，强制刷新列表
                                        deferred.reject("[" + location.status + "]定位失败");
                                    }
                                });
                            }, function (error) {
                                //定位失败，强制刷新列表
                                $timeout(function () {
                                    deferred.reject(JSON.stringify(error));
                                });
                            })
                        } catch (e) {
                            //定位失败，强制刷新列表
                            $timeout(function () {
                                deferred.reject(JSON.stringify(e));
                            });
                        }
                    });
                } else {
                    try {
                        $cordovaToast.show('无网络连接', "long", "center");
                    } catch (e) {
                        $ionicPopup.alert({
                            title: "提醒",
                            template: '无网络连接',
                            okText: '知道了',
                            okType: 'button-panda'
                        });
                    }
                    deferred.reject({error: '无网络连接'});
                }

                return deferred.promise;
            };

            function nearlySearch(param) {
                var deferred = $q.defer();
                if ($rootScope.isOnline) {
                    $ionicPlatform.ready(function () {
                        try {
                            navigator.locations.nearlySearch(function (location) {
                                if (location) {
                                    deferred.resolve(location);
                                } else {
                                    //定位失败，强制刷新列表
                                    deferred.reject("[" + location.status + "]定位失败");
                                }
                            }, function (error) {
                                //定位失败，强制刷新列表
                                deferred.reject(JSON.stringify(error));
                            }, param);
                        } catch (e) {
                            //定位失败，强制刷新列表
                            deferred.reject(JSON.stringify(e));
                        }
                    });
                } else {
                    try {
                        $cordovaToast.show('无网络连接', "long", "center");
                    } catch (e) {
                        $ionicPopup.alert({
                            title: "提醒",
                            template: '无网络连接',
                            okText: '知道了',
                            okType: 'button-panda'
                        });
                    }
                    deferred.reject({error: '无网络连接'});
                }

                return deferred.promise;
            };

            function close() {
              var deferred = $q.defer();
              if ($rootScope.isOnline) {
                $ionicPlatform.ready(function () {
                  try {
                    navigator.locations.close(function () {

                    }, function (error) {
                      //定位失败，强制刷新列表
                      deferred.reject(JSON.stringify(error));
                    }, param);
                  } catch (e) {
                    //定位失败，强制刷新列表
                    deferred.reject(JSON.stringify(e));
                  }
                });
              } else {
                try {
                  $cordovaToast.show('无网络连接', "long", "center");
                } catch (e) {
                  $ionicPopup.alert({
                    title: "提醒",
                    template: '无网络连接',
                    okText: '知道了',
                    okType: 'button-panda'
                  });
                }
                deferred.reject({error: '无网络连接'});
              }

              return deferred.promise;
            };

            return {
                getCityCode: getCityCode,
                nearlySearch: nearlySearch,
                close: close
            };

        }])
    //交易流水号
    .factory('GenerateTransactionSerialNoService', ['RestFulURLConstants', '$PFHttpResource', function (URLConstants, $PFHttpResource) {

        var _generateTransactionSerialNo = function (_obj) {
            var _promise = $PFHttpResource(URLConstants.unitResource.generateTransactionSerialNo, _obj);
            return _promise;
        }
        return {
            generateTransactionSerialNo: function (obj) {
                return _generateTransactionSerialNo(obj);
            }
        }
    }])
    .factory('ChannelApplicationService', ['$rootScope', '$PFHttpResource', 'RestFulURLConstants', '$cordovaToast', 'UserInfoService', 'MSGManage', 'DevelopmentModeConstants', '$q', '$ionicHistory',
    function($rootScope, $PFHttpResource, RestFulURLConstants, $cordovaToast, UserInfoService, MSGManage, DevelopmentModeConstants, $q, $ionicHistory) {
      return {
        exitApp: exitApp,
        getChannelParams: getChannelParams,
        channelAutoLogin: channelAutoLogin,
        channelParamsData: {}
      };
      function exitApp(){
        if(UserInfoService.isLogin()) {
          $PFHttpResource(RestFulURLConstants.userManagement.signOut)
            .then(function(){
              UserInfoService.removeUserInfo();
              exit();
            });
        } else {
          exit();
        }

        function exit() {
          $ionicHistory.clearHistory();
          $ionicHistory.clearCache();
          if (ionic.Platform.isAndroid()) {
            ionic.Platform.exitApp();
          } else {
            navigator.transfer && navigator.transfer.colseViewController();
          }
        }


      }
      function getChannelParams() {
        var _promise = $q.defer();
        if(navigator.transfer && navigator.transfer.transferPassword) {
          navigator.transfer.transferPassword({
            success: function(data) {
              if(typeof data == 'string') {
                data = JSON.parse(data);
              }
              _promise.resolve(data);
            },
            error: function(error) {
              _promise.reject(error);
            }
          });
        } else {
          _promise.resolve({userId: '1120', mobileNo: '18628217909'});
          /*if(DevelopmentModeConstants.debug) {
           _promise.resolve({userId: '123', mobileNo: '18628217909'});
           } else {
           _promise.reject();
           }*/
        }
        return _promise.promise;
      }
      function channelAutoLogin(obj) {
        $PFHttpResource(RestFulURLConstants.security.channelLogin, obj, null, {show: false})
          .then(function(data) {
            if(data.context.result) {
              UserInfoService.setUserInfo(data.context.sysUserInfo);
              UserInfoService.setUserTokenId(data.context.tokenId);
              UserInfoService.setElectronAcct(data.context.electronAcct);
              $rootScope.$broadcast("LOGIN:SUCCESS");
              //链接消息服务器并获取离线信息
              try {
                var _promise = MSGManage.wsconnect();
              } catch (e) {
              }
            } else {
              /*if(data.context.message) {
               try {
               $cordovaToast.show(data.context.message, 'long', 'center');
               } catch(e) {
               console.info('toast info');
               }

               }*/
            }
          }, function(error) {

          });
      }
    }])
    //更新APK
    .factory('UpdateApkService', ['$ionicPlatform', '$rootScope', '$timeout', '$ionicPopup', '$PFHttpResource', 'RestFulURLConstants', '$cordovaAppVersion', '$ionicLoading', '$cordovaFileTransfer', '$cordovaFileOpener2', '$cordovaFile', '$cordovaInAppBrowser', 'SecurityHTTPRequestChannel', 'DevelopmentModeConstants', 'ChannelConstants', 'ChannelApplicationService',
        function ($ionicPlatform, $rootScope, $timeout, $ionicPopup, $PFHttpResource, RestFulURLConstants, $cordovaAppVersion, $ionicLoading, $cordovaFileTransfer, $cordovaFileOpener2, $cordovaFile, $cordovaInAppBrowser, SecurityHTTPRequestChannel, DevelopmentModeConstants, ChannelConstants, ChannelApplicationService) {

          function autoLogin() {
            ChannelApplicationService.getChannelParams()
              .then(function(data) {
                if(data) {
                  var _param = {
                    mobileNo: data.mobileNo,
                    channelUserId: data.userId,
                    channelId: ChannelConstants.id
                  };
                  ChannelApplicationService.channelParamsData = _param;
                  ChannelApplicationService.channelAutoLogin(_param);
                }
              }, function(error){
                autoLogin();
              });
          }
            function initHttpRequest() {
              //非调试并且需要加密，则握手。
              if (!DevelopmentModeConstants.debug && DevelopmentModeConstants.aes && $rootScope.initHttpRequest) {
                $rootScope.initHttpRequest = false;
                SecurityHTTPRequestChannel.initHTTPRequestChannel();
                if(ChannelConstants.isAutoLogin){
                  autoLogin();
                }
              }
            }
            function checkeApkUpdate(isSelfCheck) {

                if (!$rootScope._isShowUpdate && !$rootScope._isDownloading) {
                    $cordovaAppVersion.getVersionNumber().then(function (version) {
                        //版本参数
                        var parameter = {
                            version: version,
                            systemType: ionic.Platform.platform().toLowerCase() == 'android' ? "2" : "1",
                            platform: ionic.Platform.platform().toLowerCase(),
                            platfromVersion: ionic.Platform.version()
                        };
                        //检查更新
                        $PFHttpResource(RestFulURLConstants.appResource.checkVersion, parameter, null, {show: false})
                            .then(function (data) {
                                if (data.context.isLastVersion === 'N') {
                                    if (data.context.isForceUpdate === 'Y') {
                                        $rootScope._isShowUpdate = true;
                                        /*$ionicPopup.alert({
                                            title: "温馨提示",
                                            subTitle: "最新版本:" + data.context.version + ",当前版本：" + version,
                                            template: '有新版本了，快去更新吧！',
                                            okText: '确定',
                                            okType: 'button-panda'
                                        }).then(function (res) {
                                            $rootScope._isShowUpdate = false;
                                            updateAndroidAppOther(true, data.context.version);
                                        });*/
                                      var updateVersionPopup = function() {
                                        $ionicPopup.show({
                                          title: "温馨提示",
                                          subTitle: "最新版本:" + data.context.version + ",当前版本：" + version,
                                          template: '有新版本了，快去更新吧！',
                                          buttons: [{
                                            text: '确定',
                                            type: 'button-panda',
                                            onTap: function(e) {
                                              e.preventDefault();
                                              $rootScope._isShowUpdate = false;

                                              updateAndroidAppOther(true, data.context.version);
                                            }
                                          }]
                                        })
                                      };
                                      updateVersionPopup();

                                      $ionicPlatform.onHardwareBackButton(function(e) {
                                        e.preventDefault();
                                        updateVersionPopup();
                                       });
                                    } else {
                                        $rootScope._isShowUpdate = true;
                                        $ionicPopup.confirm({
                                            title: '温馨提示',
                                            subTitle: "最新版本:" + data.context.version + ",当前版本：" + version,
                                            template: '有新版本了，快去更新吧！',
                                            cancelText: '取消',
                                            okText: '确定',
                                            okType: 'button-panda'
                                        }).then(function (res) {
                                            $rootScope._isShowUpdate = false;
                                            if (res) {
                                                updateAndroidAppOther(false, data.context.version);
                                            }
                                            initHttpRequest();
                                        });
                                    }
                                } else {
                                    if (isSelfCheck) {
                                        $ionicPopup.alert({
                                            title: "温馨提示",
                                            subTitle: "最新版本:" + version + ",当前版本：" + version,
                                            template: '当前版本为最新版本！',
                                            okText: '知道了',
                                            okType: 'button-panda'
                                        })
                                    } else {
                                      initHttpRequest();
                                    }
                                }

                            }, function () {
                                $rootScope._isShowUpdate = false;
                                initHttpRequest();
                            });

                    });
                }

            }

            function updateAndroidAppOther(isForce, version) {

                $rootScope._isDownloading = true;
                $rootScope._isDownloading = false;

                var downloadUrl = RestFulURLConstants.appResource.downloadApp + "?systemType=" + ionic.Platform.platform();
                var openType = isForce ? "_self" : "_system";
                $cordovaInAppBrowser
                    .open(downloadUrl, "_system", {
                        location: 'yes',
                        clearcache: 'yes',
                        toolbar: 'no'
                    })
                    .then(function (event) {
                        $rootScope._isDownloading = false;
                    })
                    .catch(function (event) {
                        $rootScope._isDownloading = false;
                        $ionicPopup.alert({
                            title: "温馨提示",
                            template: '下载出现了问题，请重新再试！',
                            okText: '确定',
                            okType: 'button-panda'
                        });
                    });
            };

            function updateAndroidApp(isForce, version) {
                $rootScope._isDownloading = true;

                var downloadUrl = RestFulURLConstants.appResource.downloadApp;
                var fileDirectory = cordova.file.dataDirectory || cordova.file.externalDataDirectory;
                var fileName = "PandaFinance-" + (null != version ? version : new Date().getTime()) + ".apk";

                var $scope = $rootScope.$new();

                $scope.downloadProcess = 0;

                if (isForce) {
                    $ionicLoading.show({
                        templateUrl: "./templates/appUpdateProcess.html",
                        scope: $scope
                    });
                }

                $cordovaFileTransfer.download(downloadUrl, fileDirectory + fileName, {}, true).then(function (result) {

                    $ionicLoading.hide();

                    $cordovaFile.checkFile(fileDirectory, fileName)
                        .then(function (success) {
                            // 打开下载下来的APP
                            $cordovaFileOpener2.open(fileDirectory + fileName, 'application/vnd.android.package-archive')
                                .then(function (res) {
                                    $rootScope._isDownloading = false;
                                }, function (err) {
                                    $rootScope._isDownloading = false;
                                });
                        }, function (error) {
                            $rootScope._isDownloading = false;
                            alert("error" + JSON.stringify(error));
                        });

                }, function (err) {
                    $ionicPopup.alert({
                        title: "温馨提示",
                        template: '下载出现了问题，请重新再试！',
                        okText: '确定',
                        okType: 'button-panda'
                    }).then(function (res) {
                        $rootScope._isDownloading = false;
                    });
                }, function (progress) {
                    //下载进度
                    $timeout(function () {

                        if (progress.loaded == progress.total) {
                            $ionicLoading.hide();
                        }

                        $scope.downloadProcess = Math.round(parseFloat(progress.loaded / progress.total) * 100, 2);

                    })
                });
            };

            return {
                checkeApkUpdate: checkeApkUpdate
            };

        }])
    //谁写的不知道
    .factory('JudgmentSimplePwdService', ['$cordovaToast', 'UserInfoService', function ($cordovaToast, UserInfoService) {

        var _judgmentSimplePwd = function (_pwd, _idNo) {

            if (angular.isUndefined(_pwd)) {
                $cordovaToast.show('参数非法!', 'long', 'center');
                return false;
            }

            if (_pwd === '') {
                $cordovaToast.show('密码不能为空!', 'long', 'center');
                return false;
            }

            if (!/^\d{6}$/.test(_pwd)) {
                $cordovaToast.show('密码不是6位全数字!', 'long', 'center');   // 不是6位数字
                return false;
            }
            if (/^(\d)\1+$/.test(_pwd)) {
                $cordovaToast.show('交易密码过于简单!', 'long', 'center'); // 全一样
                return false;
            }

            if (/^(\d{2,3})\1+$/.test(_pwd)) {
              $cordovaToast.show('交易密码过于简单!', 'long', 'center'); // 两两,三三重复
              return false;
            }

            var preStr = _pwd.substr(0,3); //前三位
            preStr += preStr.split("").reverse().join("");//后三位

            if (preStr == _pwd) {
              $cordovaToast.show('交易密码过于简单!', 'long', 'center'); // abccba
              return false;
            }

            if(UserInfoService.isLogin()){
              var account = UserInfoService.getUserInfo().userAccount;
              if(account.indexOf(_pwd) > -1){
                $cordovaToast.show('交易密码不能为连续的手机号码!', 'long', 'center'); // 使用电话号码作为密码
                return false;
              }
            }

            if(_idNo && _idNo.length > 0){
              if(_idNo.indexOf(_pwd) > -1){
                $cordovaToast.show('交易密码不能为连续的证件号码!', 'long', 'center'); // 使用身份证号码作为密码
                return false;
              }
            }else{
            }

            var str = _pwd.replace(/\d/g, function ($0, pos) {
                return parseInt($0) - pos;
            });
            if (/^(\d)\1+$/.test(str)) {
                $cordovaToast.show('交易密码过于简单!', 'long', 'center');  // 顺增
                return false;
            }

            str = _pwd.replace(/\d/g, function ($0, pos) {
                return parseInt($0) + pos;
            });
            if (/^(\d)\1+$/.test(str)) {
                $cordovaToast.show('交易密码过于简单!', 'long', 'center');  // 顺减
                return false;
            }
            return true;
        }
        return {
            judgmentSimplePwd: function (pwd, idNo) {
                return _judgmentSimplePwd(pwd, idNo);
            }
        }
    }])
    //报文验证加密控制器
    .factory('SecurityHTTPRequestChannel', ['$rootScope', 'SecurityMessageChannel', '$cordovaToast', '$q', 'DevelopmentModeConstants', '$ionicPopup', 'UserInfoService', '$state', 'ChannelConstants',
        function ($rootScope, SecurityMessageChannel, $cordovaToast, $q, DevelopmentModeConstants, $ionicPopup, UserInfoService, $state, ChannelConstants) {

            //同意返回字符串
            function getHTTPRequestChannel() {

              var deferred = $q.defer();

              if(ChannelConstants.id === 25) { //熊猫金融
                if (navigator.request && navigator.request.startFirst) {

                  try {
                    document.addEventListener("deviceready", function () {
                      navigator.request.startFirst({
                        'success': function (result) {
                          deferred.resolve(result);
                        },
                        'error': function (err) {
                          deferred.reject(err);
                        },
                        'mills': {
                          'URL_PREFIX': encodeURIComponent(_RESTFUL_ENDPOINT_URL_),
                          'FIRST_URL': encodeURIComponent(SecurityMessageChannel.mykey),
                          'SECOND_URL': encodeURIComponent(SecurityMessageChannel.getKey),
                          'THIRD_URL': encodeURIComponent(SecurityMessageChannel.setKey),
                          'PUBLIC_URL': encodeURIComponent(SecurityMessageChannel.public),
                          'url': '',
                          'aes': DevelopmentModeConstants.aes,
                          'type': 'post',
                          'json': ''
                        }
                      });
                    });
                  } catch (e) {
                    deferred.reject("安全通道握手失败");
                  }

                } else {
                  deferred.reject("安全通道握手失败");
                }
              } else if(ChannelConstants.id === 26) { //马立可
                deferred.resolve({});
              }

                return deferred.promise;
            };

            function postHTTPRequest(url, data, deferred) {

                deferred = deferred || $q.defer();

                var dataPost = JSON.stringify(data || {});
                dataPost = dataPost.replace(/[\\]/g, '\\\\');
                dataPost = dataPost.replace(/["]/g, '\\"');

                try {
                    document.addEventListener("deviceready", function () {
                      if($rootScope.isShankhands){
                        if($rootScope.waitList && $rootScope.waitList.length > 0){
                          $rootScope.waitList.push({
                             url: url,
                             data: data,
                             deferred: deferred
                          });
                        }else{
                          $rootScope.waitList = [{
                             url: url,
                             data: data,
                             deferred: deferred
                          }];
                        }
                      }else{
                        if ($rootScope.IsSecurityHTTPRequestChannel || !DevelopmentModeConstants.aes) {
                          navigator.request.startRequest({
                             'success': function (result) {

                             deferred.resolve(result);
                             },
                             'error': function (err) {

                             deferred.reject(err);
                             },
                             'mills': {
                             'url': encodeURIComponent(url),
                             'type': 'post',
                             'json': encodeURIComponent(dataPost)
                             }
                          });
                        } else {
                          deferred.reject("安全通道加载失败");
                        }
                      }


                    }, false);
                } catch (e) {
                    deferred.reject("安全通道加载失败");
                }

                return deferred.promise;
            };

            function initHTTPRequestChannel() {
              if($rootScope.isShankhands){
                return;
              }
                $rootScope.isShankhands = true;
                getHTTPRequestChannel()
                    .then(function (result) {
                      $rootScope.isShankhands = false;
                      $rootScope.IsSecurityHTTPRequestChannel = true;
                      while($rootScope.waitList && $rootScope.waitList.length > 0){
                        var args = $rootScope.waitList.shift();
                        postHTTPRequest(args.url, args.data, args.deferred);
                      }
                    }, function (error) {
                        //$rootScope.IsSecurityHTTPRequestChannel = false;
                      while($rootScope.waitList && $rootScope.waitList.length > 0){
                        var args = $rootScope.waitList.shift();
                        args.deferred.reject('安全通道加载失败');
                      }
                      $rootScope.isShankhands = false;
                      initHTTPRequestChannelError(error);
                    });
            };

            function initHTTPRequestChannelError(error) {
              //template: error == 'shankhands failed' ? '安全通道加载失败' : '网络异常，请重试!',
                if(error == 'shankhands failed') {
                    /*$ionicPopup.confirm({
                        title: '警告',
                        template: '安全通道加载失败',
                        cancelText: '退出应用',
                        okText: '重试',
                        okType: 'button-panda'
                    }).then(function (res) {
                        if (res) {
                            initHTTPRequestChannel();
                        } else {
                            ionic.Platform.exitApp();
                        }
                    });*/
                    initHTTPRequestChannel();
                    UserInfoService.removeUserInfo();
                    $state.go('security.login', {hideBackButton: false, backTo: 'index'});
                } else {
                    initHTTPRequestChannel();
                    UserInfoService.removeUserInfo();
                    $state.go('security.login', {hideBackButton: false, backTo: 'index'});
                }
            };

            return {
                getHTTPRequestChannel: getHTTPRequestChannel,
                postHTTPRequest: postHTTPRequest,
                initHTTPRequestChannel: initHTTPRequestChannel,
                initHTTPRequestChannelAlert: initHTTPRequestChannelError
            };

        }])
    .factory('ViewSupportBank', ['$rootScope', '$PFHttpResource', 'RestFulURLConstants', '$q', '$ionicModal',
        function ($rootScope, $PFHttpResource, RestFulURLConstants, $q, $ionicModal) {
            var $scope = $rootScope.$new();

            $ionicModal.fromTemplateUrl("templates/viewSupportBank.html", {
                animation: "slide-in-right",
                scope: $scope
            }).then(function (modal) {
                $scope.modal = modal;
            });

            $scope.openModal = function () {
                $scope.modal.show();
            };

            $scope.closeModal = function () {
                $scope.modal.hide();
            };

            $scope.$on('$destroy', function () {
                $scope.modal.remove();
            });

            return function () {
                $PFHttpResource(RestFulURLConstants.publicService.getAllKabin)
                    .then(function (data) {
                        $scope.supportBanks = data.context.result;
                        $scope.openModal();
                    });
            };

        }])
    .factory('UserDataService',function(){
        return{
            userData:{}
        }
    })
    .factory('downloadFileService', [function() {
        function downloadImg(fileName, url) {
            var time = new Date().getTime();
            if(navigator.download && navigator.download.start) {
                navigator.download.start({
                    success: function(path) {
                    },
                    error: function(error) {
                    },
                    mills:{'url':encodeURIComponent(url),'type': time,'l':'1','fileName':fileName, 'cache': true}
                });
            }
        }
        return {
            downloadImg: downloadImg
        }
    }])
    .factory('loadingTextService', [function() {
        function getRandomTxt() {
            var txt =['不忘初心，方能始终', '心存善，水润物', '投资有风险，理财需谨慎', '不要把鸡蛋放在一个篮子里'];
            var randomNum = Math.floor(Math.random()*(txt.length));
            return txt[randomNum];
        }
        return {
            getRandomTxt:getRandomTxt
        }
    }])
    .factory('weixinService', ['$ionicPopup', function($ionicPopup) {
        function shareWebPage(obj) {
            if(typeof Wechat != "undefined"){
                Wechat.share({
                    message: {
                        title: obj.title,
                        description: obj.description,
                        thumb: obj.thumb,
                        media: {
                            type: obj.type,
                            webpageUrl: obj.webpageUrl
                        }
                    },
                    scene: obj.scene   // share to Timeline
                }, function () {
                    $ionicPopup.alert({
                            title: "提示",
                            template: "微信分享成功！",
                            okText: '知道了',
                            okType: 'button-panda'
                        }
                    );
                }, function (reason) {
                    $ionicPopup.alert({
                            title: "提示",
                            template: ("微信分享失败，" + reason +"。"),
                            okText: '知道了',
                            okType: 'button-panda'
                        }
                    );
                });
            }
        }
        return {
            shareWebPage: shareWebPage
        }
    }])
    .factory('MessageService', ['$rootScope', '$PFHttpResource', 'RestFulURLConstants', '$timeout',
      function($rootScope, $PFHttpResource, RestFulURLConstants, $timeout) {
        var res = {
          getUserMsgReadFlag: getUserMsgReadFlag,
          cancelGetUserMsgReadFlag: cancelGetUserMsgReadFlag,
          timerTimeout: null
        };
        return res;

        /*获取用户是否有未读消息*/
        function getUserMsgReadFlag() {
          $PFHttpResource(RestFulURLConstants.messageCenter.getUserMsgReadFlag, {}, null, {show: false})
            .then(function(data) {
              $rootScope.hasUnReadMessage = data.context.result;

              if(res.timerTimeout) {
                $timeout.cancel(res.timerTimeout);
                res.timerTimeout = null;
              }
              if(!$rootScope.hasUnReadMessage) {
                var minute = data.context.getPushMsgTime;
                /*循环获取是否有未读消息*/
                res.timerTimeout = $timeout(function() {
                  getUserMsgReadFlag();
                }, minute*1000*60);
              }
            }, function(error) {
            });
        }

        function cancelGetUserMsgReadFlag() {
          $rootScope.hasUnReadMessage = false;
          if(res.timerTimeout) {
            $timeout.cancel(res.timerTimeout);
            res.timerTimeout = null;
          }
        }

    }]);
