/**
 * Created by Z.JM on 2015/11/10.
 */

"use strict";
angular.module('pfApp').config(['$stateProvider', '$urlRouterProvider', '$ocLazyLoadProvider', 'RouterLevel', function ($stateProvider, $urlRouterProvider, $ocLazyLoadProvider, RouterLevel) {
    $stateProvider

    // setup an abstract state for the tabs directive
        .state('auction', {
            url: '/auction',
            abstract: true,
            resolve: $ocLazyLoadProvider.ocLazyLoadDependency('auctionModule', 'finance'),
            data: {
                $stateLevel: RouterLevel.ANY_ONE
            }
        })

        // Each tab has its own nav history stack:

        .state('auction.auctionList', {
            url: '/auctionList',
            views: {
                '@': {
                    templateUrl: 'modules/auction/templates/auctionList.html',
                    controller: 'AuctionListCtrl'
                }
            },
            data: {
                $stateLevel: RouterLevel.ANY_ONE
            }
        })
        .state('auction.auctionStartItem', {
            url: '/auctionStartItem',
            params: {
                auctionId: null,
                hasBackButton: true
            },
            views: {
                '@': {
                    templateUrl: 'modules/auction/templates/auctionStartItem.html',
                    controller: 'AuctionStartItemCtrl'
                }
            },
            data: {
                $stateLevel: RouterLevel.ANY_ONE
            }
        })
        .state('auction.auctionWaitItem', {
            url: '/auctionWaitItem',
            params: {
                auctionId: null
            },
            views: {
                '@': {
                    templateUrl: 'modules/auction/templates/auctionWaitItem.html',
                    controller: 'AuctionWaitItemCtrl'
                }
            },
            data: {
                $stateLevel: RouterLevel.ANY_ONE
            }
        })
        .state('auction.auctionRecord', {
            url: '/auctionRecord',
            params: {
                auctionId: null
            },
            views: {
                '@': {
                    templateUrl: 'modules/auction/templates/auctionRecord.html',
                    controller: 'AuctionRecordCtrl'
                }
            },
            data: {
                $stateLevel: RouterLevel.ANY_ONE
            }
        })
        .state('auction.auctionSelfList', {
            url: '/auctionSelfList',
            views: {
                '@': {
                    templateUrl: 'modules/auction/templates/auctionSelfList.html',
                    controller: 'AuctionSelfListCtrl'
                }
            },
            data: {
                $stateLevel: RouterLevel.ANY_ONE
            }
        })
        .state('auction.auctionPayItem', {
            url: '/auctionPayItem',
            params: {
                auctionId: null
            },
            views: {
                '@': {
                    templateUrl: 'modules/auction/templates/auctionPayItem.html',
                    controller: 'AuctionPayItemCtrl'
                }
            },
            data: {
                $stateLevel: RouterLevel.ANY_ONE
            }
        })
        .state('auction.auctionTransactionItem', {
            url: '/auctionTransactionItem',
            params: {
                auctionId: null
            },
            views: {
                '@': {
                    templateUrl: 'modules/auction/templates/auctionTransactionItem.html',
                    controller: 'AuctionTransactionItemCtrl'
                }
            },
            data: {
                $stateLevel: RouterLevel.ANY_ONE
            }
        })
        .state('auction.auctionDoPay', {
            url: '/auctionDoPay',
            params: {
                auctionId: null,
                price: null,
                goodsName: null,
                bidId: null
            },
            views: {
                '@': {
                    templateUrl: 'modules/auction/templates/auctionDoPay.html',
                    controller: 'AuctionDoPayCtrl'
                }
            },
            data: {
                $stateLevel: RouterLevel.ANY_ONE
            }
        })
        .state('auction.selectAddress', {
            url: '/selectAddress',
            views: {
                '@': {
                    templateUrl: 'modules/auction/templates/address/selectAddress.html',
                    controller: 'AuctionSelectAddressCtrl'
                }
            },
            data: {
                $stateLevel: RouterLevel.ANY_ONE
            }
        })
        .state('auction.doAuction', {
            url: '/doAuction',
            params: {
                auctionInfo: null,
                patAuctionTokenId: null
            },
            views: {
                '@': {
                    templateUrl: 'modules/auction/templates/doAuction.html',
                    controller: 'AuctionDoAuctionCtrl'
                }
            },
            data: {
                $stateLevel: RouterLevel.AUTHEN_USER
            }
        });


}]);
