/**
 * Created by Z.JM on 2015/11/10.
 */
;
"use strict";

angular.module('pfApp')
    .controller('AuctionListCtrl', ['$scope', '$state', '$stateParams', '$ionicHistory', '$ionicSlideBoxDelegate', '$PFHttpResource', 'RestFulURLConstants', '$interval', '$ionicModal', 'BaiduLocation', '$timeout', 'loadingTextService',
        function ($scope, $state, $stateParams, $ionicHistory, $ionicSlideBoxDelegate, $PFHttpResource, RestFulURLConstants, $interval, $ionicModal, BaiduLocation, $timeout, loadingTextService) {
        //拍拍乐列表数据
        $scope.auctionStartList = [];
        $scope.auctionWaitList = [];
        $scope.loadingTxt = loadingTextService.getRandomTxt();

        //选择城市
        $scope.locationList = [];

        //当前页面的类型
        $scope.auctionFlag = 0;

        //选择城市
        $scope.location = {name: '选择城市', code: ""};


        //第一次等待刷新 加载状态
        $scope.isShowLoadingOfWaitingAuction = true;
        $scope.isShowLoadingOfStartingAuction = true;
        //加载地域数据字典
        $scope.isShowLoadingOfLocationList = true;

        //手势状态联动-tabs2silde
        $scope.$watch("auctionFlag", function (value) {
            $ionicSlideBoxDelegate.slide(value);
        });

        //手势状态联动-silde2tabs
        $scope.auctionSlideChanged = function (index) {
            $scope.auctionFlag = index;
        };

        //定位
        $scope.getCurrentLocation = function () {
            $scope.baiduLocationIsEnd = false;
            BaiduLocation.getCityCode().then(function (location) {
                $scope.baiduLocationIsEnd = true;
                $scope.location.name = location.cityName;
                $scope.location.code = location.cityCode;
                BaiduLocation.close();
            }, function (error) {
                //定位失败，强制刷新列表
                $scope.baiduLocationIsEnd = true;
                $scope.getAuctionWaitingList();
                $scope.getAuctionStartingList();
                BaiduLocation.close();
            });
        };

        //选择城市模态框
        $ionicModal.fromTemplateUrl('modules/auction/templates/location/selectLocation.html', {
            scope: $scope,
            animation: 'slide-in-left'
        }).then(function (modal) {
            $scope.selectLocationModal = modal;
        });

        //关闭模态框
        $scope.closeSelectLocationModal = function (name) {
            if (name) {
                $scope.location.name = name;
            }
            $scope.selectLocationModal.hide();
        };

        $scope.$watch("location.code", function (value) {
            //如果改变的定位值为空，则不刷新列表
            if (null != value && value != "") {
                $scope.auctionStartList = [];
                $scope.auctionWaitList = [];
                $scope.getAuctionWaitingList();
                $scope.getAuctionStartingList();
            }
        });

        //获取可选的地域数据字典
        $scope.showChangeLocationModal = function () {
            $scope.selectLocationModal.show();
            $scope.getCityCodeList();
        };

        $scope.getCityCodeList = function () {
            if (null == $scope.locationList || $scope.locationList.length == 0) {
                $scope.isShowLoadingOfLocationList = true;
            }
            new $PFHttpResource(RestFulURLConstants.auction.getAuctionPositionCodeList, {}, null, {show: false}).then(function (data) {
                $scope.locationList = data.context.codes;
                $scope.isShowLoadingOfLocationList = false;
            }, function (error) {
                $scope.isShowLoadingOfLocationList = false;
            });
        };

        //获取即将开始列表信息
        $scope.getAuctionWaitingList = function () {
            if (null == $scope.auctionWaitList || $scope.auctionWaitList.length === 0) {
                $scope.isShowLoadingOfWaitingAuction = true;
            }
            new $PFHttpResource(RestFulURLConstants.auction.getAuctionWaitingList, {goodsArea: $scope.location.code}, null, {show: false}).then(function (data) {
                $scope.isShowLoadingOfWaitingAuction = false;
                $scope.auctionWaitList = data.context.auctionInfos;
            }, function (error) {
                $scope.isShowLoadingOfWaitingAuction = false;
            });
        };

        //获取已经开始列表信息
        $scope.getAuctionStartingList = function () {
            if (null == $scope.auctionStartList || $scope.auctionStartList.length === 0) {
                $scope.isShowLoadingOfStartingAuction = true;
            }
            new $PFHttpResource(RestFulURLConstants.auction.getAuctionStartingList, {goodsArea: $scope.location.code}, null, {show: false}).then(function (data) {
                $scope.isShowLoadingOfStartingAuction = false;
                $scope.auctionStartList = data.context.auctionInfos;
            }, function (error) {
                $scope.isShowLoadingOfStartingAuction = false;
            });
        };

        //刷新节选的定位数据字典
        $scope.doRefreshLocationModal = function () {
            new $PFHttpResource(RestFulURLConstants.auction.getAuctionPositionCodeList, {}, null, {show: false}).then(function (data) {
                $scope.locationList = data.context.codes;
                $scope.$broadcast('scroll.refreshComplete');
            }, function (error) {
                $scope.$broadcast('scroll.refreshComplete');
            });
        };

        //下拉刷新 上提示刷新
        $scope.doRefreshAuctionWaitingList = function () {

            new $PFHttpResource(RestFulURLConstants.auction.getAuctionWaitingList, {goodsArea: $scope.location.code}, null, {show: false}).then(function (data) {
                $scope.auctionWaitList = data.context.auctionInfos;
                $scope.$broadcast('scroll.refreshComplete');
                $timeout(function() {
                    $scope.loadingTxt = loadingTextService.getRandomTxt();
                }, 1500);
            }, function (error) {
                $scope.$broadcast('scroll.refreshComplete');
                $timeout(function() {
                    $scope.loadingTxt = loadingTextService.getRandomTxt();
                }, 1500);
            });
        };
        //下拉刷新 上提示刷新
        $scope.doRefreshAuctionStartingList = function () {

            new $PFHttpResource(RestFulURLConstants.auction.getAuctionStartingList, {goodsArea: $scope.location.code}, null, {show: false}).then(function (data) {
                $scope.auctionStartList = data.context.auctionInfos;
                $scope.$broadcast('scroll.refreshComplete');
                $timeout(function() {
                    $scope.loadingTxt = loadingTextService.getRandomTxt();
                }, 1000);
            }, function (error) {
                $scope.$broadcast('scroll.refreshComplete');
                $timeout(function() {
                 $scope.loadingTxt = loadingTextService.getRandomTxt();
                 }, 1000);
            });
        };

        //定时出刷新 5分钟自动刷新一次 静默刷新
        $scope.loadInterval = $interval(function () {
            //如果是浏览当前页面
            $scope.getAuctionWaitingList();
            $scope.getAuctionStartingList();
        }, 5 * 60 * 1000);

        //销毁资源
        $scope.$on('$destroy', function () {
            $scope.selectLocationModal.remove();
            $interval.cancel($scope.loadInterval);
        });

        //默认第一次等位10秒
        if (null == $scope.location.code || '' == $scope.location.code) {
            $scope.getCurrentLocation();
            //若定位时间过长，则直接加载列表数据
            $timeout(function () {
                //已经超出控制时间范围，并且还在持续定位
                if (!$scope.baiduLocationIsEnd) {
                    $scope.getAuctionWaitingList();
                    $scope.getAuctionStartingList();
                }
            }, 10 * 1000);
        }

        //进入后触发 第一次等待刷新 之后静默刷新
        //$scope.$on("$ionicView.afterEnter", function (event) {
        //    //如果之前定位失败，或者未定位，则再定位一次
        //    if (null == $scope.location.code || '' == $scope.location.code) {
        //        $scope.getCurrentLocation();
        //        //若定位时间过长，则直接加载列表数据
        //        $timeout(function () {
        //            //已经超出控制时间范围，并且还在持续定位
        //            if (!$scope.baiduLocationIsEnd) {
        //                $scope.getAuctionWaitingList();
        //                $scope.getAuctionStartingList();
        //            }
        //        }, 10 * 1000);
        //    } else {
        //        //如果之前定位成功，或者已经选择过确认城市，则静默更新数据
        //        $scope.getAuctionWaitingList();
        //        $scope.getAuctionStartingList();
        //    }
        //});

    }])
    .controller('AuctionStartItemCtrl', ['$scope', '$state', '$stateParams', '$ionicHistory', '$ionicSlideBoxDelegate', '$PFHttpResource', 'RestFulURLConstants', '$ionicPopup', '$filter', 'UserInfoService', function ($scope, $state, $stateParams, $ionicHistory, $ionicSlideBoxDelegate, $PFHttpResource, RestFulURLConstants, $ionicPopup, $filter, UserInfoService) {
        $scope.hasBackButton = $stateParams.hasBackButton;
        $scope.auctionInfo = null;
        $scope.auctionProductAttributes = [];
        $scope.auctionRecords = [];

        $scope.slideImages = null;

        $scope.showBond = function () {
            $ionicPopup.alert({
                    title: "提示",
                    template: "<div style='font-size: 10px;'>根据竞价规则，您竞拍之后会冻结商品市场价的" + $scope.auctionInfo.depositRatio + "%作为保证金，竞拍完成后会解除冻结。</div>" + "<div style='font-size: 16px;font-weight: '>" + $filter('currency')($scope.auctionInfo.goodsUnitPrice, "") + " x " + $scope.auctionInfo.depositRatio + "% = " + $filter('currency')(Math.round(parseFloat($scope.auctionInfo.goodsUnitPrice * $scope.auctionInfo.depositRatio), "") / 100,
                        "") + "元</div>",
                    okText: '知道了',
                    okType: 'button-panda'
                }
            );
        };

        function loadAuctionInfo() {
            //search AuctionInfo by auctionId
            new $PFHttpResource(RestFulURLConstants.auction.getAuctionInfo, {auctionId: $state.params.auctionId})
                .then(function (data) {
                    if (null == $scope.slideImages) {
                        $scope.slideImages = data.context.auctionInfo.imgs;
                    }
                    $scope.auctionInfo = data.context.auctionInfo;
                    $scope.patAuctionTokenId = data.context.patAuctionTokenId;
                    if (data.context.auctionInfo.goodsAtrb && data.context.auctionInfo.goodsAtrb !== '') {
                        $scope.auctionProductAttributes = [];

                        angular.forEach(data.context.auctionInfo.goodsAtrb.split(";"), function (value) {
                            if (value && value !== '') {
                                $scope.auctionProductAttributes.push(value.split(":"));
                            }
                        });
                    }
                });

            //search the AuctionRecordList by auctionId
            new $PFHttpResource(RestFulURLConstants.auction.getAuctionRecordList, {auctionId: $state.params.auctionId})
                .then(function (data) {
                    $scope.auctionRecords = data.context;
                });
        };

        loadAuctionInfo();

        $scope.doAuction = function () {
            $state.go('auction.doAuction', {
                auctionInfo: $scope.auctionInfo,
                patAuctionTokenId: $scope.patAuctionTokenId
            });
        };

    }])
    .controller('AuctionWaitItemCtrl', ['$scope', '$state', '$stateParams', '$ionicHistory', '$ionicSlideBoxDelegate', '$PFHttpResource', 'RestFulURLConstants', function ($scope, $state, $stateParams, $ionicHistory, $ionicSlideBoxDelegate, $PFHttpResource, RestFulURLConstants) {

        $scope.auctionInfo = null;
        $scope.auctionProductAttributes = [];

        new $PFHttpResource(RestFulURLConstants.auction.getAuctionInfo, {auctionId: $state.params.auctionId})
            .then(function (data) {
                $scope.auctionInfo = data.context.auctionInfo;
                if (data.context.auctionInfo.goodsAtrb && data.context.auctionInfo.goodsAtrb !== '') {
                    $scope.auctionProductAttributes = [];
                    angular.forEach(data.context.auctionInfo.goodsAtrb.split(";"), function (value) {
                        if (value && value !== '') {
                            $scope.auctionProductAttributes.push(value.split(":"));
                        }
                    });
                }
            });

    }])
    .controller('AuctionRecordCtrl', ['$scope', '$state', '$stateParams', '$ionicHistory', '$ionicSlideBoxDelegate', '$PFHttpResource', 'RestFulURLConstants', function ($scope, $state, $stateParams, $ionicHistory, $ionicSlideBoxDelegate, $PFHttpResource, RestFulURLConstants) {

        $scope.auctionRecords = [];
        $scope.isShowLoadingOfAuctionRecordList = true;


        //获取已经开始列表信息
        $scope.getAuctionStartingList = function () {
            if (null == $scope.auctionRecords || null == $scope.auctionRecords.bidRecords || $scope.auctionRecords.bidRecords.length === 0) {
                $scope.isShowLoadingOfAuctionRecordList = true;
            }
            new $PFHttpResource(RestFulURLConstants.auction.getAuctionRecordList, {auctionId: $state.params.auctionId}, null, {show: false}).then(function (data) {
                $scope.isShowLoadingOfAuctionRecordList = false;
                $scope.auctionRecords = data.context;
            }, function (error) {
                $scope.isShowLoadingOfAuctionRecordList = false;
            });

        };

        //下拉刷新 上提示刷新
        $scope.doRefreshAuctionStartingList = function () {

            new $PFHttpResource(RestFulURLConstants.auction.getAuctionRecordList, {auctionId: $state.params.auctionId}, null, {show: false}).then(function (data) {
                $scope.$broadcast('scroll.refreshComplete');
                $scope.auctionRecords = data.context;
            }, function (error) {
                $scope.$broadcast('scroll.refreshComplete');
            });
        };


        $scope.$on("$ionicView.afterEnter", function (event) {
            $scope.getAuctionStartingList();
        });

    }])
    .controller('AuctionSelfListCtrl', ['$scope', '$state', '$stateParams', '$ionicHistory', '$ionicSlideBoxDelegate', '$PFHttpResource', 'RestFulURLConstants', '$interval', 'loadingTextService', '$timeout',
        function ($scope, $state, $stateParams, $ionicHistory, $ionicSlideBoxDelegate, $PFHttpResource, RestFulURLConstants, $interval, loadingTextService, $timeout) {
        $scope.auctionFlag = 0;
        $scope.auctionSelfOngoingList = [];
        $scope.auctionSelfSuccessList = [];
        $scope.auctionSelfConfirmedList = [];
        $scope.loadingTxt = loadingTextService.getRandomTxt();

        //第一次等待刷新 加载状态
        $scope.isShowLoadingOfOngoingList = true;
        $scope.isShowLoadingOfSuccessList = true;
        $scope.isShowLoadingOfConfirmedList = true;


        //手势互动
        $scope.$watch("auctionFlag", function (value) {
            $ionicSlideBoxDelegate.slide(value);
        });
        //手势互动

        $scope.auctionSlideChanged = function (index) {
            $scope.auctionFlag = index;
        };

        //获取getMyOngoingAuctions列表信息
        $scope.getMyOngoingAuctions = function () {
            if (null == $scope.auctionSelfOngoingList || $scope.auctionSelfOngoingList.length === 0) {
                $scope.isShowLoadingOfOngoingList = true;
            }
            new $PFHttpResource(RestFulURLConstants.auction.getMyOngoingAuctions, {}, null, {show: false}).then(function (data) {
                $scope.isShowLoadingOfOngoingList = false;
                $scope.auctionSelfOngoingList = data.context.bidRecords;
            }, function (error) {
                $scope.isShowLoadingOfOngoingList = false;
            });
        };

        //获取getMySuccessAuctions列表信息
        $scope.getMySuccessAuctions = function () {
            if (null == $scope.auctionSelfSuccessList || $scope.auctionSelfSuccessList.length === 0) {
                $scope.isShowLoadingOfSuccessList = true;
            }
            new $PFHttpResource(RestFulURLConstants.auction.getMySuccessAuctions, {}, null, {show: false}).then(function (data) {
                $scope.isShowLoadingOfSuccessList = false;
                $scope.auctionSelfSuccessList = data.context.bidRecords;
            }, function (error) {
                $scope.isShowLoadingOfSuccessList = false;
            });
        };

        //获取getMyOngoingAuctions列表信息
        $scope.getMyConfirmedAuctions = function () {
            if (null == $scope.auctionSelfOngoingList || $scope.auctionSelfOngoingList.length === 0) {
                $scope.isShowLoadingOfConfirmedList = true;
            }
            new $PFHttpResource(RestFulURLConstants.auction.getMyConfirmedAuctions, {}, null, {show: false}).then(function (data) {
                $scope.isShowLoadingOfConfirmedList = false;
                $scope.auctionSelfConfirmedList = data.context.bidRecords;
            }, function (error) {
                $scope.isShowLoadingOfConfirmedList = false;
            });
        };

        //下拉刷新 上提示刷新 getMyOngoingAuctions
        $scope.doRefreshMyOngoingAuctions = function () {
            new $PFHttpResource(RestFulURLConstants.auction.getMyOngoingAuctions, {}, null, {show: false}).then(function (data) {
                $scope.$broadcast('scroll.refreshComplete');
                $scope.auctionSelfOngoingList = data.context.bidRecords;
                $timeout(function() {
                    $scope.loadingTxt = loadingTextService.getRandomTxt();
                }, 1500);
            }, function (error) {
                $scope.$broadcast('scroll.refreshComplete');
                $timeout(function() {
                    $scope.loadingTxt = loadingTextService.getRandomTxt();
                }, 1500);
            });
        };

        //下拉刷新 上提示刷新
        $scope.doRefreshMySuccessAuctions = function () {
            new $PFHttpResource(RestFulURLConstants.auction.getMySuccessAuctions, {}, null, {show: false}).then(function (data) {
                $scope.$broadcast('scroll.refreshComplete');
                $scope.auctionSelfSuccessList = data.context.bidRecords;
                $timeout(function() {
                    $scope.loadingTxt = loadingTextService.getRandomTxt();
                }, 1500);
            }, function (error) {
                $scope.$broadcast('scroll.refreshComplete');
                $timeout(function() {
                    $scope.loadingTxt = loadingTextService.getRandomTxt();
                }, 1500);
            });
        };

        //下拉刷新 上提示刷新
        $scope.doRefreshMyConfirmedAuctions = function () {
            new $PFHttpResource(RestFulURLConstants.auction.getMyConfirmedAuctions, {}, null, {show: false}).then(function (data) {
                $scope.$broadcast('scroll.refreshComplete');
                $scope.auctionSelfConfirmedList = data.context.bidRecords;
                $timeout(function() {
                    $scope.loadingTxt = loadingTextService.getRandomTxt();
                }, 1500);
            }, function (error) {
                $scope.$broadcast('scroll.refreshComplete');
                $timeout(function() {
                    $scope.loadingTxt = loadingTextService.getRandomTxt();
                }, 1500);
            });
        };

        //5分钟自动刷新
        $scope.loadInterval = $interval(function () {
            $scope.getMyOngoingAuctions();
            $scope.getMySuccessAuctions();
            $scope.getMyConfirmedAuctions();
        }, 5 * 60 * 1000);

        //销毁资源
        $scope.$on('$destroy', function () {
            $interval.cancel($scope.loadInterval);
        });

        //进入后触发 第一次等待刷新 之后静默刷新
        $scope.$on("$ionicView.afterEnter", function (event) {
            $scope.getMyOngoingAuctions();
            $scope.getMySuccessAuctions();
            $scope.getMyConfirmedAuctions();
        });

    }])
    .controller('AuctionPayItemCtrl', ['$scope', '$state', '$stateParams', '$ionicHistory', '$ionicSlideBoxDelegate', '$PFHttpResource', 'RestFulURLConstants', function ($scope, $state, $stateParams, $ionicHistory, $ionicSlideBoxDelegate, $PFHttpResource, RestFulURLConstants) {

        $scope.auctionInfo = null;
        $scope.auctionProductAttributes = [];
        $scope.auctionRecords = [];

        new $PFHttpResource(RestFulURLConstants.auction.getMyAuction, {auctionId: $state.params.auctionId})
            .then(function (data) {
                $scope.auctionInfo = data.context.myAuction;
                if (data.context.myAuction.goodsAtrb && data.context.myAuction.goodsAtrb !== '') {
                    $scope.auctionProductAttributes = [];
                    angular.forEach(data.context.myAuction.goodsAtrb.split(";"), function (value) {
                        if (value && value !== '') {
                            $scope.auctionProductAttributes.push(value.split(":"));
                        }
                    });
                }
            });

        new $PFHttpResource(RestFulURLConstants.auction.getAuctionRecordList, {auctionId: $state.params.auctionId})
            .then(function (data) {
                $scope.auctionRecords = data.context;
            });
    }])
    .controller('AuctionTransactionItemCtrl', ['$scope', '$state', '$stateParams', '$ionicHistory', '$ionicSlideBoxDelegate', '$PFHttpResource', 'RestFulURLConstants', function ($scope, $state, $stateParams, $ionicHistory, $ionicSlideBoxDelegate, $PFHttpResource, RestFulURLConstants) {
        $scope.auctionInfo = null;
        $scope.auctionProductAttributes = [];
        $scope.auctionRecords = [];
        new $PFHttpResource(RestFulURLConstants.auction.getMyConfirmed, {auctionId: $state.params.auctionId})
            .then(function (data) {
                $scope.auctionInfo = data.context.myConfirmed;
                if (data.context.myConfirmed.goodsAtrb && data.context.myConfirmed.goodsAtrb !== '') {
                    $scope.auctionProductAttributes = [];
                    angular.forEach(data.context.myConfirmed.goodsAtrb.split(";"), function (value) {
                        if (value && value !== '') {
                            $scope.auctionProductAttributes.push(value.split(":"));
                        }
                    });
                }
            });

        new $PFHttpResource(RestFulURLConstants.auction.getAuctionRecordList, {auctionId: $state.params.auctionId})
            .then(function (data) {
                $scope.auctionRecords = data.context;
            });

    }])
    .controller('AuctionDoPayCtrl', ['$scope', '$state', '$stateParams', '$ionicHistory', '$ionicSlideBoxDelegate', '$PFHttpResource', 'RestFulURLConstants', '$ionicPopup', '$filter', '$ionicModal', 'EncodePassword', '$transactionPassword', 'UserInfoService', '$cordovaToast', 'BusinessConfirmModal', function ($scope, $state, $stateParams, $ionicHistory, $ionicSlideBoxDelegate, $PFHttpResource, RestFulURLConstants, $ionicPopup, $filter, $ionicModal, EncodePassword, $transactionPassword, UserInfoService, $cordovaToast, BusinessConfirmModal) {
        $scope.price = $state.params.price;
        $scope.goodsName = $state.params.goodsName;
        $scope.availavleAmount = 0.00;

        //地址相关
        $scope.addressList = [];
        $scope.address = {};
        $scope.choiceAddress = {};
        $scope.choiceAddress.oid = null;


        $scope.doPay = function () {

            if (!$scope.address || !$scope.address.oid) {
                $ionicPopup.alert({
                    title: "温馨提示",
                    template: "收货地址不能为空",
                    okText: '确定',
                    okType: 'button-panda'
                }).then(function () {
                });
                return;
            }

            if ($scope.price > $scope.availavleAmount) {
                $ionicPopup.confirm({
                    title: '温馨提示',
                    template: '电子账户可用余额不足，去充值？',
                    cancelText: '取消',
                    okText: '确定',
                    okType: 'button-panda'
                }).then(function (res) {
                    if (res) {
                        $state.go("financeCenter.recharge");
                    }
                });
                return;
            }

            $scope.confirmTransamount = $scope.price;

            $transactionPassword({scope: $scope}).then(function (password) {
                EncodePassword.encrypt("11", password).then(function (superPassword) {
                    var payParameters = angular.extend({
                        trandPassWord: superPassword,
                        auctionId: $state.params.auctionId,
                        bidId: $state.params.bidId,
                        addId: $scope.address.oid
                    }, $scope.address);
                    $PFHttpResource(RestFulURLConstants.auction.payOrder, payParameters).then(function (data) {
                        BusinessConfirmModal({
                            scope: $scope,
                            type: "success",
                            header: "购买成功",
                            title: "交易成功",
                            subTitle: "<b>支付:</b>" + $scope.goodsName,
                            message: "您已成功支付" + $scope.goodsName + ",价格:" + $filter('currency')($scope.price, "￥"),
                        }).then(function (result) {
                            $ionicHistory.goBack(-2);
                        });
                    });
                }, function () {
                    $cordovaToast.show("交易失败", 'long', 'center');
                });
            }, function (error) {
            }, function (notify) {
            });
        };

        $ionicModal.fromTemplateUrl('modules/auction/templates/address/selectAddressModal.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function (modal) {
            $scope.modal = modal;
        });

        $scope.closeSelectAddressModal = function () {
            $scope.modal.hide();
        };
        $scope.$on('$destroy', function () {
            $scope.modal.remove();
        });

        $scope.$watch("choiceAddress.oid", function (value) {
            angular.forEach($scope.addressList, function (address) {
                if (address.oid === value) {
                    $scope.address = address;
                }
            });
        });

        $scope.selectAddress = function () {
            $scope.modal.show();
        };

        $scope.addContactUserAddress = function () {
          $scope.closeSelectAddressModal();
          $state.go("personCenter.addressEdit", {"address": ''});
        };

        $scope.$on("$ionicView.beforeEnter", function (event) {
            $scope.price = $state.params.price;
            $scope.goodsName = $state.params.goodsName;

            $PFHttpResource(RestFulURLConstants.finance.assets.queryOnlyElectronicAccount, {}).then(function (data) {
                $scope.availavleAmount = data.context.result.acctAmount.availBal;
            }, function (error) {
                $ionicPopup.alert({
                    title: "温馨提示",
                    template: "查询余额失败",
                    okText: '确定',
                    okType: 'button-panda'
                }).then(function () {
                    $ionicHistory.goBack();
                });
            });

            new $PFHttpResource(RestFulURLConstants.personCenter.queryUserContactAddress).then(function (data) {
                $scope.addressList = data.context.result;
                angular.forEach($scope.addressList, function (address) {
                    if (address.isDefault == 'Y') {
                        $scope.address = address;
                        $scope.choiceAddress.oid = address.oid;
                    }
                });

                if (null == $scope.choiceAddress.oid || "" == $scope.choiceAddress.oid) {
                    if ($scope.addressList && $scope.addressList.length > 0) {
                        $scope.address = $scope.addressList[0];
                        $scope.choiceAddress.oid = $scope.addressList[0].oid;
                    }
                }

            });

        });

    }])
    .controller('AuctionDoAuctionCtrl', ['$interval', '$ionicPopup', '$scope', '$state', '$stateParams', '$ionicHistory', '$PFHttpResource', 'RestFulURLConstants', '$filter', 'UserInfoService', '$cordovaToast', 'BusinessConfirmModal',
        function ($interval, $ionicPopup, $scope, $state, $stateParams, $ionicHistory, $PFHttpResource, RestFulURLConstants, $filter, UserInfoService, $cordovaToast, BusinessConfirmModal) {

            $scope.auctionInfo = {};
            $scope.deposit = 0;

            $scope.$watch('auction.auctionPrice', function (value) {
                if (parseFloat(value) > parseFloat($scope.auctionInfo.currentPrice) + parseFloat($scope.auction.increaseRange)) {
                    $scope.decreaseDisabled = false;
                } else {
                    $scope.decreaseDisabled = true;
                }

                if (parseFloat(value) < parseFloat($scope.auctionInfo.fixedPrice || "10000.00")) {
                    $scope.increaseDisabled = false;
                } else {
                    $scope.increaseDisabled = true;
                }
            });

            $scope.decrease = function () {

                if (parseFloat($scope.auction.auctionPrice, 2) > parseFloat($scope.auctionInfo.fixedPrice || "10000", 2)) {
                    $scope.auction.auctionPrice = parseFloat($scope.auctionInfo.fixedPrice || "10000", 2);
                } else {
                    if (!!!$scope.auction.auctionPrice) {
                        $scope.auction.auctionPrice = 0;
                    }
                    if (parseFloat($scope.auction.auctionPrice) - parseFloat($scope.auction.increaseRange) < parseFloat($scope.auctionInfo.currentPrice) + parseFloat($scope.auction.increaseRange)) {
                        $scope.auction.auctionPrice = parseFloat($scope.auctionInfo.currentPrice) + parseFloat($scope.auction.increaseRange);
                        return false;
                    } else {
                        $scope.auction.auctionPrice = parseFloat($scope.auction.auctionPrice) - parseFloat($scope.auction.increaseRange);
                    }
                }

                return true;

            };

            $scope.decreaseInterval = null;
            $scope.onDecreaseHold = function () {
                $scope.decreaseInterval = $interval(function () {
                    if (!$scope.decrease()) {
                        $scope.onDecreaseRelease();
                    }
                }, 100);
            };
            $scope.onDecreaseRelease = function () {
                $interval.cancel($scope.decreaseInterval);
            };


            $scope.increase = function () {
                if (parseFloat($scope.auction.auctionPrice, 2) < parseFloat($scope.auctionInfo.currentPrice + $scope.auction.increaseRange, 2)) {
                    $scope.auction.auctionPrice = parseFloat($scope.auctionInfo.currentPrice + $scope.auction.increaseRange, 2);
                } else {
                    if (!!!$scope.auction.auctionPrice) {
                        $scope.auction.auctionPrice = 0;
                    }
                    if (parseFloat($scope.auction.auctionPrice) + parseFloat($scope.auction.increaseRange) > parseFloat($scope.auctionInfo.fixedPrice || "10000.00")) {
                        $scope.auction.auctionPrice = parseFloat($scope.auctionInfo.fixedPrice || "10000.00");
                        return false;
                    } else {
                        $scope.auction.auctionPrice = parseFloat($scope.auction.auctionPrice) + parseFloat($scope.auction.increaseRange);
                    }
                }

                return true;
            };

            $scope.increaseInterval = null;
            $scope.onIncreaseHold = function () {
                $scope.increaseInterval = $interval(function () {
                    if (!$scope.increase()) {
                        $scope.onIncreaseRelease();
                    }
                }, 100);
            };

            $scope.onIncreaseRelease = function () {
                $interval.cancel($scope.increaseInterval);
            };

            $scope.doAuction = function () {

                if (parseFloat($scope.auction.auctionPrice, 2) < parseFloat($scope.auctionInfo.currentPrice + $scope.auction.increaseRange, 2)) {
                    $ionicPopup.alert({
                        title: "温馨提示",
                        template: "竞拍价格幅度不能小于出价幅度（" + parseFloat($scope.auctionInfo.currentPrice + $scope.auction.increaseRange, 2) + "元）。",
                        okText: '确定',
                        okType: 'button-panda'
                    })
                    return;
                }

                if (parseFloat($scope.auction.auctionPrice, 2) > parseFloat($scope.auctionInfo.fixedPrice || "10000", 2)) {
                    $ionicPopup.alert({
                        title: "温馨提示",
                        template: "不能超过最大限额（" + parseFloat($scope.auctionInfo.fixedPrice || "10000", 2) + "元）。",
                        okText: '确定',
                        okType: 'button-panda'
                    })
                    return;
                }

                if ($scope.isFirst == 'Y' && parseFloat($scope.deposit, 2) > parseFloat($scope.availavleAmount)) {

                    $ionicPopup.confirm({
                        title: '温馨提示',
                        template: '电子账户可用余额不足保证金，去充值？',
                        cancelText: '取消',
                        okText: '确定',
                        okType: 'button-panda'
                    }).then(function (res) {
                        if (res) {
                            $state.go("financeCenter.recharge");
                        }
                    });

                    return;
                }

                new $PFHttpResource(RestFulURLConstants.auction.doAuction, {
                    patAuctionTokenId: CryptoJS.MD5($scope.patAuctionTokenId + parseFloat($scope.auction.auctionPrice, 2)).toString(),
                    auctionId: $scope.auctionInfo.oid,
                    bidPrice: parseFloat($scope.auction.auctionPrice, 2)
                }).then(function (data) {
                    BusinessConfirmModal({
                        scope: $scope,
                        type: "success",
                        header: "竞价成功",
                        title: "竞价成功",
                        subTitle: "<b>冻结保证金:</b>" + $filter('currency')(data.context.deposit, "￥"),
                        message: "您已成功竞价" + $scope.auctionInfo.goodsName + ",价格:" + $filter('currency')($scope.auction.auctionPrice, "￥"),
                    }).then(function (result) {
                        //$ionicHistory.goBack(-2);
                        $state.go("tab.auctionList");
                    });
                });
            };

            $scope.$on("$ionicView.beforeEnter", function (event) {

                $scope.auctionInfo = $stateParams.auctionInfo;
                $scope.patAuctionTokenId = $stateParams.patAuctionTokenId;
                $scope.auction = {};

                $scope.decreaseDisabled = false;
                $scope.increaseDisabled = false;

                $scope.deposit = Math.round(parseFloat($scope.auctionInfo.goodsUnitPrice * $scope.auctionInfo.depositRatio || 10)) / 100;
                $scope.auction.auctionPrice = $scope.auctionInfo.currentPrice + $scope.auctionInfo.increaseRange;
                $scope.auction.increaseRange = $scope.auctionInfo.increaseRange ? $scope.auctionInfo.increaseRange : 1;
            });

            //查询电子账户余额
            function queryElectronicAccount(){
              $PFHttpResource(RestFulURLConstants.auction.doBiddingCheck, {auctionId: $stateParams.auctionInfo.oid}).then(function (data) {
                $scope.isFirst = data.context.result.isFirst;
                $scope.availavleAmount = data.context.result.availBal || null;
                //$scope.availavleAmount = data.context.result.acctAmount.availBal;
              }, function (error) {
                $ionicPopup.alert({
                  title: "温馨提示",
                  template: "查询余额失败",
                  okText: '确定',
                  okType: 'button-panda'
                }).then(function () {
                  $ionicHistory.goBack();
                });
              });
            }
            //首次竞拍后不再查询余额
            queryElectronicAccount();

        }]);





