/**
 * Created by Z.ZR on 2015/11/10.
 */

"use strict";
angular.module('pfApp')
    .config(['$stateProvider', '$urlRouterProvider', '$ocLazyLoadProvider', 'RouterLevel',
        function ($stateProvider, $urlRouterProvider, $ocLazyLoadProvider, RouterLevel) {

            $stateProvider
                .state('electronicBill', {
                    url: '/electronicBill',
                    abstract: true,
                    resolve: $ocLazyLoadProvider.ocLazyLoadDependency('electronicBillModule', 'finance'),
                    data: {
                        $stateLevel: RouterLevel.ANY_ONE
                    }
                })

                .state('electronicBill.electronicBillProduct', {
                    url: '/electronicBillProduct',
                    params: {
                        fromName: '首页',
                        from: "tab.home",
                        projectCode: null,
                        projectName: null
                    },
                    cache: false,
                    views: {
                        '@': {
                            templateUrl: 'modules/electronicBill/templates/electronicBillProduct.html',
                            controller: 'ElectronicBillProductCtrl'
                        }
                    },
                    data: {
                        $stateLevel: RouterLevel.ANY_ONE
                    }
                })


                .state('electronicBill.productDescription', {
                    url: '/electronicBillProductDescription',
                    params: {
                        product: null
                    },
                    cache: false,
                    views: {
                        '@': {
                            templateUrl: 'modules/electronicBill/templates/productDescription.html',
                            controller: 'ElectronicBillProductDescriptionCtrl'
                        }
                    },
                    data: {
                        $stateLevel: RouterLevel.ANY_ONE
                    }
                })

                .state('electronicBill.purchaseDetails', {
                    url: '/electronicBillPurchaseDetails',
                    params: {
                        product: {}
                    },
                    cache: false,
                    views: {
                        '@': {
                            templateUrl: 'modules/electronicBill/templates/purchaseDetails.html',
                            controller: 'ElectronicBillPurchaseDetailsCtrl'
                        }
                    },
                    data: {
                        $stateLevel: RouterLevel.ANY_ONE
                    }
                })

                .state('electronicBill.purchaseHistory', {
                    url: '/electronicBillPurchaseHistory',
                    params: {
                        projectCode: null
                    },
                    cache: false,
                    views: {
                        '@': {
                            templateUrl: 'modules/electronicBill/templates/purchaseHistory.html',
                            controller: 'ElectronicBillPurchaseHistoryCtrl'
                        }
                    },
                    data: {
                        $stateLevel: RouterLevel.ANY_ONE
                    }
                })


                .state('electronicBill.productPurchase', {
                    url: '/electronicBillProductPurchase',
                    params: {
                        from: "tab.home",
                        product: {}
                    },
                    cache: false,
                    views: {
                        '@': {
                            templateUrl: 'modules/electronicBill/templates/productPurchase.html',
                            controller: 'ElectronicBillProductPurchaseCtrl'
                        }
                    },
                    data: {
                        $stateLevel: RouterLevel.AUTHEN_USER
                    }
                });



        }]);
