/**
 * Created by Z.ZR on 2015/11/10.
 */
;
"use strict";

angular.module('pfApp')
    .controller('ElectronicBillProductCtrl', ['$scope', '$state', '$stateParams', '$PFHttpResource', 'RestFulURLConstants', '$ionicHistory', '$ionicPopup', 'UserInfoService',
        function ($scope, $state, $stateParams, $PFHttpResource, RestFulURLConstants, $ionicHistory, $ionicPopup, UserInfoService) {

            $scope.electronicBillProduct = {};

            $scope.goBack = function () {
                $state.go($state.params.from);
            };

            //倒计时为零的时候，自动刷新
            $scope.$watch("electronicBillProduct.countDown", function (value) {
                if (value == 0 && ($scope.electronicBillProduct.projectStatus == '01' || $scope.electronicBillProduct.projectStatus == '02')) {
                    $scope.loadElectronicBillProduct();
                }
            });

            $scope.loadElectronicBillProduct = function () {
                new $PFHttpResource(RestFulURLConstants.electronicBill.getWJProjectDetail, {projectCode: $scope.projectCode}, null, {show: true})
                    .then(function (data) {
                        $scope.electronicBillProduct = data.context.data;
                        $scope.electronicBillProduct.maxLimitInvestAmount = Number($scope.electronicBillProduct.maxLimitInvestAmount);
                    }, function () {
                        $ionicHistory.goBack();
                    });
            };

            $scope.$on('$ionicView.beforeEnter', function (e) {
                $scope.rootFrom = $state.params.from;
                $scope.backViewName = $state.params.fromName;
                $scope.projectCode = $state.params.projectCode;
                $scope.projectName = $state.params.projectName || "电票";
                $scope.loadElectronicBillProduct();
            });

            $scope.billPurchase = function() {
                if(UserInfoService.isLogin()&&UserInfoService.isAuthenUser()) {
                    new $PFHttpResource(RestFulURLConstants.electronicBill.isBuyElectronicBill, {appropriateParamSchema: $scope.projectCode}, null, {show: true})
                        .then(function (data) {
                            if(data.context.canbuy == 'N') {
                                if(data.context.href) {
                                    $ionicPopup.confirm({
                                        title: "消息",
                                        template: data.context.message,
                                        okText: data.context.hrefName,
                                        okType: 'button-panda',
                                        cancelText: '取消'
                                    }).then(function(res) {
                                        if(res) {
                                            $state.go(data.context.href);
                                        }
                                    });
                                } else {
                                    $ionicPopup.alert({
                                        title: "消息",
                                        template: data.context.message,
                                        okText: '知道了',
                                        okType: 'button-panda'
                                    });
                                }
                            } else {
                                $state.go("electronicBill.productPurchase", {
                                    product: $scope.electronicBillProduct,
                                    from: $scope.rootFrom
                                });
                            }
                        }, function (error) {
                        });
                } else {
                    $state.go("electronicBill.productPurchase", {
                        product: $scope.electronicBillProduct,
                        from: $scope.rootFrom
                    });
                }
            }

        }])

    .controller('ElectronicBillProductDescriptionCtrl', ['$scope', '$state', '$stateParams',
        function ($scope, $state, $stateParams) {

            $scope.$on('$ionicView.beforeEnter', function (e) {
                $scope.electronicBillProduct = $stateParams.product
            });

        }])

    .controller('ElectronicBillPurchaseDetailsCtrl', ['$scope', '$state', '$stateParams', '$ionicSlideBoxDelegate',
        function ($scope, $state, $stateParams, $ionicSlideBoxDelegate) {

            //手势互动
            $scope.electronicBillFlag = 0;

            $scope.$watch("electronicBillFlag", function (value) {
                $ionicSlideBoxDelegate.slide(value);
            });
            //手势互动

            $scope.electronicBillSlideChanged = function (index) {
                $scope.electronicBillFlag = index;
            };

            $scope.$on('$ionicView.beforeEnter', function (e) {
                $scope.electronicBillProduct = $stateParams.product
            });

        }])

    .controller('ElectronicBillPurchaseHistoryCtrl', ['$scope', '$state', '$stateParams', '$PFHttpResource', 'RestFulURLConstants',
        function ($scope, $state, $stateParams, $PFHttpResource, RestFulURLConstants) {

            $scope.recordList = [];
            $scope.isShowLoadingOfRecordList = true;

            //获取已经开始列表信息
            $scope.getRrecordList = function () {
                if (null == $scope.recordList || $scope.recordList.length === 0) {
                    $scope.isShowLoadingOfRecordList = true;
                }
                new $PFHttpResource(RestFulURLConstants.electronicBill.queryInvestRecord, {projectCode: $state.params.projectCode}, null, {show: false}).then(function (data) {
                    $scope.isShowLoadingOfRecordList = false;
                    $scope.recordList = data.context.data;
                }, function (error) {
                    $scope.isShowLoadingOfRecordList = false;
                });

            };

            //下拉刷新 上提示刷新
            $scope.doRefreshAuctionStartingList = function () {

                new $PFHttpResource(RestFulURLConstants.electronicBill.queryInvestRecord, {projectCode: $state.params.projectCode}, null, {show: false}).then(function (data) {
                    $scope.$broadcast('scroll.refreshComplete');
                    $scope.recordList = data.context.data;
                }, function (error) {
                    $scope.$broadcast('scroll.refreshComplete');
                });
            };


            $scope.$on("$ionicView.afterEnter", function (event) {
                $scope.getRrecordList();
            });

        }])

    .controller('ElectronicBillProductPurchaseCtrl', ['$scope', '$state', '$stateParams', 'RestFulURLConstants', '$PFHttpResource', '$ionicPopover', '$transactionPassword', 'ElectronicBillConfirmModal', '$ionicHistory', '$ionicPopup', '$interval', 'EncodePassword', 'UserInfoService', '$filter',
        function ($scope, $state, $stateParams, RestFulURLConstants, $PFHttpResource, $ionicPopover, $transactionPassword, ElectronicBillConfirmModal, $ionicHistory, $ionicPopup, $interval, EncodePassword, UserInfoService, $filter) {

            $scope.availavleAmount = 0.00;
            $scope.transaction = {};
            $scope.validate = {};
            $scope.tentativeProfit = 0.00;

            $scope.$watch("transaction.shareAmount", function (value) {
                if (value == null || value == '') {
                    value = 0;
                }

                //判断递减
                if (value <= $scope.validate.minLimitInvestCount) {
                    $scope.decreaseDisabled = true;
                } else {
                    $scope.decreaseDisabled = false;
                }

                //判断增加
                if (value >= $scope.validate.maxLimitInvestCount) {
                    $scope.increaseDisabled = true;
                } else {
                    $scope.increaseDisabled = false;
                }

                //计算金额
                $scope.transaction.applicationAmount = parseFloat(value * $scope.electronicBillProduct.eachAmount, 2);

                //处理余数金额
                $scope.isLastAmount = false;
                if (value == $scope.electronicBillProduct.remainCount) {

                    var remainNumber = parseFloat($scope.electronicBillProduct.projectAmount) - parseFloat($scope.electronicBillProduct.eachAmount * $scope.electronicBillProduct.totalCount);
                    if (remainNumber > 0) {
                        $scope.transaction.applicationAmount = $scope.transaction.applicationAmount + remainNumber;
                        $scope.isLastAmount = true;
                    }
                }

                //计算收益
                if ($scope.electronicBillProduct && $scope.electronicBillProduct.investRate) {
                    $scope.tentativeProfit = parseFloat($scope.transaction.applicationAmount * $scope.electronicBillProduct.investRate * $scope.electronicBillProduct.investLimit / 100.00 / 360.00, 2);
                }

            });


            //份额递减
            $scope.decrease = function () {

                var correctFactor = $scope.shareAmountCorrect();
                //向低值纠错
                if ($scope.transaction.shareAmount > correctFactor) {
                    $scope.transaction.shareAmount = correctFactor;
                } else {
                    if ($scope.transaction.shareAmount - $scope.validate.increaseInvestCount < $scope.validate.minLimitInvestCount) {
                        $scope.transaction.shareAmount = $scope.validate.minLimitInvestCount;
                        return false;
                    } else {
                        $scope.transaction.shareAmount = $scope.transaction.shareAmount - $scope.validate.increaseInvestCount;
                    }
                }

                return true;
            };

            $scope.decreaseInterval = null;
            $scope.onDecreaseHold = function () {
                $scope.decreaseInterval = $interval(function () {
                    if (!$scope.decrease()) {
                        $scope.onDecreaseRelease();
                    }
                }, 100);
            };
            $scope.onDecreaseRelease = function () {
                $interval.cancel($scope.decreaseInterval);
            };

            //份额递增
            $scope.increase = function () {

                var correctFactor = $scope.shareAmountCorrect();
                //向高值纠错
                if ($scope.transaction.shareAmount < correctFactor) {
                    $scope.transaction.shareAmount = correctFactor;
                } else {
                    $scope.transaction.shareAmount = correctFactor;
                    if ($scope.transaction.shareAmount + $scope.validate.increaseInvestCount > $scope.validate.maxLimitInvestCount) {
                        return false;
                    } else {
                        $scope.transaction.shareAmount = $scope.transaction.shareAmount + $scope.validate.increaseInvestCount;
                    }
                }
                return true;
            };

            $scope.increaseInterval = null;
            $scope.onIncreaseHold = function () {
                $scope.increaseInterval = $interval(function () {
                    if (!$scope.increase()) {
                        $scope.onIncreaseRelease();
                    }
                }, 100);
            };

            $scope.onIncreaseRelease = function () {
                $interval.cancel($scope.increaseInterval);
            };


            $scope.shareAmountCorrect = function () {
                if (!$scope.transaction.shareAmount) {
                    $scope.transaction.shareAmount = 0;
                }

                var correctFactor = $scope.transaction.shareAmount - ($scope.transaction.shareAmount - $scope.validate.minLimitInvestCount) % $scope.validate.increaseInvestCount;

                if (correctFactor < $scope.validate.minLimitInvestCount || correctFactor < 0) {
                    correctFactor = $scope.validate.minLimitInvestCount;
                }

                if (correctFactor > $scope.validate.maxLimitInvestCount) {
                    correctFactor = $scope.validate.maxLimitInvestCount;
                }

                return correctFactor;
            };

            $scope.purchase = function () {

                //检查起购份额
                if ($scope.transaction.shareAmount != $scope.electronicBillProduct.remainCount) {
                    if ($scope.transaction.shareAmount < $scope.validate.minLimitInvestCount) {
                        reminder("购买份额不能小于起购份额");
                        return;
                    }
                }

                //检查累计最大购买份额
                //检查是否超过剩余份额
                if ($scope.transaction.shareAmount > $scope.validate.maxLimitInvestCount) {
                    if ($scope.electronicBillProduct.maxLimitInvestCount) {
                        reminder("购买份额不能超过累计购买份额");
                    } else {
                        reminder("购买份额不能超过剩余可购份额");
                    }
                    return;
                }

                //检查递增份额 （份额-起购份额）% 递增份额==0
                if ($scope.transaction.shareAmount < $scope.electronicBillProduct.remainCount) {

                    var judgmentFactor = $scope.electronicBillProduct.remainCount - $scope.transaction.shareAmount;
                    if (judgmentFactor < $scope.validate.minLimitInvestCount) {
                        reminder("购买后所剩余份额必须大于" + $scope.validate.minLimitInvestCount + "份，或者全部购买");
                        return;
                    }

                    //检查递增份额 （份额-起购份额）% 递增份额==0
                    if (($scope.transaction.shareAmount - $scope.validate.minLimitInvestCount < 0) || ($scope.transaction.shareAmount - $scope.validate.minLimitInvestCount) % $scope.validate.increaseInvestCount != 0) {
                        reminder("递增份额不合法");
                        return;
                    }
                }

                //检查余额
                if ($scope.transaction.applicationAmount > parseFloat($scope.availavleAmount)) {
                    $ionicPopup.confirm({
                        title: '温馨提示',
                        template: '电子账户可用余额不足，去充值？',
                        cancelText: '取消',
                        okText: '确定',
                        okType: 'button-panda'
                    }).then(function (res) {
                        if (res) {
                            $state.go("financeCenter.recharge");
                        }
                    });
                    return;
                }

                var _parameters = {
                    userAccount: UserInfoService.getUserInfo().userAccount,
                    transamount: $scope.transaction.shareAmount,
                    type: "trans",
                    transType: "6",//购买:6,购买网金
                    key: $filter('uppercase')(CryptoJS.SHA1(UserInfoService.getUserInfo().userAccount + $scope.transaction.shareAmount).toString())
                };

                $PFHttpResource(RestFulURLConstants.unitResource.generateTransactionSerialNo, _parameters).then(function (data) {

                    var _serialNo = data.context.result.serialNo;
                    $scope.confirmTransamount = data.context.result.transamount;

                    //输入交易密码
                    $transactionPassword({scope: $scope})
                        .then(function (password) {

                            EncodePassword.encrypt("11", password).then(function (password) {

                                new $PFHttpResource(RestFulURLConstants.electronicBill.createOrder, {
                                    prjCode: $scope.electronicBillProduct.projectCode,
                                    transPassWord: password,
                                    serialNo: _serialNo
                                }).then(function (data) {

                                    ElectronicBillConfirmModal({
                                        scope: $scope,
                                        type: "success",
                                        header: "交易详情",
                                        title: "订单已提交",
                                        subTitle: "订单号：" + data.context.orderNo || $scope.electronicBillProduct.projectName,
                                        message: "订单份额：<b class='panda'>" + $scope.transaction.shareAmount + "</b>份额，订单金额：<b class='panda'>" + $filter('currency')(data.context.partsAmount, '') + "</b>元",
                                        transactionTime: data.context.transactionDate,
                                        profitStartTime: $scope.electronicBillProduct.interestBeginDate,
                                        profitEndTime: $scope.electronicBillProduct.repayDate
                                    }).then(function () {
                                        $state.go($scope.rootFrom);
                                    });

                                });

                            }, function () {
                                $cordovaToast.show("交易失败", 'long', 'center');
                            });

                        });

                });

            };

            function reminder(message) {
                $ionicPopup.alert({
                    title: "温馨提示",
                    template: message,
                    okText: '确定',
                    okType: 'button-panda'
                });
            };

            $scope.$on('$ionicView.beforeEnter', function (e) {

                $scope.isLastAmount = false;

                $scope.electronicBillProduct = $stateParams.product;

                $scope.rootFrom = $state.params.from;

                $scope.validate = {
                    minLimitInvestCount: $scope.electronicBillProduct.minInvestCount || 1,//最小投资份额
                    maxLimitInvestCount: ($scope.electronicBillProduct.maxLimitInvestCount == null || $scope.electronicBillProduct.maxLimitInvestCount == 0) ? $scope.electronicBillProduct.remainCount : ($scope.electronicBillProduct.maxLimitInvestCount < $scope.electronicBillProduct.remainCount ? $scope.electronicBillProduct.maxLimitInvestCount : $scope.electronicBillProduct.remainCount),//最大投资份额
                    increaseInvestCount: $scope.electronicBillProduct.increCount || 1
                };

                $scope.transaction = {
                    applicationAmount: 0.00,
                    shareAmount: $scope.electronicBillProduct.minInvestCount || 0
                };

                $PFHttpResource(RestFulURLConstants.finance.assets.queryOnlyElectronicAccount, {})
                    .then(function (data) {
                        $scope.availavleAmount = data.context.result.acctAmount.availBal;
                    }, function (error) {
                        $ionicPopup.alert({
                            title: "温馨提示",
                            template: "查询余额失败",
                            okText: '确定',
                            okType: 'button-panda'
                        }).then(function () {
                            $ionicHistory.goBack();
                        });
                    });

            });

        }]);
