/**
 * Created by Z.ZR on 2015/11/15.
 */

"use strict";
angular.module('pfApp')
    .factory('ElectronicBillConfirmModal', ['$rootScope', '$ionicModal', '$q', '$sce',
        function ($rootScope, $ionicModal, $q, $sce) {

            return function (_parameterObject) {

                var parameterObject = {
                    scope: $rootScope,
                    type: null,
                    header: null,
                    title: null,
                    subTitle: null,
                    message: null,
                    animation: 'slide-in-right',
                    url: 'modules/electronicBill/templates/electronicBillConfirmModal.html'
                };

                parameterObject = angular.extend({}, parameterObject, _parameterObject, true);

                var scope = parameterObject.scope.$new();

                scope.header = parameterObject.header;
                scope.type = parameterObject.type;
                scope.title = parameterObject.title;

                scope.transactionTime = parameterObject.transactionTime;
                scope.profitStartTime = parameterObject.profitStartTime;
                scope.profitEndTime = parameterObject.profitEndTime;

                scope.subTitle = $sce.trustAsHtml(parameterObject.subTitle);
                scope.message = $sce.trustAsHtml(parameterObject.message);

                var deferred = $q.defer();

                $ionicModal.fromTemplateUrl(parameterObject.url, {
                    scope: scope,
                    animation: parameterObject.animation
                }).then(function (modal) {
                    scope._ElectronicBillConfirmModal = modal;
                    scope._ElectronicBillConfirmModal.show();
                });

                scope._closeElectronicBillConfirmModal = function () {
                    scope._ElectronicBillConfirmModal.hide();
                };

                scope.$on('$destroy', function () {
                    scope._ElectronicBillConfirmModal.remove();
                });

                scope.$on('modal.hidden', function () {
                    deferred.resolve(parameterObject);
                });

                return deferred.promise;
            };
        }]);
