/**
 * Created by Z.ZR on 2015/11/10.
 */

"use strict";
angular.module('pfApp').config(['$stateProvider', '$urlRouterProvider', '$ocLazyLoadProvider', 'RouterLevel', function ($stateProvider, $urlRouterProvider, $ocLazyLoadProvider, RouterLevel) {
    $stateProvider
        .state('financeCenter', {
            url: '/financeCenter',
            abstract: true,
            resolve: $ocLazyLoadProvider.ocLazyLoadDependency('chart', 'echarts', 'financeModule'),
            data: {
                $stateLevel: RouterLevel.LOGIN_USER
            }
        })
        .state('financeCenter.setting', {
            url: '/setting',
            params: {"comeFrom": null},
            views: {
                '@': {
                    templateUrl: 'modules/finance/templates/setting.html',
                    controller: 'FinanceSettingCtrl'
                }
            },
            data: {
                $stateLevel: RouterLevel.LOGIN_USER
            }
        })
        .state('financeCenter.details', {
            params: {
                "productType": null,
                "productName": null,
                "bindCardNo": null,
                "totalAmount": null,
                "lastIncome": null,
                "totalIncome": null,
                "copies":null,
                "nav": null,
                "navDate": null,
                "dailyGains": null,
                "availableCopies": null
            },
            url: '/details/:productType/:productName/:electronAcct',
            views: {
                '@': {
                    resolve: $ocLazyLoadProvider.ocLazyLoadDependency('chart','echarts'),
                    templateUrl: function($routeParams){
                      if($routeParams.productType == 'ZS0005'){
                        return 'modules/finance/templates/productDetailForYkx.html';
                      }else{
                        return 'modules/finance/templates/productDetail.html';
                      }
                    },
                    controller: 'FinanceDetailsCtrl'
                }
            },
            data: {
                $stateLevel: RouterLevel.AUTHEN_USER
            }
        })
        .state('financeCenter.fundBuyPage', {
            url: '/fundBuyPage',
            params: {"productDesc": null},
            views: {
                '@': {
                    templateUrl: 'modules/finance/templates/fundBuyPage.html',
                    controller: 'FinanceFundBuyPageCtrl'
                }
            },
            data: {
                $stateLevel: RouterLevel.AUTHEN_USER
            }
        })
        .state('financeCenter.fundRedeemPage', {
            url: '/fundRedeemPage',
            params: {"productDesc": null},
            views: {
                '@': {
                    templateUrl: 'modules/finance/templates/fundRedeemPage.html',
                    controller: 'FinanceFundRedeemPageCtrl'
                }
            },
            data: {
                $stateLevel: RouterLevel.AUTHEN_USER
            }
        })
        .state('financeCenter.buyDetails', {
            url: 'buyDetails',
            params: {"productType": null},
            views: {
                '@': {
                    templateUrl: 'modules/finance/templates/buyDetails.html',
                    controller: 'FinanceBuyDetailsCtrl'
                }
            },
            data: {
                $stateLevel: RouterLevel.AUTHEN_USER
            }
        })
        .state('financeCenter.accountInfo', {
            url: '/accountInfo/:electronAcct',
            params: {
                "legendData": null,
                "seriesData": null,
                "totalAmount": null,
                "totalIncome": null,
                "availAmount": null
            },
            views: {
                '@': {
                    templateUrl: 'modules/finance/templates/accountInfo.html',
                    controller: 'FinanceAccountCtrl'
                }
            },
            data: {
                $stateLevel: RouterLevel.AUTHEN_USER
            }
        })
        .state('financeCenter.regularMoney', {
            url: '/regularMoney',
            params: {isForceReload: ''},
            views: {
                '@': {
                    templateUrl: 'modules/finance/templates/regularMoney.html',
                    controller: 'FinanceRegularMoneyCtrl'
                }
            },
            data: {
                $stateLevel: RouterLevel.AUTHEN_USER
            }
        })
        .state('financeCenter.regularInfo', {
            url: '/regularInfo',
            params: {id: '', actionStatus: ''},
            views: {
                '@': {
                    templateUrl: 'modules/finance/templates/regularInfo.html',
                    controller: 'FinanceRegularInfoCtrl'
                }
            },
            data: {
                $stateLevel: RouterLevel.AUTHEN_USER
            }
        })
        .state('financeCenter.bindCardInfo', {
            url: '/bindCardInfo',
            params: {cardStyle: null, from: null},
            views: {
                '@': {
                    templateUrl: 'modules/finance/templates/bindCardInfo.html',
                    controller: 'FinanceBindCardCtrl'
                }
            },
            resolve: $ocLazyLoadProvider.ocLazyLoadDependency('finance'),
            data: {
                $stateLevel: RouterLevel.AUTHEN_USER
            }
        })
        .state('financeCenter.bindCard', {
            url: '/bindCard',
            params: {card: null},
            views: {
                '@': {
                    templateUrl: 'modules/finance/templates/addBindCard.html',
                    controller: 'FinanceBindCardCtrl'
                }
            },
            data: {
                $stateLevel: RouterLevel.AUTHEN_USER
            }
        })
        .state('financeCenter.unBindCardInfo', {
            url: '/unBindCardInfo',
            params: {
                card: null,
                isOnlyOne: true
            },
            views: {
                '@': {
                    templateUrl: 'modules/finance/templates/unBindBankCard.html',
                    controller: 'FinanceunBindCardInfoCtrl'
                }
            },
            data: {
                $stateLevel: RouterLevel.AUTHEN_USER
            }
        })
        //更换银行卡
        .state('financeCenter.changeBindCard', {
            url: '/changeBindCard',
            params: {card: null},
            views: {
                '@': {
                    templateUrl: 'modules/finance/templates/changeBindCard.html',
                    controller: 'changeBindCardCtrl'
                }
            },
            data: {
                $stateLevel: RouterLevel.AUTHEN_USER
            }
        })
        .state('financeCenter.recharge', {
            url: '/recharge',
            views: {
                '@': {
                    templateUrl: 'modules/finance/templates/recharge.html',
                    controller: 'FinanceRechargeCtrl'
                }
            },
            data: {
                $stateLevel: RouterLevel.AUTHEN_USER
            }
        })
        .state('financeCenter.deposit', {
            url: '/deposit',
            views: {
                '@': {
                    templateUrl: 'modules/finance/templates/deposit.html',
                    controller: 'FinanceDepositCtrl'
                }
            },
            data: {
                $stateLevel: RouterLevel.AUTHEN_USER
            }
        })
        .state('financeCenter.tradeDetail', {
            url: '/tradeDetail',
            views: {
                '@': {
                    templateUrl: 'modules/finance/templates/tradeDetail.html',
                    controller: 'FinanceTradeDetailCtrl'
                }
            },
            data: {
                $stateLevel: RouterLevel.AUTHEN_USER
            }
        })
      .state('financeCenter.assetsDetail', {
        url: '/assetsDetail',
        params: {
          data: null
        },
        views: {
          '@': {
            templateUrl: 'modules/finance/templates/assetsDetail.html',
            controller: 'FinanceAssetsDetailCtrl'
          }
        },
        data: {
          $stateLevel: RouterLevel.AUTHEN_USER
        }
      })
        .state('financeCenter.dayIncomeHistory', {
            url: '/dayIncomeHistory',
            params: {"dayIncomes": null},
            views: {
                '@': {
                    templateUrl: 'modules/finance/templates/dayIncomeHistory.html',
                    controller: 'FinanceFundDayIncomeCtrl'
                }
            },
            data: {
                $stateLevel: RouterLevel.AUTHEN_USER
            }
        }).state('financeCenter.memberCardDetail', {
        url: '/memberCardDetail',
        params: {'from': null},
        views: {
          '@': {
            templateUrl: 'modules/finance/templates/memberCardDetail.html',
            controller: 'FinanceMemberCardDetailCtrl'
          }
        },
        data: {
          $stateLevel: RouterLevel.AUTHEN_USER
        }
      });
}]);
