/**
 * Created by Z.ZR on 2015/11/10.
 */
;
"use strict";

angular.module('pfApp')
    .controller('FinanceDetailsCtrl', ['$scope', '$state', '$stateParams', 'FinanceService', '$ionicSlideBoxDelegate', function ($scope, $state, $stateParams, FinanceService, $ionicSlideBoxDelegate) {
        $scope.product = {};
        $scope.user = {};
        $scope.product.title = $stateParams.productName;
        $scope.product.productType = $stateParams.productType;
        $scope.user.electronAcct = $stateParams.electronAcct;
        $scope.product.totalAmount = $stateParams.totalAmount == null ? '0.00' : $stateParams.totalAmount;
        $scope.product.lastIncome = $stateParams.lastIncome == null ? '0.00' : $stateParams.lastIncome;
        $scope.product.totalIncome = $stateParams.totalIncome == null ? '0.00' : $stateParams.totalIncome;
        $scope.product.copies = $stateParams.copies == null ? '0' : $stateParams.copies;
        $scope.product.availableCopies = $stateParams.availableCopies == null ? '0' : $stateParams.availableCopies;
        $scope.product.nav = $stateParams.nav == null ? '0.00' : $stateParams.nav;
        $scope.product.navDate = $stateParams.navDate == null ? '' : $stateParams.navDate;
        $scope.product.dailyGains = $stateParams.dailyGains == null ? '0.00' : $stateParams.dailyGains;
        var myDate = new Date();
        var date = myDate.getDate();
        myDate.setDate(date - 1);
        $scope.yesterday = myDate.toLocaleDateString();

        //产品代码 02 熊猫宝
        if ($stateParams.productType == 'ZS0002' || $stateParams.productType == 'ZS0003') {
            //查询七日年化收益和万分年化收益
            var _promise = FinanceService.queryProductHistoryDetail($scope);
            _promise.then(function (data) {
                var sevenDayProfit = new Array();
                var sevenDayProfitNavDate = new Array();
                var millionProfit = new Array();
                if (data.context.result) {
                    angular.forEach(data.context.result, function (obj) {
                        sevenDayProfit.push(obj.yield);
                        millionProfit.push(obj.fundIncome);
                        if (obj.navDate) {
                            sevenDayProfitNavDate.push(obj.navDate.slice(-4));
                        }
                    });
                    FinanceService.showSevenDayProfitChart(sevenDayProfitNavDate, sevenDayProfit, millionProfit);
                    //查询产品介绍
                    FinanceService.queryProductProtocol({"productCode": $stateParams.productType}).then(function (ret) {
                        if (ret && ret.context.product) {
                            $scope.product.productDesc = ret.context.product.productDesc;
                            $scope.product.buyCode = ret.context.product.buyCode;
                            $scope.product.redeemCode = ret.context.product.redeemCode;
                        }
                    }, function (err) {
                    })

                }
            }, function (data) {
            });
            //查询日收益明细
            var _promose = FinanceService.queryProductDayIncomeHistory({"productType": $stateParams.productType});
            _promose.then(function (data) {
                if (data && data.context) {
                    $scope.dayIncomes = data.context.result;

                    if ($scope.dayIncomes && $scope.dayIncomes.length > 0) {
                        $scope.yesterday = $scope.dayIncomes[0].incomeDay;
                    }

                }
            }, function (ret) {
            });
            //七日年化收益
            $scope.slideshow = {
                tabsShow: 'sevenDayProfit'
            }
            $scope.profitNextSlide = function () {
                $scope.slideshow.tabsShow = 'sevenDayProfit';
                $ionicSlideBoxDelegate.previous();
            }
            $scope.profitPreviousSlide = function () {
                $scope.slideshow.tabsShow = 'millionProfit';
                $ionicSlideBoxDelegate.next();
            }
            $scope.slideHasChanged = function (_index) {
                if (_index == 0) {
                    $scope.slideshow.tabsShow = 'sevenDayProfit';
                } else {
                    $scope.slideshow.tabsShow = 'millionProfit';
                }
            }
        }

    //加载周周盈图表
    function loadNavData(canvasChart, num){
      FinanceService.queryNavList({productType: $stateParams.productType, rowNumber: num}).then(function (data) {
        FinanceService.showDavListLineChart(canvasChart, data.context.navList);
        switch (num) {
          case 1:
            $scope.chartsLoading30 = false;
            $scope.chartsLoadError30 = false;
            break;
          case 3:
            $scope.chartsLoading90 = false;
            $scope.chartsLoadError90 = false;
            break;
          case 6:
            $scope.chartsLoading180 = false;
            $scope.chartsLoadError180 = false;
            break;
          case 12:
            $scope.chartsLoading365 = false;
            $scope.chartsLoadError365 = false;
            break;
        }

      }, function () {
        switch (num) {
          case 1:
            $scope.canvasChart30 = null;
            $scope.chartsLoading30 = false;
            $scope.chartsLoadError30 = true;
            break;
          case 3:
            $scope.canvasChart90 = null;
            $scope.chartsLoading90 = false;
            $scope.chartsLoadError90 = true;
            break;
          case 6:
            $scope.canvasChart180 = null;
            $scope.chartsLoading180 = false;
            $scope.chartsLoadError180 = true;
            break;
          case 12:
            $scope.canvasChart365 = null;
            $scope.chartsLoading365 = false;
            $scope.chartsLoadError365 = true;
            break;
        }
      });
    };

        $scope.slideTo = function (index, src) {
          $ionicSlideBoxDelegate.slide(index);
          if(src === 'ykx') { //周周盈
            switch (index) {
              case 0:
                if(!$scope.canvasChart30) {
                  $scope.chartsLoading30 = true;
                  $scope.canvasChart30 = new Chart(document.getElementById("pandaTreasure30").getContext("2d"));
                  loadNavData($scope.canvasChart30, 1);
                }
                break;
              case 1:
                if(!$scope.canvasChart90) {
                  $scope.chartsLoading90 = true;
                  $scope.canvasChart90 = new Chart(document.getElementById("pandaTreasure90").getContext("2d"));
                  loadNavData($scope.canvasChart90, 3);
                }
                break;
              case 2:
                if(!$scope.canvasChart180) {
                  $scope.chartsLoading180 = true;
                  $scope.canvasChart180 = new Chart(document.getElementById("pandaTreasure180").getContext("2d"));
                  loadNavData($scope.canvasChart180, 6);
                }
                break;
              case 3:
                if(!$scope.canvasChart365) {
                  $scope.chartsLoading365 = true;
                  $scope.canvasChart365 = new Chart(document.getElementById("pandaTreasure365").getContext("2d"));
                  loadNavData($scope.canvasChart365, 12);
                }
                break;
            }
          }
        };

        //产品代码 05 月开鑫
        if ($stateParams.productType == 'ZS0005') {
          //查询产品介绍
          FinanceService.queryProductProtocol({"productCode": $stateParams.productType}).then(function (ret) {
            if (ret && ret.context.product) {
              $scope.product.productDesc = ret.context.product.productDesc;
              $scope.product.productFeature = ret.context.product.productFeature;
              $scope.product.productDetailone = ret.context.product.productDetailone;
              $scope.product.productDetailtwo = ret.context.product.productDetailtwo;
              $scope.product.buyCode = ret.context.product.buyCode;
              $scope.product.redeemCode = ret.context.product.redeemCode;
              $scope.product.minResidual = ret.context.product.minResidual;
              $scope.product.productCode = $stateParams.productType;
              //周周盈初始30天图表
              $scope.chartsLoading30 = true;
              $scope.canvasChart30 = new Chart(document.getElementById("pandaTreasure30").getContext("2d"));
              loadNavData($scope.canvasChart30, 1);
            }
          }, function (err) {
          });

          //周周盈赎回判断
          FinanceService.checkRedeem({"productType":$stateParams.productType})
              .then(function(data) {
                  $scope.isGray = data.context.checkRedeem; //false时赎回按钮置灰
              }, function(error) {
              });
        }

        //返回财富URL
        $scope.goBack = function () {
            $state.go('tab.self');
        };
        //产品购买
        $scope.fundBuyPage = function () {
            //调整到购买界面
            $state.go("financeCenter.fundBuyPage", {"productDesc": $scope.product});

        };
        //产品赎回
        $scope.fundRedeemPage = function () {
            if(angular.isDefined($scope.isGray)&&!$scope.isGray) {
                return false;
            }
            //调整到赎回界面
            $state.go("financeCenter.fundRedeemPage", {"productDesc": $scope.product});
        };
        //购买详细信息
        $scope.buyDetails = function () {
            $state.go("financeCenter.buyDetails", {"productType": $scope.product.productType});
        };

        /*$scope.$on("$ionicView.afterEnter", function(event) {
          if($stateParams.productType === 'ZS0005') { //周周盈初始30天图表
            $scope.chartsLoading30 = true;
            $scope.canvasChart30 = new Chart(document.getElementById("pandaTreasure30").getContext("2d"));
            loadNavData($scope.canvasChart30, 1);
          }
        });*/
    }])
    .controller('FinanceBuyDetailsCtrl', ['$scope', '$stateParams', 'FinanceService', function ($scope, $stateParams, FinanceService) {
        /**
         * 产品购买历史信息
         * @type {Array}
         */
        $scope.products = [];
        $scope.selfFilter=function(item){
            return item.productType==$stateParams.productType;
        }
        var _promise = FinanceService.buyDetails({"productType": $stateParams.productType});
        _promise.then(function (data) {
            if (data && data.context.result) {
                $scope.products = data.context.result;
            }
        }, function (data) {
        });
    }])
    .controller('FinanceFundBuyPageCtrl', ['$scope', '$state', '$stateParams', '$filter', 'UserInfoService', 'GenerateTransactionSerialNoService', 'ElectroinicAccountService', 'FinanceService', 'SendLocalNotificationService', '$transactionPassword', 'DevelopmentModeConstants', 'EncodePassword', '$cordovaToast',
        function ($scope, $state, $stateParams, $filter, UserInfoService, GenerateTransactionSerialNoService, ElectroinicAccountService, FinanceService, SendLocalNotificationService, $transactionPassword, DevelopmentModeConstants, EncodePassword, $cordovaToast) {
            var productType = $stateParams.productDesc.productType;
            var buyCode = $stateParams.productDesc.buyCode;
            $scope.title = $stateParams.productDesc.title;
            $scope.buy = {};
            $scope.account = {
                availBal: ''
            }
            $scope.agreements = [];
            //查询电子账户余额
            var _promise = ElectroinicAccountService.queryOnlyElectroinicAmount($scope);
            _promise.then(function (data) {
                if (data.context && data.context.result) {
                    $scope.account.availBal = data.context.result.acctAmount.availBal;
                }
                convertAgreement(buyCode, $scope.agreements);
            }, function (data) {
            });
            function convertAgreement(agreementCodesString, agreements) {
                agreements = agreements || [];
                if (agreementCodesString) {
                    var agreementCodes = agreementCodesString.split(";");
                    angular.forEach(agreementCodes, function (agreementCode) {
                            var agreement = agreementCode.split(":");
                            if (agreement.length === 2) {
                                agreements.push({name: "《" + agreement[1] + "》", code: agreement[0]});
                            }
                        }
                    );
                    $scope.buy.pandaArgument = !agreements.length > 0;
                }
            };

            $scope.account = {};
            if (productType === 'ZS0005') {
              $scope.inputKeyDown = function(event) {
                if(event.keyCode === 190) {
                  event.preventDefault();
                }
              };
            }

            //熊猫宝购买
            $scope.xmbBuyFinance = function () {
                var _parameters = {
                    userAccount: UserInfoService.getUserInfo().userAccount,
                    transamount: $scope.account.applicationAmount.toString().trim(),
                    type: "trans",
                    transType: "2",//购买:2
                    key: $filter('uppercase')(CryptoJS.SHA1(UserInfoService.getUserInfo().userAccount + $scope.account.applicationAmount.toString().trim()).toString())
                };
                GenerateTransactionSerialNoService.generateTransactionSerialNo(_parameters).then(function (data) {
                    if (data && data.context.result) {
                        $scope._serialNo = data.context.result.serialNo;
                        $scope.confirmTransamount = data.context.result.transamount;

                        $transactionPassword({scope: $scope})
                            .then(function (password) {
                                if (!DevelopmentModeConstants.debug) {
                                    var _promise = EncodePassword.encrypt("11", password);
                                    _promise.then(function (ret) {
                                        $scope.account.trandPassWord = ret;
                                        FinanceService.xmbFundBuy(angular.extend($scope.account, {
                                            "productType": productType,
                                            "serialNo": $scope._serialNo
                                        }));
                                    }, function (error) {
                                    })
                                } else {
                                    $scope.account.trandPassWord = password;
                                    FinanceService.xmbFundBuy(angular.extend($scope.account, {"productType": productType}));
                                }
                            });
                    } else {
                        $cordovaToast.show("产生流水号失败!", 'long', 'center');
                    }
                });

            }
        }])
    .controller('FinanceFundRedeemPageCtrl', ['$scope', '$state', '$stateParams', 'UserInfoService', 'FinanceService', '$transactionPassword', 'EncodePassword', 'DevelopmentModeConstants', 'GenerateTransactionSerialNoService', '$cordovaToast', '$filter', '$ionicPopup',
        function ($scope, $state, $stateParams, UserInfoService, FinanceService, $transactionPassword, EncodePassword, DevelopmentModeConstants, GenerateTransactionSerialNoService, $cordovaToast, $filter, $ionicPopup) {
            var productType = $stateParams.productDesc.productType;
            var redeemCode = $stateParams.productDesc.redeemCode;
            $scope.title = $stateParams.productDesc.title;
            $scope.copies = $stateParams.productDesc.availableCopies;//周周盈购买份数
            $scope.isXjj = false;
            $scope.redeem = {};

            $scope.account = {
                availBal: '',
                turnOutType: false
            }
            $scope.turnOutSetting = function () {
                if ($scope.account.turnOutType) {
                    $scope.account.saleAmount = parseFloat($scope.account.totalAmount);
                } else {
                    $scope.account.saleAmount = null;
                }
            }
            //非周周盈查询购买份额
            if(productType != 'ZS0005') {
              var _promise = FinanceService.queryProductBuyInfo({"productType": productType});
              _promise.then(function (data) {
                if (data.context && data.context) {
                  $scope.account.totalAmount = data.context.totalAmount;
                }
              }, function (data) {
              });
            }else{
              $scope.account.totalAmount = $scope.copies;
              $scope.isXjj = true;
            }
            //$scope.account = {}
            //赎回
            $scope.redeemFinance = function () {
                var _parameters = {
                    userAccount: UserInfoService.getUserInfo().userAccount,
                    transamount: $scope.account.saleAmount.toString().trim(),
                    type: "trans",
                    transType: "3",//赎回:3
                    key: $filter('uppercase')(CryptoJS.SHA1(UserInfoService.getUserInfo().userAccount + $scope.account.saleAmount.toString().trim()).toString())
                };
                if(productType === 'ZS0005') {
                    var isLow = $scope.account.totalAmount - $scope.account.saleAmount;
                    if(isLow != 0 && isLow < $stateParams.productDesc.minResidual) {
                        $ionicPopup.alert({
                            title: '温馨提示',
                            template: '剩余份数不能低于最小赎回份数'+$stateParams.productDesc.minResidual+'份!',
                            okText: '我知道了',
                            okType: 'button-panda'
                        });
                        return false;
                    }
                    //angular.extend(_parameters, {callableCopies: $scope.account.totalAmount});
                }
                GenerateTransactionSerialNoService.generateTransactionSerialNo(_parameters).then(function (data) {
                    if (data && data.context.result) {
                        $scope._serialNo = data.context.result.serialNo;
                        $scope.confirmTransamount = data.context.result.transamount;

                        $transactionPassword({scope: $scope})
                            .then(function (password) {
                                if (!DevelopmentModeConstants.debug) {
                                    var _promise = EncodePassword.encrypt("11", password);
                                    _promise.then(function (ret) {
                                        $scope.account.trandPassWord = ret;
                                        FinanceService.redeemProduct(angular.extend($scope.account, {
                                            "productType": productType,
                                            "serialNo": $scope._serialNo,
                                            "callableCopies": $scope.account.totalAmount
                                        }));
                                    }, function (error) {
                                    })
                                } else {
                                    $scope.account.trandPassWord = password;
                                    FinanceService.redeemProduct(angular.extend($scope.account, {"productType": productType}));
                                }
                            });
                    } else {
                        $cordovaToast.show("产生流水号失败!", 'long', 'center');
                    }
                });
            }

        }])
    .controller('FinanceAccountCtrl', ['$scope', '$stateParams', '$state', 'ElectroinicAccountService', function ($scope, $stateParams, $state, ElectroinicAccountService) {
        var legendData = JSON.parse($stateParams.legendData);
        var seriesData = JSON.parse($stateParams.seriesData);
        $scope.totalAmount = $stateParams.totalAmount;
        $scope.totalIncome = $stateParams.totalIncome;
        $scope.availAmount = $stateParams.availAmount;
        var _promise = ElectroinicAccountService.queryBankDepositRate($scope);
        _promise.then(function (data) {
            if (data && data.context) {
                var bars = document.getElementById("bar").getContext("2d");
                var barChart = new Chart(bars);
                var _dataRet = new Array();
                _dataRet.push(data.context.result.baseRate); //活期
                _dataRet.push(data.context.result.weekRate); //七天
                _dataRet.push(data.context.result.threeMonthRate);//三个月
                _dataRet.push(data.context.result.halfYearRate);//半年
                _dataRet.push(data.context.result.yearRate);//一年
                var barChartData = {
                    labels: ["活期", "七天", "三个月", "半年", "一年"],
                    datasets: [
                        {
                            fillColor: "rgba(249,108,65,0.15)",
                            strokeColor: "rgba(249,108,65,1)",
                            data: _dataRet,
                            colors: ['#FFDE92', '#77DFB8', '#E4C8A3', '#94D3EF', '#FFAECA']
                        }
                    ]
                };
                barChart.Bar(barChartData, {
                    responsive: true,
                    barStrokeWidth: 0.5,
                    scaleLineWidth: 0.5,
                    scaleLineColor: "rgba(151,187,205,1)",
                    animationSteps: 30,
                    scaleShowGridLines: false
                });
            }
        }, function (err) {
        });

        //返回财富URL
        $scope.goBack = function () {
            $state.go('tab.self');
        }

        //账户明细
        $scope.accountDetails = function () {
            //跳转交易明细页面
            $state.go('financeCenter.tradeDetail');
        }

        //资金明细
        $scope.assetsDetails = function () {
          //跳转金额明细页面
          $state.go('financeCenter.assetsDetail');
        }
    }])
    .controller('FinanceBindCardCtrl', ['$scope', '$state', '$ionicPopup', '$transactionPassword', '$ionicModal', 'SendValidateCodeService', '$stateParams', 'ElectroinicAccountService', 'DistinguishBankTypeService', '$cordovaToast', 'DevelopmentModeConstants', 'EncodePassword', 'MobileValidateCodeTypeConstants', 'JudgmentSimplePwdService', 'ViewSupportBank',
        function ($scope, $state, $ionicPopup, $transactionPassword, $ionicModal, SendValidateCodeService, $stateParams, ElectroinicAccountService, DistinguishBankTypeService, $cordovaToast, DevelopmentModeConstants, EncodePassword, MobileValidateCodeTypeConstants, JudgmentSimplePwdService, ViewSupportBank) {
            //查询绑定卡信息
            $scope.cards = new Array();
            $scope.memberCards = new Array();
            $scope.from = $stateParams.from;
            $scope.fromTitle = ($scope.from == 'home')? "首页":"我的";
            //获取验证码
            $scope.isSending = false;
            $scope.isSendTimeLimit = false;
            $scope.sendTimeOut = null;
            $scope.user = {};
            if ($stateParams.cardStyle == 'bank') {
                $scope.isBank = true;
                $scope.cardName = '银行卡';
            } else {
                $scope.isBank = false;
                $scope.cardName = '会员卡';
            }
            $scope.shortMessageValidateCode = function () {
                SendValidateCodeService.sendValidateCode($scope, MobileValidateCodeTypeConstants.BANKPHONECERTIFICATION);
            };
            /**
             * 查询绑定银行卡&会员卡信息信息
             */
            function queryBindCardInfo() {
                ElectroinicAccountService.queryBindCardList($scope)
                    .then(function (data) {
                        if (data.context.result) {
                            angular.forEach(data.context.result, function (obj) {
                                obj.bankacct = "**** **** **** " + obj.bankacct.slice(-4);
                                if (obj.bindCardType === '01') {
                                    $scope.cards.push(obj);
                                } else {
                                    $scope.memberCards.push(obj);
                                }

                            });
                        }
                    });
            }

            queryBindCardInfo();

            //新增银行卡
            $scope.addBankCardInfo = function () {
                //判断绑定的银行卡是否大于5张
                if ($scope.cards.length > 5) {
                    var alertPopup = $ionicPopup.alert({
                        title: '温馨提示',
                        template: '电子账户最多支持绑定5张银行卡!',
                        okText: '我知道了',
                        okType: 'button-clear button-balanced'
                    });
                    return;
                }
                //新增
                $state.go("financeCenter.bindCard", {"product": ''});
                $scope.card = {};  //重新初始化数据
            }

            $scope.card = {};
            $scope.card.isThisBank = '';
            function calculateDiscount(newValue) {
                if (newValue && newValue.length == 6) {
                    DistinguishBankTypeService.distinguishBankType(newValue, $scope);
                } else if (newValue && newValue.length < 6) {
                    $scope.card.cardPassword = null;
                    $scope.card.banktype = null;
                    $scope.card.bankname = null;
                    $scope.card.showFlag = false;
                    $scope.user.cellPhone = null;
                    $scope.user.verificationCode = null;
                }
            }

            $scope.$watch("card.bankacct", calculateDiscount);
            //银行卡输入域离开 校验
            $scope.validBankCardType = function () {
                var _bankAcctNo = $scope.card.bankacct;
                var _bankType = $scope.card.banktype;
                if (_bankAcctNo != null && _bankAcctNo.length >= 6 && _bankType == null) {
                    DistinguishBankTypeService.distinguishBankType(_bankAcctNo.substr(0, 6), $scope);
                }
            }
            //弹出密码框
            $scope.showPasswordModal = function () {
                $scope.keyboardTitle = '输入卡密码';
                $transactionPassword({scope: $scope})
                    .then(function (password) {
                        $scope.card.cardPassword = password;
                    });
            }
            //新增绑定卡
            $scope.submitBindCard = function () {
                //保存加挂卡信息
                if (!DevelopmentModeConstants.debug && $scope.card.isThisBank === 'Y') {
                    if (JudgmentSimplePwdService.judgmentSimplePwd($scope.card.cardPassword)) {
                        var _promise = EncodePassword.encrypt("11", $scope.card.cardPassword, $scope.card.bankacct);
                        _promise.then(function (ret) {
                            $scope.card.cardPassword = ret;
                            $scope.card.bindCardType = '01'; //只绑定借记卡
                            var _promise = ElectroinicAccountService.addBindCardInfo(angular.extend($scope.user, $scope.card));
                            _promise.then(function (ret) {
                                $scope.cards = new Array();
                                queryBindCardInfo();
                                $state.go("financeCenter.bindCardInfo", {'cardStyle': 'bank'});
                            }, function (ret) {
                                $scope.card.cardPassword = null;
                            });
                        }, function (error) {
                        })
                    }
                } else {
                    $scope.card.bindCardType = '01'; //只绑定借记卡
                    var _promise = ElectroinicAccountService.addBindCardInfo(angular.extend($scope.user, $scope.card));
                    _promise.then(function (ret) {
                        $scope.cards = new Array();
                        queryBindCardInfo();
                        $state.go("financeCenter.bindCardInfo", {'cardStyle': 'bank'});
                    }, function (ret) {
                    });
                }
            }
            //解绑绑定到电子账户的银行卡
            $scope.unBindingCard = function (card) {
                if ($scope.cards.length == '1') {

                    $state.go("financeCenter.unBindCardInfo", {"card": card, 'isOnlyOne': true});

                } else {
                    $state.go("financeCenter.unBindCardInfo", {"card": card, 'isOnlyOne': false});
                }

            }

            //会员卡资产页
            $scope.toMemberCard = function(){
              $state.go("financeCenter.memberCardDetail",{'from': $scope.from});
            }
            //返回个人财富
            $scope.goBack = function () {
                if($scope.from == 'home'){
                  $state.go("tab.home");
                }else {
                  $state.go("tab.self");
                }
            };

            $scope.viewSupportBank = function () {
                ViewSupportBank();
            };
        }])
    .controller('FinanceunBindCardInfoCtrl', ['$scope', '$state', '$stateParams', 'ElectroinicAccountService', '$cordovaToast', '$transactionPassword', 'EncodePassword',
        function ($scope, $state, $stateParams, ElectroinicAccountService, $cordovaToast, $transactionPassword, EncodePassword) {

            $scope.card = $stateParams.card;
            $scope.isOnlyOne = $stateParams.isOnlyOne;
            //解绑银行卡
            $scope.unBindBankCardSubmit = function () {
                //如果只有一张银行卡，就为‘更换银行卡’
                //解绑银行卡
                if ($scope.isOnlyOne) {
                    // $cordovaToast.show('至少保留一张绑定的银行卡', 'long', 'center');
                    //!TODO 20161110 如果今天晚上核心功能上成功，这次的版本就上‘更换银行卡功能’
                    $state.go('financeCenter.changeBindCard');
                    return;
                }

                $transactionPassword({scope: $scope})
                    .then(function (password) {
                        EncodePassword.encrypt("11", password)
                            .then(function (password) {
                                $scope.card.password = password;
                                ElectroinicAccountService.unBindBankCard($scope.card);
                            });
                    });


            };

        }])
    .controller('FinanceRegularMoneyCtrl', ['$scope', '$state', '$stateParams', '$ionicHistory', '$ionicSlideBoxDelegate', '$PFHttpResource', 'RestFulURLConstants', '$interval', 'RegularData', '$timeout', 'loadingTextService',
        function ($scope, $state, $stateParams, $ionicHistory, $ionicSlideBoxDelegate, $PFHttpResource, RestFulURLConstants, $interval, RegularData, $timeout, loadingTextService) {
            $scope.regularFlag = RegularData.activeRegularIndex || 0;
            $scope.isExcuteEnd = false;
            $scope.isForceReload = !!$stateParams.isForceReload || false;
            $scope.actionStatus = $stateParams.actionStatus || '';
            $scope.isAndroid = ionic.Platform.isAndroid();
            $scope.loadingTxt = loadingTextService.getRandomTxt();

            if($scope.isForceReload) {
                $scope.regularList = {
                    owned: [],
                    redeem: [],
                    fail: [],
                    currentPage: [0, 0, 0],
                    hasMore: [true, true, true]
                };
                $scope.regularFlag = 0;
            } else {
                $scope.regularList = RegularData.saveRegularData;
                $scope.isForceReload = true;
            }

            $scope.tabsData = [
                {index: 0, title: "持有中"},
                {index: 1, title: "已赎回"},
                {index: 2, title: "已流标"}
            ];

            //手势状态联动
            $scope.$watch("regularFlag", function (value) {
                RegularData.activeRegularIndex = value;
                $ionicSlideBoxDelegate.slide(value);
                switch (value) {
                    case 0:
                        if($scope.regularList['owned'].length===0) {
                            $scope.isShowLoadingOfRegular1 = true;
                            $scope.getRegulars(value);
                        }
                        break;
                    case 1:
                        if($scope.regularList['redeem'].length===0) {
                            $scope.isShowLoadingOfRegular2 = true;
                            $scope.getRegulars(value);
                        }
                        break;
                    case 2:
                        if($scope.regularList['fail'].length===0) {
                            $scope.isShowLoadingOfRegular3 = true;
                            $scope.getRegulars(value);
                        }
                        break;
                }
            });

            $scope.regularSlideChanged = function (index) {
                $scope.regularFlag = index;
            };
            $scope.goBack = function () {
                $state.go('tab.self');
            };
            $scope.toRegularInfo = function (id, status) {
                $state.go('financeCenter.regularInfo', {"id": id, "actionStatus": status});
                return false;
            };

            $scope.getTypeByFlag = function(value) {
                var flagType = null;
                switch (value) {
                    case 0:
                        flagType = 'owned';
                        $scope.isShowLoadingOfRegular1 = false;
                        break;
                    case 1:
                        flagType = 'redeem';
                        $scope.isShowLoadingOfRegular2 = false;
                        break;
                    case 2:
                        flagType = 'fail';
                        $scope.isShowLoadingOfRegular3 = false;
                        break;
                }
                return flagType;
            };

            $scope.setLoadingFalse = function(value) {
                switch (value) {
                    case 0:
                        $scope.isShowLoadingOfRegular1 = false;
                        break;
                    case 1:
                        $scope.isShowLoadingOfRegular2 = false;
                        break;
                    case 2:
                        $scope.isShowLoadingOfRegular3 = false;
                        break;
                }
            };

            //获取getRegulars列表信息 flag:0代表持有中，1代表已赎回，2代表已流标
            $scope.getRegulars = function (flag, direction) {
                var flagType = null;
                $scope.isExcuteEnd = false;
                $scope.regularList.currentPage[flag]++;
                new $PFHttpResource(RestFulURLConstants.personCenter.getRegulars2, {status: flag, pageNo: $scope.regularList.currentPage[flag]}, null, {show: false}).then(function (data) {
                    if($scope.regularList.currentPage[flag] > data.context.data.orderListCount) {
                        $scope.regularList.hasMore[flag] = false;
                        $scope.regularList.currentPage[flag]--;
                        $scope.setLoadingFalse(flag);
                        $scope.isExcuteEnd = true;
                        return;
                    }
                    flagType = $scope.getTypeByFlag(flag);
                    $scope.regularList[flagType] = $scope.regularList[flagType].concat(data.context.data.orderList);
                    RegularData.saveRegularData = $scope.regularList;
                    $scope.isExcuteEnd = true;
                    if(direction === 'loadMore') {
                        $scope.$broadcast('scroll.infiniteScrollComplete');
                        /*$scope.loadTimer = $timeout(function(){
                         $scope.$apply(function(){ $scope.$broadcast('scroll.infiniteScrollComplete');});
                         },1000);*/
                    }
                }, function (error) {
                    $scope.setLoadingFalse(flag);
                    $scope.isExcuteEnd = true;
                });
                //$scope.isExcuteEnd = true;
            };

            //下拉刷新
            $scope.doRefreshRegularList = function () {
                var flagType = $scope.getTypeByFlag($scope.regularFlag);
                $scope.regularList[flagType] = [];
                $scope.regularList.currentPage[$scope.regularFlag] = 0;
                $scope.isExcuteEnd = false;
                new $PFHttpResource(RestFulURLConstants.personCenter.getRegulars2, {status: $scope.regularFlag, pageNo: 1}, null, {show: false}).then(function (data) {
                    //$scope.isShowLoadingOfRegular1 = false;
                    if(data.context.data.orderListCount <= 1) {
                        $scope.regularList.hasMore[$scope.regularFlag] = false;
                    } else {
                        $scope.regularList.hasMore[$scope.regularFlag] = true;
                    }
                    $scope.regularList.currentPage[$scope.regularFlag] = 1;
                    $scope.regularList[flagType] = data.context.data.orderList;
                    $scope.$broadcast('scroll.refreshComplete');
                    $timeout(function() {
                        $scope.loadingTxt = loadingTextService.getRandomTxt();
                        $scope.isExcuteEnd = true;
                    }, 1000);
                }, function (error) {
                    $scope.$broadcast('scroll.refreshComplete');
                    $timeout(function() {
                        $scope.loadingTxt = loadingTextService.getRandomTxt();
                        $scope.isExcuteEnd = true;
                    }, 1000);
                });
            };

            //销毁资源
            $scope.$on('$destroy', function () {
                //$interval.cancel($scope.loadInterval);
                $timeout.cancel($scope.loadTimer);
            });

            //上拉加载更多
            $scope.loadMoreData = function() {
                $scope.getRegulars($scope.regularFlag, 'loadMore');
            };

        }])
    .controller('FinanceRegularInfoCtrl', ['$scope', '$state', '$stateParams', '$ionicHistory', '$ionicSlideBoxDelegate', '$PFHttpResource', 'RestFulURLConstants', '$interval', 'RegularData',
        function ($scope, $state, $stateParams, $ionicHistory, $ionicSlideBoxDelegate, $PFHttpResource, RestFulURLConstants, $interval, RegularData) {
            $scope.actionStatus = $stateParams.actionStatus || '';
            $scope.isAndroid = ionic.Platform.isAndroid();

            if (!$scope.isForceReload) {
                $scope.isShowLoadingOfRegular = false;
            }

            $scope.toBackRegular = function () {
                $state.go('financeCenter.regularMoney', {'isForceReload': false});
            };

            //获取getRegulars列表信息
            $scope.getRegulars = function () {
                $scope.isForceReload = true;
                $scope.regularList = RegularData.saveRegularData;
                var dataMap = {
                    "orderNo": "订单号",
                    "prjCode": "项目编号",
                    "orderTime": "购买时间",//原 购买日
                    "payTime": "得到支付结果时间",
                    "orderSort": "订单顺序",
                    "orderAmount": "购买金额",
                    "orderParts": "订单份额",
                    "acctno": "回款账号",
                    "acctname": "回款账户名",
                    "expectIncome": "收益",
                    "investRate": "预期收益率",
                    "prjName": "项目名称",
                    "orderStatusName": "订单状态",//状态名称
                    "investLimit": "投资期限",
                    "interestBeginDate": "起息日",
                    "redeemStyle": "赎回方式",
                    "repayDate": "到期日",
                    "meneyFloat": "本金去向",
                    "extraIncome": "额外收益"
                };
                $scope.showAttrs = [];
                if ($scope.actionStatus == 'owned') {
                    $scope.viewTitle = "持有中";
                    $scope.showAttrs = ["orderNo", "prjName", "orderAmount", "investRate", "expectIncome", "investLimit", "orderTime", "interestBeginDate", "repayDate", "redeemStyle", "orderStatusName"];//缺赎回方式
                } else if ($scope.actionStatus == 'redeem') {
                    $scope.viewTitle = "已赎回";
                    $scope.showAttrs = ["orderNo", "prjName", "orderAmount", "investRate", "expectIncome", "extraIncome", "investLimit", "orderTime", "interestBeginDate", "repayDate", "redeemStyle", "orderStatusName"];//缺赎回方式
                }
                else if ($scope.actionStatus == 'fail') {
                    $scope.viewTitle = "已流标";
                    $scope.showAttrs = ["orderNo", "prjName", "orderAmount", "investRate", "investLimit", "orderTime"];//缺赎回方式，流标日不显示
                }
                $scope.regularInfo = [];
                $scope.data = {};
                $scope.searchData = $scope.regularList[$scope.actionStatus];
                angular.forEach($scope.searchData, function (data, index) {
                    if ($scope.searchData[index]['orderNo'] == $stateParams.id) {
                        $scope.data = $scope.searchData[index];
                    }
                });
                for (var item in $scope.showAttrs) {
                    var obj = {'key': '', 'value': ''},
                        data = $scope.data[$scope.showAttrs[item]],
                        attr = $scope.showAttrs[item],
                        value = "";
                    obj.key = dataMap[attr];
                    if (attr == "redeemStyle") {
                        value = "到期一次性还本付息";
                    } else if (!!data && ((obj.key).indexOf('期限') != -1 || (obj.key).indexOf('率') != -1)) {
                        if ((obj.key).indexOf('期限') != -1) {
                            value = data + "天";
                        } else if ((obj.key).indexOf('率') != -1) {
                            value = data + "%";
                        }
                    } else {
                        value = data;
                    }
                    obj.value = value;
                    $scope.regularInfo.push(obj);
                }
                $interval.cancel($scope.loadInterval);
            };

            //进入后触发 第一次等待刷新 之后静默刷新
            $scope.$on("$ionicView.beforeEnter", function (event) {
                $scope.getRegulars();
            });
        }])
    .controller('FinanceRechargeCtrl', ['$scope', '$ionicHistory', '$state', '$ionicModal', '$ionicBackdrop', 'UserInfoService', 'GenerateTransactionSerialNoService', '$transactionPassword', 'ElectroinicAccountService', 'DevelopmentModeConstants', 'EncodePassword', '$filter', '$cordovaToast','$ionicPopup', '$PFHttpResource', 'RestFulURLConstants', 'MobileValidateCodeTypeConstants', 'SendValidateCodeService',
        function ($scope, $ionicHistory, $state, $ionicModal, $ionicBackdrop, UserInfoService, GenerateTransactionSerialNoService, $transactionPassword, ElectroinicAccountService, DevelopmentModeConstants, EncodePassword, $filter, $cordovaToast, $ionicPopup, $PFHttpResource, RestFulURLConstants, MobileValidateCodeTypeConstants, SendValidateCodeService) {

            $scope.backViewName = $ionicHistory.backView().title;

            $scope.bankcard = {
                oid: '', defaultTransferAcct: '', nowTransferAcct: ''
            };

            $scope.cards = new Array();
            var type = "01";//查询借记卡
            ElectroinicAccountService.queryBindCardInfo($scope, type);
            $scope.account = {
                turnOutType: false,
                amount: ''
            };

            //他行充值已经修改卡手机号type
            $scope.mobileVerCode = {
                recharge:MobileValidateCodeTypeConstants.RECHARGE,
                changeBankMobile:MobileValidateCodeTypeConstants.CHANGE_BANK_MOBILE
            };

            //发送手机验证码
            var submitPhoneCode = function (code, type, phoneNumber) {
                return new $PFHttpResource(
                    RestFulURLConstants.publicService.checkVerificationCode,
                    {
                        userAccount:phoneNumber,
                        type:type,
                        verificationCode:code
                    }
                );
            };

            //付款确认手机验证码组件，方法参数
            $scope.recharPhoneCodeAction = {
                //现在不自动发送验证码了
                // initAction:function () {
                //     this.sendCode();
                // },
                phoneCodeObj:{}
            };
            $scope.changePhNumAction = {
                phoneCodeObj:{}
            };

            //他行充值，验证手机验证码
            var rechargeConfirm = function () {
                $scope.confirmModel = {};
                var popModel = $scope.rechargeConfirmModel = $ionicPopup.show({
                    title: '付款确认', // String. The title of the popup.
                    cssClass: 'popup-white', // String, The custom CSS class name
                    subTitle: '', // String (optional). The sub-title of the popup.
                    template: '', // String (optional). The html template to place in the popup body.
                    templateUrl: 'modules/finance/templates/rechargeConfirm.html', // String (optional). The URL of an html template to place in the popup   body.
                    scope: $scope, // Scope (optional). A scope to link to the popup content.
                    buttons: [{ // Array[Object] (optional). Buttons to place in the popup footer.
                        text: '取消',
                        type: 'button-default',
                        onTap: function(e) {
                            return;
                        }
                    }, {
                        text: '确认',
                        type: 'button-panda',
                        onTap: function(e) {
                            // e.preventDefault() will stop the popup from closing when tapped.
                            e.preventDefault();
                            if ($scope.confirmModel.rechargeVeriCode) {
                                //验证码和充值信息一起提交
                                $scope.recharge();
                                // //提交验证手机码
                                // submitPhoneCode($scope.confirmModel.rechargeVeriCode, $scope.mobileVerCode.recharge.type, $scope.bankcard.cellPhone)
                                //     .then(function (data) {
                                //         $scope.recharge();
                                //         //手机码验证正确，关闭弹出窗
                                //         popModel.close();
                                //     });
                            }

                        }
                    }]
                });
            };

            //更改手机号
            $scope.changePhoneNum = function () {
                delete $scope.confirmModel.newPhone;
                var popModel = $ionicPopup.show({
                    title: '更改手机号', // String. The title of the popup.
                    cssClass: 'popup-white',
                    templateUrl: 'modules/finance/templates/changePhoneNum.html', // String (optional). The URL of an html template to place in the popup   body.
                    scope: $scope, // Scope (optional). A scope to link to the popup content.
                    buttons: [{ // Array[Object] (optional). Buttons to place in the popup footer.
                        text: '取消',
                        type: 'button-default',
                        onTap: function(e) {
                            //!! 觉得不合适，需求要求点击取消，两个弹出框都关闭
                            // 但我认为应该返回到‘付款确认’弹出框
                            $scope.rechargeConfirmModel.close();
                            return;
                        }
                    }, {
                        text: '确认',
                        type: 'button-panda',
                        onTap: function(e) {
                            // e.preventDefault() will stop the popup from closing when tapped.
                            e.preventDefault();
                            //无法识别html模板form上的name $scope.changePhoneNumForm.$valid
                            if ($scope.confirmModel.newPhone && $scope.confirmModel.changeVeriCode && (($scope.confirmModel.newPhone+'') != ($scope.bankcard.cellPhone+''))) {
                                //提交验证手机码
                                submitPhoneCode($scope.confirmModel.changeVeriCode, $scope.mobileVerCode.changeBankMobile.type, $scope.confirmModel.newPhone)
                                    .then(function (data) {
                                        //验证手机码成功，清除验证码倒计时
                                        SendValidateCodeService.clearValidateCode('reChP');
                                        submitPhoneChange()
                                            .then(function (data) {
                                                if (data.context.result) {
                                                    popModel.close();
                                                    //现在更改手机号成功以后就直接充值成功
                                                    $scope.rechargeConfirmModel.close();
                                                    $scope.recharge();
                                                    //改变bankCard上的手机号，以及cards数组中的cellPhone
                                                    changeCardCellPhone();
                                                    //回到充值确认Pop弹出框后,根据新的手机号重新发送手机验证码
                                                    // $scope.recharPhoneCodeAction.forceSendCode($scope.bankcard.cellPhone);
                                                }
                                            });
                                    });
                            }

                        }
                    }]
                });
            };

            //改变缓存中卡上的绑定手机号
            var changeCardCellPhone = function () {
                $scope.bankcard.cellPhone = $scope.confirmModel.newPhone;
                for(var i in $scope.cards){
                    if ($scope.cards[i].transoid == $scope.transoid){
                        $scope.cards[i].cellPhone = $scope.confirmModel.newPhone;
                        break;
                    }
                }
            };

            //提交修改手机号
            var submitPhoneChange = function () {
                return new $PFHttpResource(RestFulURLConstants.finance.assets.changeCellPhone,{mobileNo:$scope.confirmModel.newPhone,cardId:$scope.transoid});
            };

            //充值提交
            $scope.submitRecharge = function () {
                //他行充值需要手机验证码
                if ($scope.bankcard.isThisBank == 'N'){
                    rechargeConfirm();
                    return;
                }

                $scope.recharge();
            };

            /**
             * 发送充值请求
             * @param encryptedPW 加密后的密码
             */
            var chargeRequest = function (encryptedPW) {
                $scope.account.trandPassWord = encryptedPW;
                $scope.account.transType = "0";
                var obj = angular.extend({
                    "defaultTransferAcct": $scope.bankcard.oid,
                    "serialNo": $scope._serialNo,
                    //更换手机号成功后直接充值，就不发送验证码了(changeVeriCode为改变手机的验证码)
                    verificationCode: (!$scope.confirmModel || $scope.confirmModel.changeVeriCode) ? undefined : $scope.confirmModel.rechargeVeriCode
                }, $scope.account);
                //充值提交
                ElectroinicAccountService.electroinicAccountRecharge(obj,function () {
                    if ($scope.rechargeConfirmModel){
                        $scope.rechargeConfirmModel.close();
                        SendValidateCodeService.clearValidateCode('reCon');
                    }
                },function (data) {
                    if (data.data.type != 'validException')
                        SendValidateCodeService.clearValidateCode('reCon');
                });
            };

            //开始输入交易密码进行充值
            $scope.recharge = function () {
                var _parameters = {
                    userAccount: UserInfoService.getUserInfo().userAccount,
                    transamount: $scope.account.transamount.toString().trim(),
                    payerAccNo: $scope.transoid,
                    type: "dynamicAccount",
                    transType: "0",//充值:0
                    key: $filter('uppercase')(CryptoJS.SHA1(UserInfoService.getUserInfo().userAccount + $scope.transoid + $scope.account.transamount.toString().trim()).toString())
                };
                GenerateTransactionSerialNoService.generateTransactionSerialNo(_parameters)
                    .then(function (data) {
                        if (data && data.context.result) {
                            $scope._serialNo = data.context.result.serialNo;
                            $scope.confirmTransamount = data.context.result.transamount;

                            if($scope.bankcard.isThisBank == 'N'){
                                chargeRequest(null);
                            }else {
                                $transactionPassword({scope: $scope})
                                    .then(function (password) {
                                        EncodePassword.encrypt("11", password)
                                            .then(function (ret) {
                                                chargeRequest(ret);
                                            })
                                    });
                            }
                        } else {
                            $cordovaToast.show("产生流水号失败!", 'long', 'center');
                        }
                    });
            };

            //更换充值银行卡模态框
            $ionicModal.fromTemplateUrl('modules/finance/templates/choiceBindCardModel.html', {
                scope: $scope,
                animation: 'slide-in-up',
                backdropClickToClose: false
            }).then(function (modal) {
                $scope.modal = modal;
            });
            //关闭充值银行卡模态框
            $scope._closeChoiceBankCardModal = function () {
                $scope.modal.hide();
                $ionicBackdrop.release();
            };
            //Cleanup the modal when we're done with it!
            $scope.$on('$destroy', function () {
                $scope.modal.remove();
                $ionicBackdrop.release();
            });
            //选择银行卡-弹出模态框
            $scope.choiceBankCard = function () {
                $ionicBackdrop.retain();
                $scope.modal.show();
            };
            $scope.$on('modal.hidden', function() {
                $ionicBackdrop.release();
            });
            //选择充值银行卡
            $scope.choiseRechargeBankCard = function (obj) {
                $ionicBackdrop.release();
                $scope.modal.hide();
                $scope.bankcard.oid = obj.oid;
                $scope.bankcard.nowTransferAcct = obj.bankacct;   //充值界面显示更换的银行卡
                $scope.bankcard.bankname = obj.bankname;
                $scope.bankcard.bankCardIcon = obj.bankCardIcon;
                $scope.bankcard.cellPhone = obj.cellPhone;
                $scope.bankcard.isThisBank = obj.isThisBank;
                $scope.transoid = obj.transoid;

            };
        }])
    .controller('FinanceDepositCtrl', ['$scope', '$ionicHistory', '$state', '$ionicModal', '$ionicBackdrop', 'UserInfoService', 'GenerateTransactionSerialNoService', 'ElectroinicAccountService', '$transactionPassword', 'DevelopmentModeConstants', 'EncodePassword', 'RestFulURLConstants', '$PFHttpResource', '$filter', '$cordovaToast','SendValidateCodeService', 'MobileValidateCodeTypeConstants','$ionicPopup',
        function ($scope, $ionicHistory, $state, $ionicModal, $ionicBackdrop, UserInfoService, GenerateTransactionSerialNoService, ElectroinicAccountService, $transactionPassword, DevelopmentModeConstants, EncodePassword, URLConstants, Resource, $filter, $cordovaToast, SendValidateCodeService, MobileValidateCodeTypeConstants, $ionicPopup) {

            $scope.backViewName = $ionicHistory.backView().title;

            $scope.account = {
                turnOutType: false,
                amount: ''
            };
            $scope.bankcard = {
                oid: '', defaultTransferAcct: '', nowTransferAcct: '', isThisBank: ''
            };
            $scope.cards = new Array();
            var type = "01";//查询借记卡
            ElectroinicAccountService.queryAcctCardInfo($scope, type);


            function queryOnlyElectroinicAmount() {
                var _promise = ElectroinicAccountService.queryOnlyElectroinicAmount($scope);
                _promise.then(function (data) {
                    if (data.context && data.context.result) {
                        $scope.account.amount = data.context.result.acctAmount.availBal; //电子账户可用余额
                        //$scope.account.isThisBank = data.context.result.bindCardInfo.isThisBank;  //是否本行卡
                        //查询绑定银行卡信息
                    }
                }, function (data) {
                });
            };

            //queryOnlyElectroinicAmount();

            //提现 提交
            $scope.turnOutSetting = function () {
                if ($scope.account.turnOutType) {
                    $scope.account.transamount = parseFloat($scope.account.amount);
                } else {
                    $scope.account.transamount = null;
                }
            }
            //弹出密码输入框
            $scope.submitDeposit = function () {
                var _parameters = {
                    userAccount: UserInfoService.getUserInfo().userAccount,
                    transamount: $scope.account.transamount.toString().trim(),
                    payeeAccNo: $scope.transoid,
                    type: "dynamicAccount",
                    transType: "1",//提现:1
                    key: $filter('uppercase')(CryptoJS.SHA1(UserInfoService.getUserInfo().userAccount + $scope.transoid + $scope.account.transamount.toString().trim()).toString())
                };
                GenerateTransactionSerialNoService.generateTransactionSerialNo(_parameters).then(function (data) {
                    if (data && data.context.result) {
                        $scope._serialNo = data.context.result.serialNo;
                        $scope.confirmTransamount = data.context.result.transamount;

                        $transactionPassword({scope: $scope})
                            .then(function (password) {
                                if (!DevelopmentModeConstants.debug) {
                                    var _promise = EncodePassword.encrypt("11", password);
                                    _promise.then(function (ret) {
                                        $scope.account.trandPassWord = ret;
                                        $scope.account.transType = "1";
                                        var obj = angular.extend({
                                            "defaultTransferAcct": $scope.bankcard.oid,
                                            "bankacct": $scope.bankcard.nowTransferAcct,
                                            "serialNo": $scope._serialNo,
                                            verificationCode:$scope.user.verificationCode
                                        }, $scope.account);
                                        ElectroinicAccountService.electroinicAccountEnchash(obj,function () {
                                            SendValidateCodeService.clearValidateCode();
                                        },function (data) {
                                            if (data.data.type != 'validException')
                                                SendValidateCodeService.clearValidateCode();
                                        });
                                    }, function (error) {

                                    })
                                } else {
                                    $scope.account.trandPassWord = password;
                                    $scope.account.transType = "1";
                                    var obj = angular.extend({
                                        "defaultTransferAcct": $scope.bankcard.oid,
                                        "bankacct": $scope.transoid,
                                        "serialNo": $scope._serialNo,
                                        verificationCode:$scope.user.verificationCode
                                    }, $scope.account);
                                    ElectroinicAccountService.electroinicAccountEnchash(obj,function () {
                                        SendValidateCodeService.clearValidateCode();
                                    },function (data) {
                                        if (data.data.type != 'validException')
                                            SendValidateCodeService.clearValidateCode();
                                    });
                                }
                            });
                    } else {
                        $cordovaToast.show("产生流水号失败!", 'long', 'center');
                    }
                });
            }
            //更换充值银行卡模态框
            $ionicModal.fromTemplateUrl('modules/finance/templates/choiceBindCardModel.html', {
                scope: $scope,
                animation: 'slide-in-up',
                backdropClickToClose: false
            }).then(function (modal) {
                $scope.modal = modal;
            });
            //关闭充值银行卡模态框
            $scope._closeChoiceBankCardModal = function () {
                $scope.modal.hide();
                $ionicBackdrop.release();
            };
            //Cleanup the modal when we're done with it!
            $scope.$on('$destroy', function () {
                $scope.modal.remove();
                $ionicBackdrop.release();
            });
            //选择银行卡-弹出模态框
            $scope.choiceBankCard = function () {
                $ionicBackdrop.retain();
                $scope.modal.show();
            };
            $scope.$on('modal.hidden', function() {
                $ionicBackdrop.release();
            });
            //选择提现银行卡
            $scope.choiseRechargeBankCard = function (obj) {
                $ionicBackdrop.release();
                $scope.modal.hide();
                $scope.bankcard.nowTransferAcct = obj.bankacct;   //充值界面显示更换的银行卡
                $scope.bankcard.isThisBank = obj.isThisBank;
                $scope.bankcard.bankname = obj.bankname;
                $scope.bankcard.bankCardIcon = obj.bankCardIcon;
                $scope.bankcard.oid = obj.oid;
                $scope.transoid = obj.transoid;
            }

            //(20160822 add by yanliang)提现时，需要验证手机验证码
            $scope.shortMessageValidateCode = function () {
                $scope.passPhoneCode = false;
                SendValidateCodeService.sendValidateCode($scope, MobileValidateCodeTypeConstants.ENCASH);
            };
            $scope.user ?
                $scope.user.cellPhone = UserInfoService.getUserInfo().cellPhone :
                $scope.user = {cellPhone:UserInfoService.getUserInfo().cellPhone}

            //提交前需要验证校验码是否正确
            $scope.submit = function () {
                //20160919 modify by yanliang 提现把手机验证码发过去统一验证。
                $scope.submitDeposit();

                // if($scope.isSendTimeLimit && $scope.passPhoneCode){
                //     $scope.submitDeposit();
                //     return;
                // }
                //
                // new Resource(URLConstants.publicService.checkVerificationCode,{userAccount:UserInfoService.getUserInfo().userAccount,type:MobileValidateCodeTypeConstants.ENCASH.type,verificationCode:$scope.user.verificationCode})
                //     .then(function (data) {
                //         //校验码成功后再提交业务数据
                //         $scope.submitDeposit();
                //         $scope.passPhoneCode = true;
                //     });
            }

        }])
    .controller('FinanceTradeDetailCtrl', ['$scope', '$state', '$timeout', '$cordovaDatePicker', 'ElectroinicAccountService', '$cordovaToast', function ($scope, $state, $timeout, $cordovaDatePicker, ElectroinicAccountService, $cordovaToast) {
        var now = new Date();
        $scope.date = now;
        //调用Cordova日期控件
        $scope.showDetail = false;
        var optionsStart = {
            date: $scope.date,
            mode: 'date', // or 'time'
            allowOldDates: true,
            allowFutureDates: false,
            doneButtonLabel: 'DONE',
            doneButtonColor: '#F2F3F4',
            cancelButtonLabel: 'CANCEL',
            cancelButtonColor: '#000000'
        };
        var optionsEnd = {
            date: new Date(),
            mode: 'date', // or 'time'
            minDate: $scope.date,
            allowOldDates: false,
            allowFutureDates: false,
            doneButtonLabel: 'DONE',
            doneButtonColor: '#F2F3F4',
            cancelButtonLabel: 'CANCEL',
            cancelButtonColor: '#000000'
        };
        document.addEventListener("deviceready", function () {
            $scope.startDateFn = function () {
                $cordovaDatePicker.show(optionsStart).then(function (date) {
                    $scope.date = date;
                    $scope.startDate = date.toLocaleDateString();
                });
            }
            $scope.endDateFn = function () {
                if (!$scope.startDate) {
                    $cordovaToast.show('请先输入开始日期', "long", "center");
                    return;
                }
                $cordovaDatePicker.show(optionsEnd).then(function (date) {
                    $scope.endDate = date.toLocaleDateString();
                });
            }
        }, false);
        //默认显示最近一个月明细
        $scope.queryCon = {
            type: '01',
            limit: 30,
            beginDate: null,
            endDate: null,
            page: 0, //页码初始化成0,访问之前加1
            hasMore: false
        };
        queryTradeDetail($scope);
        $scope.tradeDetails = [];
        function queryTradeDetail($scope, type) {
            $scope.flag = false;
            $scope.queryCon.page++;
            var _promise = ElectroinicAccountService.queryTradeDetail($scope);
            _promise.then(function (data) {
                if(data.context){
                  $scope.queryCon.hasMore = data.context.hasNext || false;
                }
                if (data.context && data.context.LIST) {
                    //$scope.queryCon.hasMore = true;
                    $scope.flag = true;
                    $scope.tradeDetails = $scope.tradeDetails.concat(data.context.LIST);
                }else{
                  $scope.queryCon.hasMore = false;
                }
            }, function (data) {
              $scope.queryCon.hasMore = false;
            });
        }

        //
        $scope.queryTransDetails = function (type) {
            $scope.tradeDetails = [];//切换tab后，清除数据
            angular.element(document.getElementById("buttonBar")).children().removeClass('active');
            angular.element(document.getElementById(type)).addClass('active');
            if (type == 'date') {
                if (!$scope.startDate || !$scope.endDate) {
                    $cordovaToast.show('请先输入查询日期', "long", "center");
                } else {
                    $scope.queryCon.type = '02';
                    var dateA = $scope.startDate.split("/");
                    var dateY = dateA[0];
                    var dateM = dateA[1] > 10 ? dateA[1] : "0" + dateA[1];
                    var dateD = dateA[2] > 10 ? dateA[2] : "0" + dateA[2];
                    $scope.queryCon.beginDate = dateY + dateM + dateD;
                    var dateA = $scope.endDate.split("/");
                    var dateY = dateA[0];
                    var dateM = dateA[1] > 10 ? dateA[1] : "0" + dateA[1];
                    var dateD = dateA[2] > 10 ? dateA[2] : "0" + dateA[2];
                    $scope.queryCon.endDate = dateY + dateM + dateD;
                    if ($scope.queryCon.beginDate > $scope.queryCon.endDate) {
                        $cordovaToast.show('开始日期不能大于结束日期', "long", "center");
                        return;
                    }
                    queryTradeDetail($scope, 'date');
                }
            }
            if (type == '7') {
                $scope.queryCon.type = '01';
                $scope.queryCon.limit = 7;
                $scope.queryCon.page = 0;//初始化页码为1
                $scope.queryCon.hasMore = false;
                queryTradeDetail($scope, '7');
            }
            if (type == '30') {
                $scope.queryCon = {
                    type: '01',
                    limit: 30,
                    page: 0,//初始化页码为1
                    hasMore: false
                };
                queryTradeDetail($scope, '30');
            }
            if (type == '90') {
                $scope.queryCon = {
                    type: '01',
                    limit: 90,
                    page: 0,//初始化页码为1
                    hasMore: false
                };
                queryTradeDetail($scope, '90');
            }
        }
        //doFresh test
        $scope.loadMore = function () {
          $scope.showLoading = false;
          queryTradeDetail($scope);
          $timeout(function(){
            $scope.$apply(function(){ $scope.$broadcast('scroll.infiniteScrollComplete');});
            //$scope.$broadcast('scroll.infiniteScrollComplete');
          },1000);
        }

        //
        $scope.moreDataCanBeLoaded = function () {
          return $scope.queryCon.hasMore;
        }
        //返回财富URL
        $scope.goBack = function () {
            $state.go('tab.self');
        }
    }])
    .controller('FinanceAssetsDetailCtrl', ['$scope', '$state', 'FinanceService','UserDataService', 'UserInfoService', '$ionicPopup', '$ionicHistory',
        function ($scope, $state, FinanceService,UserData, UserInfoService, $ionicPopup, $ionicHistory) {
            //$scope.isShowLoading = true;
            var params = $state.params;
            var paramsData = params.data;
            $scope.totalAmount = paramsData.totalAmount;
            $scope.user = {};
            if(paramsData.amountList.length > 0){
              $scope.user.amountList = paramsData.amountList; //列表已经格式化，直接显示在页面
              var colorArr = ["#6fb3e8", "#ffd45f", "#faab4d", "#f96c41", "#d385d8", "#aee491"]; //颜色数组
              var dataArr = [];
              var dataColorArr = [];
              var index = 0;
              angular.forEach($scope.user.amountList,function(item){
                if(!item.indent){
                  var dataItem = {};
                  dataItem.value = Number(item.value);
                  dataItem.name = item.name;
                  item.color = colorArr[index++];
                  dataColorArr.push(item.color);
                  dataArr.push(dataItem);
                }
              });
              var totalAmountDom = document.getElementById('totalAmountDom');
              var totalAmountStr = $scope.totalAmount + "";
              if(totalAmountStr.length <= 6){
                totalAmountDom.style.fontSize = '28px';
              }else if(totalAmountStr.length <= 11){
                totalAmountDom.style.fontSize = '24px';
              }else if(totalAmountStr.length <= 14){
                totalAmountDom.style.fontSize = '20px';
              }else{
                totalAmountDom.style.fontSize = '11px';
              }

              FinanceService.showAssetsDoughnutDetail(dataArr,dataColorArr);
            }
            //返回财富URL
            $scope.goBack = function () {
              $state.go('tab.self');
            }
  }])
    .controller('FinanceMemberCardDetailCtrl', ['$scope', '$state', 'ElectroinicAccountService','UserDataService', 'UserInfoService', '$ionicPopup', '$ionicHistory',
        function ($scope, $state, ElectroinicAccountService,UserData, UserInfoService, $ionicPopup, $ionicHistory) {
          var paramsData = $state.params;
          $scope.user = {};
          $scope.user.dlCard = {};
          $scope.$on('$ionicView.beforeEnter', function (e) {
            var promise = ElectroinicAccountService.queryMemberCardDetail($scope);
            promise.then(function(data){
              if(data.context && data.context.result){
                var res = data.context.result;
                $scope.user.dlCard.cardInfo = res.cardInfo || {};
                $scope.user.dlCard.cardAmount = res.cardAmount;
                $scope.user.dlCard.generalCard = res.generalCard;
                $scope.user.dlCard.goldCard = res.goldCard;
              }
            });
          });
          //返回财富URL
          $scope.goBack = function () {
            $state.go('financeCenter.bindCardInfo', {'cardStyle': 'membership', 'from': paramsData.from});
          }
    }])
    .controller('FinanceSettingCtrl', ['$stateParams', 'GestureService','UserDataService', 'UpdateApkService', '$scope', '$state', '$window', 'UserInfoService', '$PFHttpResource', 'RestFulURLConstants', 'localStorageServices', 'WebStorageConstants', '$ionicPopup', '$ionicHistory', 'ChannelConstants', 'MessageService', '$rootScope',
        function ($stateParams, GestureService,UserData, UpdateApkService, $scope, $state, $window, UserInfoService, Resource, URLConstants, localStorageServices, WebStorageConstants, $ionicPopup, $ionicHistory, ChannelConstants, MessageService, $rootScope) {
            $scope.toGobackUrl = 'tab.self';
            //返回财富URL
            $scope.goBack = function () {
                $state.go($scope.toGobackUrl);
            };
            $scope.isShowSetExitBtn = ChannelConstants.isShowSetExitBtn;
            $scope.user = {};
            $scope.user = UserInfoService.getUserInfo();
            $scope.user.isAuthenUser = UserInfoService.isAuthenUser();
            //查询开户行
            Resource(URLConstants.personCenter.queryAcctInfo).then(function (data) {
                if (data && data.context) {
                    $scope.user.userName = data.context.acctInfo.userName;
                    $scope.user.branchName = data.context.acctInfo.branchName;
                    $scope.user.electronAcct = data.context.acctInfo.electronAcct;
                }
            }, function (err) {
            });
            //退出
            $scope.signOut = function () {
                Resource(URLConstants.userManagement.signOut);
                $scope.user=null;
                UserData.userData={};
                GestureService.removeGesture();
                UserInfoService.removeUserInfo();
                $ionicHistory.clearHistory();
                $ionicHistory.clearCache();
                $state.go("tab.home");
                //取消获取未读消息
                MessageService.cancelGetUserMsgReadFlag();
            };
            //联系客户
            $scope.contactCustomerService = function () {
                var confirmPopup = $ionicPopup.confirm({
                    title: '温馨提示',
                    template: '请拨打客户服务热线&nbsp;&nbsp;40016-96869',
                    okText: '拨打',
                    okType: 'button-panda',
                    cancelText: '取消'
                });
                confirmPopup.then(function (res) {
                    if (res) {
                        $window.location.href = "tel:4001696869";
                    } else {
                    }
                });
            }

            $scope.goMsgCenter = function () {
                $state.go('personCenter.messageNotice');
                $rootScope.messageNotice_activeType = 'public';
            };

            $scope.toQuestion = function () {
                $state.go("security.familiarBreakdown");
            }

            $scope.checkApkUpdate = function () {
                if (ionic.Platform.isAndroid()) {
                    UpdateApkService.checkeApkUpdate(true);
                }
            };
            if($stateParams.comeFrom === "messageCenter") {
              //查看是否有未读消息
              MessageService.getUserMsgReadFlag();
            }
        }])
    .controller('FinanceFundDayIncomeCtrl', ['$scope', '$stateParams', function ($scope, $stateParams) {
        $scope.dayIncomes = $stateParams.dayIncomes;
    }])
    //修改绑定卡
    .controller('changeBindCardCtrl', ['$scope', '$state', '$ionicPopup', '$transactionPassword', '$ionicModal', 'SendValidateCodeService', '$stateParams', 'ElectroinicAccountService', 'DistinguishBankTypeService', '$cordovaToast', 'DevelopmentModeConstants', 'EncodePassword', 'MobileValidateCodeTypeConstants', 'JudgmentSimplePwdService', 'ViewSupportBank', 'BusinessConfirmModal',
        function ($scope, $state, $ionicPopup, $transactionPassword, $ionicModal, SendValidateCodeService, $stateParams, ElectroinicAccountService, DistinguishBankTypeService, $cordovaToast, DevelopmentModeConstants, EncodePassword, MobileValidateCodeTypeConstants, JudgmentSimplePwdService, ViewSupportBank, BusinessConfirmModal) {
            $scope.user = {};

            $scope.card = {};
            $scope.card.isThisBank = '';
            function calculateDiscount(newValue) {
                if (newValue && newValue.length == 6) {
                    DistinguishBankTypeService.distinguishBankType(newValue, $scope);
                } else if (newValue && newValue.length < 6) {
                    $scope.card.cardPassword = null;
                    $scope.card.banktype = null;
                    $scope.card.bankname = null;
                    $scope.card.showFlag = false;
                    $scope.user.cellPhone = null;
                    $scope.user.verificationCode = null;
                }
            }

            $scope.$watch("card.bankacct", calculateDiscount);
            //银行卡输入域离开 校验
            $scope.validBankCardType = function () {
                var _bankAcctNo = $scope.card.bankacct;
                var _bankType = $scope.card.banktype;
                if (_bankAcctNo != null && _bankAcctNo.length >= 6 && _bankType == null) {
                    DistinguishBankTypeService.distinguishBankType(_bankAcctNo.substr(0, 6), $scope);
                }
            }
            //弹出密码框
            $scope.showPasswordModal = function () {
                $scope.keyboardTitle = '输入卡密码';
                $transactionPassword({scope: $scope})
                    .then(function (password) {
                        $scope.card.cardPassword = password;
                    });
            }

            //银行卡每四位隔开空字符
            $scope.fourSpaceStr = function (data) {
                var index = 0;
                var resultText = "";
                while (index < data.length){
                    var lastIndex = index + (data.length - index > 4 ? 4 : data.length - index);
                    resultText += (data.substring(index,lastIndex)+" ");

                    index = lastIndex;
                }
                return resultText;
            };

            var bindCardSuccess = function () {
                BusinessConfirmModal({
                    type: "success",
                    header: "更换成功",
                    title: "更换银行卡成功",
                    subTitle: "更换后银行卡号：" + $scope.fourSpaceStr($scope.card.bankacct),
                    subTitleStyle: {'font-size':'4vmin'}
                }).then(function (result) {
                    $state.go("financeCenter.bindCardInfo", {'cardStyle': 'bank'});
                });
            };

            //新增绑定卡
            $scope.submitBindCard = function () {
                //保存加挂卡信息
                if (!DevelopmentModeConstants.debug && $scope.card.isThisBank === 'Y') {
                    if (JudgmentSimplePwdService.judgmentSimplePwd($scope.card.cardPassword)) {
                        var _promise = EncodePassword.encrypt("11", $scope.card.cardPassword, $scope.card.bankacct);
                        _promise.then(function (ret) {
                            $scope.card.cardPassword = ret;
                            $scope.card.bindCardType = '01'; //只绑定借记卡
                            var _promise = ElectroinicAccountService.changeBindCard(angular.extend($scope.user, $scope.card));
                            _promise.then(function (ret) {
                                bindCardSuccess();
                            }, function (ret) {
                                $scope.card.cardPassword = null;
                            });
                        }, function (error) {
                        })
                    }
                } else {
                    $scope.card.bindCardType = '01'; //只绑定借记卡
                    var _promise = ElectroinicAccountService.changeBindCard(angular.extend($scope.user, $scope.card));
                    _promise.then(function (ret) {
                        bindCardSuccess();
                    }, function (ret) {
                    });
                }
            }

            $scope.viewSupportBank = function () {
                ViewSupportBank();
            };
        }]);
