/**
 * Created by Z.ZR on 2015/11/15.
 */

"use strict";
angular.module('pfApp')
    .factory('FinanceService', ['$state', '$PFHttpResource', 'RestFulURLConstants', 'BusinessConfirmModal', '$filter',
        function ($state, Resource, URLConstants, BusinessConfirmModal, $filter) {
            /**
             * 产品信息：是否后台维护还是今天数据需确认
             * @type {*[]}
             */
            var products = [
                {
                    productType: 'xmb',
                    src: 'img/finance/max.png',
                    typeName: '熊猫宝',
                    totalMondy: '2001',
                    yesterdayIncome: '3.4'
                },
                {
                    productType: 'tpyl',
                    src: 'img/finance/max.png',
                    typeName: '熊猫宝',
                    totalMondy: '2001',
                    yesterdayIncome: '3.4'
                }
            ];
            /**
             * 1、查询总资产，昨日收益，累计收益，电子账号，绑定卡号
             * 2、查询各个已购买产品的昨日收益，总金额，七日年化率
             * @private
             */
            var _queryFinanceInfo = function (obj) {
                var _promise = Resource(URLConstants.finance.assets.queryUserTotalAssetsInfo, {}, {}, {show: obj.isShowLoading});
                return _promise;
            };
            var _queryFinanceInfoShow = function (obj) {
                var _promise = Resource(URLConstants.finance.assets.queryUserTotalAssetsInfoShow);
                return _promise;
            };
            var _queryProductBuyInfo = function (obj) {
                var _promise = Resource(URLConstants.financeBusiness.pandaTreasure.queryPandaIncome, obj);
                return _promise;
            };
            var _queryXmbHistoryDetail = function (obj) {
                var _promise = Resource(URLConstants.financeBusiness.pandaTreasure.queryFundHistoryDetail, obj.product);
                return _promise;
            };
            var _showSevenDayProfitChart = function (sevenDayProfitNavDate, sevenDayProfitNav, millionProfit) {
                var ctx = document.getElementById("sevenDayProfitPie").getContext("2d");
                var ctx1 = document.getElementById("sevenDayProfitBar").getContext("2d");
                var lineChartData = {
                    labels: sevenDayProfitNavDate,
                    datasets: [
                        {
                            fillColor: "rgba(249,108,65,0.15)",
                            strokeColor: "rgba(249,108,65,1)",
                            pointColor: "rgba(249,108,65,1)",
                            pointStrokeColor: "#fff",
                            pointHighlightFill: "#fff",
                            pointHighlightStroke: "rgba(249,108,65,1)",
                            data: sevenDayProfitNav
                        }
                    ]
                }
                var barChartData = {
                    labels: sevenDayProfitNavDate,
                    datasets: [
                        {
                            label: "",
                            fillColor: "rgba(249,108,65,0.15)",
                            strokeColor: "rgba(249,108,65,1)",
                            pointColor: "rgba(249,108,65,1)",
                            pointStrokeColor: "#fff",
                            pointHighlightFill: "#fff",
                            pointHighlightStroke: "rgba(249,108,65,1)",
                            data: millionProfit
                        }
                    ]
                }
                new Chart(ctx).Line(lineChartData, {
                    responsive: true,
                    pointDotRadius: 5,
                    datasetStrokeWidth: 0.5,
                    scaleLineWidth: 0.5,
                    scaleLineColor: "rgba(151,187,205,1)",
                    animationSteps: 30
                });
                new Chart(ctx1).Line(barChartData, {
                    responsive: true,
                    pointDotRadius: 5,
                    datasetStrokeWidth: 0.5,
                    scaleLineWidth: 0.5,
                    scaleLineColor: "rgba(151,187,205,1)",
                    animationSteps: 30
                });
            }
            //资金明细饼状环图
            var _showAssetsDoughnutDetail = function (dataArr, dataColorArr) {
              var option = {
                tooltip : {
                  trigger: 'item',
                  formatter: "{b} <br/>  {c} ({d}%)"
                },
                calculable : false,
                series : [
                  {
                    name:'资产来源',
                    type:'pie',
                    radius : ['70%', '90%'],
                    itemStyle : {
                      normal : {
                        label : {
                          show : false
                        },
                        labelLine : {
                          show : false
                        }
                      },
                      emphasis : {
                        label : {
                          show : false,
                          position : 'center',
                          textStyle : {
                            fontSize : '10',
                            fontWeight : 'bold'
                          }
                        }
                      }
                    },
                    data: dataArr
                  }
                ],
              color: dataColorArr
              };

              //var ctx = document.getElementById("assetsDoughnutDetail").getContext("2d");
              var myChart = echarts.init(document.getElementById("assetsDoughnutDetail"));
              myChart.setOption(option);
            };

            //净值走势图
            var _showDavListLineChart = function (canvasChart, data) {
                var dateArr = [];
                var dataArr = [];
                var len = data.length;
                for(var i = len-1; i >= 0; i--) {
                  if(i != 0 && i != len - 1) {
                    dateArr.push('');
                  } else {
                    dateArr.push(data[i].navDate);
                  }
                  dataArr.push(data[i].nav);
                }

                canvasChart.Line({
                  labels: dateArr,
                  datasets: [
                    {
                      label: "净值走势",
                      fillColor: "rgba(249,108,65,0.15)",
                      strokeColor: "rgba(249,108,65,1)",
                      pointColor: "rgba(249,108,65,1)",
                      pointStrokeColor: "#fff",
                      pointHighlightFill: "#fff",
                      pointHighlightStroke: "rgba(249,108,65,1)",
                      data: dataArr
                    }
                  ]
                }, {
                  responsive: true,
                  scaleLabel: "<%=value +''%>",
                  pointDotRadius: 0,
                  datasetStrokeWidth: 0.5,
                  scaleLineWidth: 0.5,
                  scaleLineColor: "rgba(151,187,205,1)",
                  animationSteps: 30,
                  scaleShowGridLines: true,
                  boxWidth: 50,
                  xTextDirectionHorizon: true,
                  scaleShowVerticalLines: false,
                  showTooltips: false
                });
            };

            //产品赎回
            var _redeemProduct = function (obj) {
                var _promise = Resource(URLConstants.financeBusiness.pandaTreasure.saleFund, obj);
                _promise.then(function (data) {
                    var productName = '';
                    if ('ZS0003' == obj.productType) {
                        productName = '润金宝';
                    } else if ('ZS0002' == obj.productType) {
                        productName = '熊猫宝';
                    } else if ('ZS0005' == obj.productType) {
                      productName = '周周盈';
                    }
                    var confirmObj = {
                      type: "success",
                      header: "赎回成功",
                      title: "赎回成功",
                      subTitle: "赎回的金额：" + $filter("currency")(obj.saleAmount, "") + "元",
                      message: "温馨提示,您已成功从" + productName + "赎回&nbsp; " + obj.saleAmount + "&nbsp;份，赎回的金额（" + $filter("currency")(obj.saleAmount, "") + "）元已实时转入电子账户。"
                    };
                    if('ZS0005' == obj.productType){
                      confirmObj.title = '交易成功';
                      var date = new Date();
                      var dateStr = date.getFullYear()+ '-' + (date.getMonth() > 8 ? '':'0') + (date.getMonth()+1)+'-'+ date.getDate();
                      confirmObj.subTitle = "<div style=\"height: 30px; font-size: 18px;\">申赎基金："+ productName+" </div> <div style=\"height: 30px; font-size: 18px;\">申赎份数：<span style=\"color: red;\">" + (obj.saleAmount.toString().trim()) + "份</span></div><div style=\"height: 30px; font-size: 18px;\">交易申请日：" + dateStr+"</div>" ;
                      confirmObj.message = "";
                    }
                    BusinessConfirmModal(confirmObj).then(function (result) {
                          $state.go("tab.self");
                      });
                }, function (data) {
                });
            }
            //更改签约卡
            var _changeFundCard = function (obj) {
              var _promise = Resource(URLConstants.financeBusiness.pandaTreasure.changeFundCard, obj);
              return _promise;
            };
            //熊猫宝购买
            var _xmbFundBuy = function (obj) {
                var _promise = Resource(URLConstants.financeBusiness.pandaTreasure.buyFund, obj);
                _promise.then(function (data) {
                    if(data.context.transDate) {
                        var transDate=data.context.transDate.replace(/^(\d{4})(\d{2})(\d{2})$/,'$1'+'-'+'$2'+'-'+'$3');
                    }
                    var confirmObj = {
                        type: "success",
                        header: "购买成功",
                        title: "交易成功",
                        subTitle: "购买金额：" + $filter("currency")(obj.applicationAmount, '') + "元",
                        message: ''
                    };
                    if ('ZS0002' == obj.productType) {
                        confirmObj.message = "<span style='font-weight: bold;'>购买</span><br><span style='padding-left: 32px'>每个工作日15点前完成购买，T+1个工作日开始计算收益，T+2个工作日可看到收益；15点后完成购买，计算收益及看到收益时间顺延一个工作日。</span><br>" +
                            "<span style='font-weight: bold;'>赎回</span><br><span style='padding-left: 32px'>单笔限额20万（含），每日限额100万（含），赎回实时到账。</span>";
                    } else if ('ZS0003' == obj.productType) {
                        confirmObj.message = "<span style='font-weight: bold;'>购买</span> <br> <span style='padding-left: 32px'>每个工作日15点前完成购买，T+1个工作日开始计算收益，T+2个工作日可看到收益；15点后完成购买，计算收益及看到收益时间顺延一个工作日。</span>" +
                            "<br><span style='font-weight: bold;'>赎回</span> <br><span style='padding-left: 32px'>每日100万（含）以下赎回实时到账，100万以上赎回T+2个工作日内到账。</span>";
                    } else if ('ZS0005' == obj.productType) {
                        confirmObj.message = "<span style=\"color:red; font-size:14px;\" class=\"ion-ios-information-outline\"></span> <span style=''>温馨提示：账户资金冻结，交易申请将于"+transDate+"提交给基金公司</span>";
                    }
                    BusinessConfirmModal(confirmObj).then(function (result) {
                        $state.go("tab.self");
                    });
                }, function (data) {
                    /*BusinessConfirmModal({
                        type: "error",
                        header: "购买失败",
                        title: "交易失败",
                        message: "温馨提示," + data.data.message
                    }).then(function (result) {
                        $state.go("tab.self");
                    });*/
                });
            }
            //查询购买历史
            var _buyDetails = function (obj) {
                var _promise = Resource(URLConstants.productMessage.queryNotificationMessage, obj);
                return _promise;
            }
            // 查询净值列表
            var _queryNavList = function (obj){
                var _promise = Resource(URLConstants.financeBusiness.pandaTreasure.navList, obj, {}, {show: false});
                return _promise;
            }
            //查询产品协议
            var _queryProductProtocol = function (obj) {
                var _promise = Resource(URLConstants.finance.assets.queryFundProductProtocol, obj);
                return _promise;
            }
            //查询日收益明细
            var _queryProductDayIncomeHistory = function (obj) {
                var _promise = Resource(URLConstants.financeBusiness.pandaTreasure.queryPandaFundDayIncome, obj);
                return _promise;
            };
            //周周盈赎回判断
            var _checkRedeem = function (obj) {
                return Resource(URLConstants.finance.assets.checkRedeem, obj);
            };
            return {
                queryFinanceInfo: function (obj) {
                    return _queryFinanceInfo(obj);
                },
                queryFinanceInfoShow: function (obj) {
                    return _queryFinanceInfoShow(obj);
                },
                queryProductBuyInfo: function (obj) {
                    return _queryProductBuyInfo(obj);
                },
                queryProductHistoryDetail: function (obj) {
                    return _queryXmbHistoryDetail(obj);
                },
                showSevenDayProfitChart: function (sevenDayProfitNavDate, sevenDayProfitNav, millionProfit) {
                    return _showSevenDayProfitChart(sevenDayProfitNavDate, sevenDayProfitNav, millionProfit);
                },
                showAssetsDoughnutDetail: function (dataArr, dataColorArr) {
                  return _showAssetsDoughnutDetail(dataArr, dataColorArr);
                },
                showDavListLineChart: function (canvasChart, data) {
                  return _showDavListLineChart(canvasChart, data);
                },
                redeemProduct: function (obj) {
                    return _redeemProduct(obj);
                },
                changeFundCard: function (obj) {
                  return _changeFundCard(obj);
                },
                xmbFundBuy: function (obj) {
                    return _xmbFundBuy(obj);
                },
                buyDetails: function (obj) {
                    return _buyDetails(obj);
                },
                queryNavList: function(obj){
                    return _queryNavList(obj);
                },
                queryProductProtocol: function (obj) {
                    return _queryProductProtocol(obj);
                },
                queryProductDayIncomeHistory: function (obj) {
                    return _queryProductDayIncomeHistory(obj);
                },
                checkRedeem: function(obj) {
                    return _checkRedeem(obj);
                },
                userData:{}
            };
        }])
    .factory('ElectroinicAccountService', ['$state', '$ionicHistory', '$PFHttpResource', 'RestFulURLConstants', 'BusinessConfirmModal', '$filter',
        function ($state, $ionicHistory, Resource, URLConstants, BusinessConfirmModal, $filter) {
            /**
             * 查询电子账户信息
             * 1、电子账号&余额
             * 2、电子账号绑定的卡号
             * 3、随心存累计收益
             * 4、电子账号一个月的收入与支出
             * @returns {*[]}
             */
            var _electroinicAccount = function (obj) {
                var _promise = Resource(URLConstants.finance.assets.electronicAccount);
                return _promise;
            }
            var _electroinicTradeDetail = function (obj) {
                var _promise = Resource(URLConstants.finance.assets.queryElectronicAccountTradeDetail, obj.queryCon);
                return _promise;
            }
            var _memberCardDetail = function (obj) {
              var _promise = Resource(URLConstants.finance.assets.queryDLMemberCardDetail);
              return _promise;
            }
            //查询绑定卡信息
            var _queryBindCardInfo = function (_obj, _bindCardType) {

                Resource(URLConstants.finance.assets.queryBindCardInfo, {"bindCardType": _bindCardType})
                    .then(function (data) {
                        if (data && data.context.result) {
                            if (data.context.result) {
                                _obj.cards = data.context.result;
                            }

                            //查询默认的充值账号（银行卡）
                            var isHasDefault = false;

                            angular.forEach(_obj.cards, function (obj) {
                                if (obj.isDefaultCard == 'Y') {
                                    isHasDefault = true;
                                    _obj.bankcard.oid = obj.oid;
                                    _obj.bankcard.bankname = obj.bankname;
                                    _obj.bankcard.bankCardIcon = obj.bankCardIcon;
                                    _obj.bankcard.nowTransferAcct = obj.bankacct;
                                    _obj.bankcard.isThisBank = obj.isThisBank;
                                    _obj.transoid = obj.oid;
                                    _obj.bankcard.cellPhone = obj.cellPhone;
                                }
                            });

                            if (!isHasDefault) {
                                _obj.bankcard.oid = _obj.cards[0].oid;
                                _obj.bankcard.bankname = _obj.cards[0].bankname;
                                _obj.bankcard.bankCardIcon = _obj.cards[0].bankCardIcon;
                                _obj.bankcard.nowTransferAcct = _obj.cards[0].bankacct;
                                _obj.bankcard.isThisBank = _obj.cards[0].isThisBank;
                                _obj.transoid = _obj.cards[0].oid;
                                _obj.bankcard.cellPhone = _obj.cards[0].cellPhone;
                            }

                        }
                    });
            }

            //查询绑定卡及余额信息 added by lzh 2016/6/15
            var _queryAcctCardInfo = function (_obj, _bindCardType) {
              Resource(URLConstants.finance.assets.queryAcctCardInfo, {"bindCardType": _bindCardType})
                .then(function (data) {
                  if (data && data.context.result) {
                    if (data.context.result) {
                      _obj.cards = data.context.result;
                    }

                    if (data.context.acctInfo) {
                      _obj.account.amount = data.context.acctInfo.acctAmount.availBal;
                    }

                    //查询默认的充值账号（银行卡）
                    var isHasDefault = false;

                    angular.forEach(_obj.cards, function (obj) {
                      if (obj.isDefaultCard == 'Y') {
                        isHasDefault = true;
                        _obj.bankcard.oid = obj.oid;
                        _obj.bankcard.bankname = obj.bankname;
                        _obj.bankcard.bankCardIcon = obj.bankCardIcon;
                        _obj.bankcard.nowTransferAcct = obj.bankacct;
                        _obj.bankcard.isThisBank = obj.isThisBank;
                        _obj.transoid = obj.oid;
                      }
                    });

                    if (!isHasDefault) {
                      _obj.bankcard.oid = _obj.cards[0].oid;
                      _obj.bankcard.bankname = _obj.cards[0].bankname;
                      _obj.bankcard.bankCardIcon = _obj.cards[0].bankCardIcon;
                      _obj.bankcard.nowTransferAcct = _obj.cards[0].bankacct;
                      _obj.bankcard.isThisBank = _obj.cards[0].isThisBank;
                      _obj.transoid = _obj.cards[0].oid;
                    }

                  }
                });
            }
            //查询绑定卡信息-未处理
            var _queryBindCardList = function (obj) {
                var _promise = Resource(URLConstants.finance.assets.queryBindCardInfo, {"bindCardType": null});
                return _promise;
            }
            var _changeBindCardInfo = function (obj) {
                var _promise = Resource(URLConstants.finance.assets.changeBindCardInfo, angular.extend(obj.card, obj.user));
                _promise.then(function (data) {
                    $state.go("tab.self");
                }, function (data) {
                });
            }
            //提现
            var _electroinicAccountEnchash = function (obj,succCallback,errorCallback) {
                var _promise = Resource(URLConstants.finance.assets.electroinicAccountEnchash, obj);
                _promise.then(function (data) {
                    BusinessConfirmModal({
                        type: "success",
                        header: "提现",
                        title: "交易成功",
                        subTitle: "提现金额：" + $filter("currency")(obj.transamount, '') + "元",
                        message: "温馨提示,您已从电子账户成功提现" + $filter("currency")(obj.transamount, '') + "元。"
                    }).then(function (result) {
                        $ionicHistory.goBack();
                    });
                    if (succCallback)
                        succCallback(data);
                }, function (data) {
                    if (errorCallback)
                        errorCallback(data);
                });
            }
            //充值
            var _electroinicAccountRecharge = function (obj,succCallback,errorCallback) {

                Resource(URLConstants.finance.assets.electroinicAccountRecharge, obj)
                    .then(function (data) {
                        BusinessConfirmModal({
                            type: "success",
                            header: "充值",
                            title: "交易成功",
                            subTitle: "充值金额：" + $filter("currency")(obj.transamount, '') + "元",
                            message: "温馨提示,您已成功为电子账户充值" + $filter("currency")(obj.transamount, '') + "元。"
                        }).then(function (result) {
                            $ionicHistory.goBack();
                        });

                        if(succCallback){
                            succCallback(data);
                        }
                    }, function (data) {
                        if (errorCallback)
                            errorCallback(data);
                    });
            }
            //查询电子账户余额
            var _queryOnlyElectroinicAmount = function (obj) {
                var _promise = Resource(URLConstants.finance.assets.queryOnlyElectronicAccount);
                return _promise;
            }
            //解绑指定银行卡
            var _unBindBankCard = function (obj) {
                Resource(URLConstants.finance.assets.unBindBankCard, {"oid": obj.oid, 'password': obj.password})
                    .then(function (data) {
                        $state.go("financeCenter.bindCardInfo", {'cardStyle': 'bank'});
                    });
            };
            //新增绑定银行卡
            var _addBindCardInfo = function (obj) {
                var _promise = Resource(URLConstants.finance.assets.addBindCardInfo, obj);
                return _promise;
            }
            //查询银行存款利率
            var _queryBankDepositRate = function (obj) {
                var _promise = Resource(URLConstants.finance.assets.queryBankDepositRate);
                return _promise;
            }
            //更换绑定银行卡
            var _changeBindCard = function (obj) {
                return Resource(URLConstants.finance.assets.changeBindCard, obj);
            };
            return {
                electroinicAccount: function (obj) {
                    return _electroinicAccount(obj);
                },
                queryBindCardInfo: function (obj, bindCardType) {
                    return _queryBindCardInfo(obj, bindCardType);
                },
                queryAcctCardInfo:function(obj, bindCardType){
                  return _queryAcctCardInfo(obj, bindCardType);
                },
                //其他地方没有用到的方法？更换绑定银行卡（担心其他地方会用到，重新写了changeBindCard方法）？
                changeBindCardInfo: function (obj) {
                    return _changeBindCardInfo(obj);
                },
                queryTradeDetail: function (obj) {
                    return _electroinicTradeDetail(obj);
                },
                queryMemberCardDetail: function (obj) {
                  return _memberCardDetail(obj);
                },
                electroinicAccountRecharge: function (obj) {
                    return _electroinicAccountRecharge(obj,arguments[1],arguments[2]);
                },
                electroinicAccountEnchash: function (obj) {
                    return _electroinicAccountEnchash(obj,arguments[1],arguments[2]);
                },
                queryOnlyElectroinicAmount: function (obj) {
                    return _queryOnlyElectroinicAmount(obj);
                },
                unBindBankCard: function (obj) {
                    return _unBindBankCard(obj);
                },
                addBindCardInfo: function (obj) {
                    return _addBindCardInfo(obj);
                },
                queryBindCardList: function (obj) {
                    return _queryBindCardList(obj);
                },
                queryBankDepositRate: function (obj) {
                    return _queryBankDepositRate(obj);
                },
                //更换绑定银行卡
                changeBindCard: function (obj) {
                    return _changeBindCard(obj);
                }
            };
        }])
    .factory('RegularData', [function () {
        return {
            saveRegularData: {},
            activeRegularIndex: 0,
            isBackForceReload: false
        };
    }]);
