/**
 * Created by Z.JM on 2015/11/10.
 */

"use strict";
angular.module('pfApp').config(['$stateProvider', '$urlRouterProvider', '$ocLazyLoadProvider', 'RouterLevel', function ($stateProvider, $urlRouterProvider, $ocLazyLoadProvider, RouterLevel) {
    $stateProvider

    // setup an abstract state for the tabs directive
        .state('financeBusiness', {
            url: '/financeBusiness',
            abstract: true,
            resolve: $ocLazyLoadProvider.ocLazyLoadDependency('financeBusinessModule', 'finance'),
            data: {
                $stateLevel: RouterLevel.ANY_ONE
            }
        })

        // Each tab has its own nav history stack:
        .state('financeBusiness.pandaTreasure', {
            url: '/pandaTreasure',
            params: {
                fromName: '首页',
                from: "tab.home",
                provider: null,
                product: null
            },
            cache: false,
            views: {
                '@': {
                    resolve: $ocLazyLoadProvider.ocLazyLoadDependency('chart', 'echarts'),
                    templateUrl: function($routeParams){
                     if($routeParams.product.productCode == 'ZS0005'){
                       return 'modules/financeBusiness/templates/pandaTreasureForYkx.html';
                    }else{
                       return 'modules/financeBusiness/templates/pandaTreasure.html';
                     }
                    },
                    controller: 'FinanceBusinessPandaTreasureCtrl'
                }
            },
            data: {
                $stateLevel: RouterLevel.ANY_ONE
            }
        })
        .state('financeBusiness.orderList', {
          url: '/orderList',
          params: {
            fromName: '周周盈',
            from: "financeBusiness.pandaTreasure",
            totalAmount: null,
            copies: null,
            productType: null
          },
          cache: false,
          views: {
            '@': {
              templateUrl: 'modules/financeBusiness/templates/orderList.html',
              controller: 'FinanceBusinessOrderListCtrl'
            }
          },
          data: {
            $stateLevel: RouterLevel.ANY_ONE
          }
        })
        .state('financeBusiness.navList', {
          url: '/navList',
          params: {
            fromName: '周周盈',
            from: "financeBusiness.pandaTreasure",
            provider: null,
            product: null
          },
          cache: false,
          views: {
            '@': {
              templateUrl: 'modules/financeBusiness/templates/navList.html',
              controller: 'FinanceBusinessNavListCtrl'
            }
          },
          data: {
            $stateLevel: RouterLevel.ANY_ONE
          }
        })
        .state('financeBusiness.pandaTreasureSign', {
            url: '/pandaTreasureSign',
            params: {
                fromName: '首页',
                from: "tab.home",
                provider: null,
                product: null,
                signInfo: null
            },
            cache: false,
            views: {
                '@': {
                    templateUrl: 'modules/financeBusiness/templates/pandaTreasureSign.html',
                    controller: 'FinanceBusinesspandaTreasureSignCtrl'
                }
            },
            data: {
                $stateLevel: RouterLevel.AUTHEN_USER
            }
        })
        .state('financeBusiness.pandaTreasureSignThirdpart', {
            url: '/pandaTreasureSignThirdpart',
            params: {
                fromName: '首页',
                from: "tab.home",
                provider: null,
                product: null
            },
            cache: false,
            views: {
                '@': {
                    templateUrl: 'modules/financeBusiness/templates/pandaTreasureSignThirdpart.html',
                    controller: 'FinanceBusinesspandaTreasureSignThirdpartCtrl'
                }
            },
            data: {
                $stateLevel: RouterLevel.AUTHEN_USER
            }
        })
        .state('financeBusiness.pandaTreasureRiskAssessment', {
            url: '/pandaTreasureRiskAssessment',
            params: {
                fromName: '首页',
                from: "tab.home",
                provider: null,
                product: null
            },
            cache: false,
            views: {
                '@': {
                    templateUrl: 'modules/financeBusiness/templates/pandaTreasureRiskAssessment.html',
                    controller: 'FinanceBusinesspandaTreasureRiskAssessmentCtrl'
                }
            },
            data: {
                $stateLevel: RouterLevel.AUTHEN_USER
            }
        })
        .state('financeBusiness.pandaTreasureTransaction', {
            url: '/pandaTreasureTransaction',
            params: {
                fromName: '首页',
                from: "tab.home",
                provider: null,
                product: null
            },
            cache: false,
            views: {
                '@': {
                    templateUrl: 'modules/financeBusiness/templates/pandaTreasureTransaction.html',
                    controller: 'FinanceBusinessPandaTreasureTransactionCtrl'
                }
            },
            data: {
                $stateLevel: RouterLevel.AUTHEN_USER
            }
        })
        .state('financeBusiness.changeFundCard', {
            url: '/changeFundCard',
            params: {
                provider: null,
                product: null,
                signInfo:null
            },
            cache: false,
            views: {
                '@': {
                    templateUrl: 'modules/financeBusiness/templates/changeFundCard.html',
                    controller: 'changeFundCardCtrl'
                }
            },
            data: {
                $stateLevel: RouterLevel.AUTHEN_USER
            }
        });

    $stateProvider.state('invitationFinance', {
        url: '/invitationFinance',
        params: {
            product: null,
            provider: null
        },
        cache: false,
        views: {
            '@': {
                templateUrl: 'modules/financeBusiness/templates/invitationFinance.html',
                controller: 'InvitationFinanceCtrl'
            }
        },
        data: {
            $stateLevel: RouterLevel.ANY_ONE
        }
    });
}]);
