/**
 * Created by Z.JM on 2015/11/10.
 */
;
"use strict";

angular.module('pfApp')
    .controller('FinanceBusinessPandaTreasureCtrl', ['$scope', '$stateParams', '$ionicHistory', '$PFHttpResource', 'RestFulURLConstants', 'FinanceBusinessPandaTreasureService', 'FinanceService',  '$ionicPopup', '$state', '$filter', 'UserInfoService', '$ionicSlideBoxDelegate', 'EncodePassword', '$transactionPassword', 'DevelopmentModeConstants', '$cordovaToast',
        function ($scope, $stateParams, $ionicHistory, $PFHttpResource, RestFulURLConstants, FinanceBusinessPandaTreasureService, FinanceService, $ionicPopup, $state, $filter, UserInfoService, $ionicSlideBoxDelegate, EncodePassword, $transactionPassword, DevelopmentModeConstants, $cordovaToast) {
            $scope.fundHistoryDetail = null;
            $scope.productDetails = [];
            $scope.queryDates = 360; //4个slidebox, 需要的数据一次性取360条数据，若分开分时
            //获取参数
            $scope.backViewName = $state.params.fromName;
            $scope.provider = $stateParams.provider;
            $scope.product = $stateParams.product;

            $scope.product.productDesc = $scope.product.productDesc;
            $scope.product.productFeature = $scope.product.productFeature;
            convertAgreement($scope.product.productDetail, $scope.productDetails);



            $scope.buyPandaTreasure = function () {
                if (!UserInfoService.isLogin()) {
                    $ionicPopup.confirm({
                        title: "温馨提示",
                        template: "你还没有登录，去登录？",
                        cancelText: '取消',
                        okText: '确定',
                        okType: 'button-panda'
                    }).then(function (res) {
                        if (res) {
                            $state.go("security.login");
                        } else {

                        }
                    });
                } else if (!UserInfoService.isAuthenUser()) {
                    $ionicPopup.confirm({
                        title: "温馨提示",
                        template: "你还没有实名认证，去实名认证？",
                        cancelText: '取消',
                        okText: '确定',
                        okType: 'button-panda'
                    }).then(function (res) {
                        if (res) {
                            $state.go("personCenter.identification");
                        } else {

                        }
                    });
                } else {
                    new $PFHttpResource(RestFulURLConstants.financeBusiness.pandaTreasure.checkSignInfo, {productType: $scope.product.productCode}).then(function (data) {
                            //是否签约：是
                            if (data.context.isSign === 'Y') {
                                //签约账户是否是电子账户:是
                                if (data.context.isEletronAcct === 'Y') {
                                    //是否签约第三方协议
                                    if(angular.isUndefined(data.context.isNeedThirdpartSign) || data.context.isNeedThirdpartSign === 'Y') {
                                        //是否做过风险评估
                                        if (data.context.isRisk === 'Y') {
                                            if (parseInt(data.context.riskGrade || "01") < parseInt($scope.product.productRisklevel || "01")) {
                                                $ionicPopup.confirm({
                                                    title: "温馨提示",
                                                    template: "风险评估等级过低，请重新评估。",
                                                    cancelText: '取消',
                                                    okText: '确定',
                                                    okType: 'button-panda'
                                                }).then(function (res) {
                                                    if (res) {
                                                        $state.go("financeBusiness.pandaTreasureRiskAssessment", $stateParams);
                                                    } else {
                                                    }
                                                });
                                            } else {
                                                //去购买
                                                $state.go("financeBusiness.pandaTreasureTransaction", $stateParams);
                                            }
                                        } else {
                                            //去风险评估
                                            $ionicPopup.confirm({
                                                title: "温馨提示",
                                                template: "尚未风险评估或已过期，去风险评估？",
                                                cancelText: '取消',
                                                okText: '确定',
                                                okType: 'button-panda'
                                            }).then(function (res) {
                                                if (res) {
                                                    $state.go("financeBusiness.pandaTreasureRiskAssessment", $stateParams);
                                                } else {
                                                }
                                            });
                                        }
                                    } else {
                                        //去签约第三方协议
                                        $ionicPopup.confirm({
                                            title: "温馨提示",
                                            template: "您未签约第三方协议，去签约？",
                                            cancelText: '取消',
                                            okText: '确定',
                                            okType: 'button-panda'
                                        }).then(function (res) {
                                            if (res) {
                                                $state.go("financeBusiness.pandaTreasureSignThirdpart", $stateParams);
                                            } else {
                                            }
                                        });
                                    }


                                } else {
                                    //提示签约账户与电子账户不一致
                                    $ionicPopup.confirm({
                                        title: "温馨提示",
                                        template: "签约卡号不一致，无法购买" + ($scope.product.productName || '此理财产品') + "! 是否更换签约卡?",//lzh update 2016/6/28
                                        cancelText: "取消",
                                        cancelType: "button-default",
                                        okText: "确定",
                                        okType: "button-panda"
                                    }).then(function (res) {
                                        if (res) {
                                            //20160905 modify by yanliang 更换签约卡需要到新页面变更，并且显示新老签约卡
                                            $state.go('financeBusiness.changeFundCard', angular.extend({},$stateParams, {signInfo:data.context}));
                                            return;
                                        } else {

                                        }
                                    });
                                }

                            } else {
                                // 去签约，并且作风险评估
                                $ionicPopup.confirm({
                                    title: "温馨提示",
                                    template: "您未签约" + ($scope.product.productName || '此理财产品') + "，去签约？",
                                    cancelText: '取消',
                                    okText: '确定',
                                    okType: 'button-panda'
                                }).then(function (res) {
                                    if (res) {
                                        $state.go("financeBusiness.pandaTreasureSign", angular.extend({},$stateParams, {signInfo:data.context}));
                                    } else {
                                    }
                                });
                            }
                        },
                        function (error) {

                        });
                }

            };

            $scope.slideTo = function (index, src) {
                $ionicSlideBoxDelegate.slide(index);
              if(src === 'ykx') { //周周盈
                switch (index) {
                  case 0:
                    if(!$scope.canvasChart30) {
                      $scope.chartsLoading30 = true;
                      $scope.canvasChart30 = new Chart(document.getElementById("pandaTreasure30").getContext("2d"));
                      loadNavData($scope.canvasChart30, 1);
                    }
                    break;
                  case 1:
                    if(!$scope.canvasChart90) {
                      $scope.chartsLoading90 = true;
                      $scope.canvasChart90 = new Chart(document.getElementById("pandaTreasure90").getContext("2d"));
                      loadNavData($scope.canvasChart90, 3);
                    }
                    break;
                  case 2:
                    if(!$scope.canvasChart180) {
                      $scope.chartsLoading180 = true;
                      $scope.canvasChart180 = new Chart(document.getElementById("pandaTreasure180").getContext("2d"));
                      loadNavData($scope.canvasChart180, 6);
                    }
                    break;
                  case 3:
                    if(!$scope.canvasChart365) {
                      $scope.chartsLoading365 = true;
                      $scope.canvasChart365 = new Chart(document.getElementById("pandaTreasure365").getContext("2d"));
                      loadNavData($scope.canvasChart365, 12);
                    }
                    break;
                }
              }
            };

            //获取产品详细信息code
            function convertAgreement(agreementCodesString, agreements) {
                agreements = agreements || [];
                if (agreementCodesString) {
                    var agreementCodes = agreementCodesString.split(";");
                    angular.forEach(agreementCodes, function (agreementCode) {
                            var agreement = agreementCode.split(":");
                            if (agreement.length === 2) {
                                agreements.push({name: agreement[1], code: agreement[0]});
                            }
                        }
                    );
                }
            };

            function loadCharts() {
                $scope.chartsLoading = true;
                $scope.chartsLoadError = false;
                new $PFHttpResource(RestFulURLConstants.financeBusiness.pandaTreasure.queryFundHistoryDetail, {productType: $scope.product.productCode}, {}, {show: false}).then(function (data) {
                    $scope.chartsLoading = false;
                    $scope.chartsLoadError = false;
                    $scope.fundHistoryDetail = data;
                    drawCharts(data);
                }, function () {
                    $scope.chartsLoading = false;
                    $scope.chartsLoadError = true;
                });
            };

            function drawCharts(data) {
                $scope.chartsLoading = false;

                var pandaTreasureSevenDayProfitCanvasContext = document.getElementById("pandaTreasureSevenDayProfitCanvas").getContext("2d");
                var pandaTreasureMillionProfitCanvasContext = document.getElementById("pandaTreasureMillionProfitCanvas").getContext("2d");

                var pandaTreasureMillionProfitChart = new Chart(pandaTreasureMillionProfitCanvasContext);
                var pandaTreasureSevenDayProfitChart = new Chart(pandaTreasureSevenDayProfitCanvasContext);

                var pandaTreasureSevenDayProfitData = {
                    labels: [],
                    datasets: [
                        {
                            label: "近七日年化收益率",
                            fillColor: "rgba(249,108,65,0.15)",
                            strokeColor: "rgba(249,108,65,1)",
                            pointColor: "rgba(249,108,65,1)",
                            pointStrokeColor: "#fff",
                            pointHighlightFill: "#fff",
                            pointHighlightStroke: "rgba(249,108,65,1)",
                            data: []
                        }
                    ]

                };
                var pandaTreasureMillionProfitData = {
                    labels: [],
                    datasets: [
                        {
                            label: "日万分收益",
                            fillColor: "rgba(249,108,65,0.15)",
                            strokeColor: "rgba(249,108,65,1)",
                            pointColor: "rgba(249,108,65,1)",
                            pointStrokeColor: "#fff",
                            pointHighlightFill: "#fff",
                            pointHighlightStroke: "rgba(249,108,65,1)",
                            data: []
                        }
                    ]
                };

                for (var i = 0, n = data.context.result.length; i < n; i++) {

                    pandaTreasureSevenDayProfitData.labels[i] = data.context.result[i].navDate.substring('4');
                    pandaTreasureSevenDayProfitData.datasets[0].data[i] = data.context.result[i].yield;

                    pandaTreasureMillionProfitData.labels[i] = data.context.result[i].navDate.substring('4');
                    pandaTreasureMillionProfitData.datasets[0].data[i] = data.context.result[i].fundIncome;

                    if (i === 6) {
                        break;
                    }
                }

                pandaTreasureSevenDayProfitChart.Line(pandaTreasureSevenDayProfitData, {
                    responsive: true,
                    scaleLabel: "<%=value +''%>",
                    pointDotRadius: 5,
                    datasetStrokeWidth: 0.5,
                    scaleLineWidth: 0.5,
                    scaleLineColor: "rgba(151,187,205,1)",
                    animationSteps: 30
                });

                pandaTreasureMillionProfitChart.Line(pandaTreasureMillionProfitData, {
                    responsive: true,
                    scaleLabel: "<%=value +''%>",
                    pointDotRadius: 5,
                    datasetStrokeWidth: 0.5,
                    scaleLineWidth: 0.5,
                    scaleLineColor: "rgba(151,187,205,1)",
                    animationSteps: 30
                });
            }

            function drawNavCharts (data){
                var dateArr = [];
                var dataArr = [];
                var canvasContext30 = document.getElementById("pandaTreasure30").getContext("2d"),
                    canvasContext90 = document.getElementById("pandaTreasure90").getContext("2d"),
                    canvasContext180 = document.getElementById("pandaTreasure180").getContext("2d"),
                    canvasContext365 = document.getElementById("pandaTreasure365").getContext("2d"),
                    canvasChart30 = new Chart(canvasContext30),
                    canvasChart90 = new Chart(canvasContext90),
                    canvasChart180 = new Chart(canvasContext180),
                    canvasChart365 = new Chart(canvasContext365),
                    canvasData30 = null,
                    canvasData90 = null,
                    canvasData180 = null,
                    canvasData365 = null;

                for(var len = data.length-1; len >= 0; len--) {
                    dateArr.push(data[len].navDate);
                    dataArr.push(data[len].nav);
                }
                function filterArray(arr) {
                    var size = arr.length;
                    var tempArr = [];
                    for(var i = 0;i < size; i++) {
                        if(i != 0 && i != size - 1) {
                            tempArr[i] = '';
                        } else {
                            tempArr[i] = arr[i];
                        }
                    }
                    return tempArr;
                }
                canvasData30 = {
                    labels: filterArray(dateArr.slice(-30)),
                    datasets: [
                        {
                            label: "一个月净值走势",
                            fillColor: "rgba(249,108,65,0.15)",
                            strokeColor: "rgba(249,108,65,1)",
                            pointColor: "rgba(249,108,65,1)",
                            pointStrokeColor: "#fff",
                            pointHighlightFill: "#fff",
                            pointHighlightStroke: "rgba(249,108,65,1)",
                            data: dataArr.slice(-30)
                        }
                    ]
                };
                canvasData90 = {
                    labels: filterArray(dateArr.slice(-90)),
                    datasets: [
                        {
                            label: "三个月净值走势",
                            fillColor: "rgba(249,108,65,0.15)",
                            strokeColor: "rgba(249,108,65,1)",
                            pointColor: "rgba(249,108,65,1)",
                            pointStrokeColor: "#fff",
                            pointHighlightFill: "#fff",
                            pointHighlightStroke: "rgba(249,108,65,1)",
                            data: dataArr.slice(-90)
                        }
                    ]
                };
                canvasData180 = {
                    labels: filterArray(dateArr.slice(-180)),
                    datasets: [
                        {
                            label: "半年净值走势",
                            fillColor: "rgba(249,108,65,0.15)",
                            strokeColor: "rgba(249,108,65,1)",
                            pointColor: "rgba(249,108,65,1)",
                            pointStrokeColor: "#fff",
                            pointHighlightFill: "#fff",
                            pointHighlightStroke: "rgba(249,108,65,1)",
                            data: dataArr.slice(-180)
                        }
                    ]
                };
                canvasData365 = {
                    labels: filterArray(dateArr.slice(-365)),
                    datasets: [
                        {
                            label: "一年净值走势",
                            fillColor: "rgba(249,108,65,0.15)",
                            strokeColor: "rgba(249,108,65,1)",
                            pointColor: "rgba(249,108,65,1)",
                            pointStrokeColor: "#fff",
                            pointHighlightFill: "#fff",
                            pointHighlightStroke: "rgba(249,108,65,1)",
                            data: dataArr.slice(-365)
                        }
                    ]
                };

                var chartOptions = {
                    responsive: true,
                    scaleLabel: "<%=value +''%>",
                    pointDotRadius: 0,
                    datasetStrokeWidth: 0.5,
                    scaleLineWidth: 0.5,
                    scaleLineColor: "rgba(151,187,205,1)",
                    animationSteps: 30,
                    scaleShowGridLines: true,
                    boxWidth: 50,
                    xTextDirectionHorizon: true,
                    scaleShowVerticalLines: false,
                    showTooltips: false
                };

                canvasChart30.Line(canvasData30, chartOptions);
                canvasChart90.Line(canvasData90, chartOptions);
                canvasChart180.Line(canvasData180, chartOptions);
                canvasChart365.Line(canvasData365, chartOptions);
            }

            function loadNavData(canvasChart, num){
              FinanceService.queryNavList({productType: $scope.product.productCode, rowNumber: num}).then(function (data) {
                  //drawNavCharts(data.context.navList);
                  FinanceService.showDavListLineChart(canvasChart, data.context.navList);
                  switch (num) {
                    case 1:
                      $scope.chartsLoading30 = false;
                      $scope.chartsLoadError30 = false;
                      break;
                    case 3:
                      $scope.chartsLoading90 = false;
                      $scope.chartsLoadError90 = false;
                      break;
                    case 6:
                      $scope.chartsLoading180 = false;
                      $scope.chartsLoadError180 = false;
                      break;
                    case 12:
                      $scope.chartsLoading365 = false;
                      $scope.chartsLoadError365 = false;
                      break;
                  }

                }, function () {
                  switch (num) {
                    case 1:
                      $scope.canvasChart30 = null;
                      $scope.chartsLoading30 = false;
                      $scope.chartsLoadError30 = true;
                      break;
                    case 3:
                      $scope.canvasChart90 = null;
                      $scope.chartsLoading90 = false;
                      $scope.chartsLoadError90 = true;
                      break;
                    case 6:
                      $scope.canvasChart180 = null;
                      $scope.chartsLoading180 = false;
                      $scope.chartsLoadError180 = true;
                      break;
                    case 12:
                      $scope.canvasChart365 = null;
                      $scope.chartsLoading365 = false;
                      $scope.chartsLoadError365 = true;
                      break;
                  }
                });
            };

            $scope.goBack = function () {
                $state.go($state.params.from);
            };

            $scope.$on("$ionicView.afterEnter", function(event) {
              if($scope.product.productCode === 'ZS0005') {
                $scope.chartsLoading30 = true;
                $scope.canvasChart30 = new Chart(document.getElementById("pandaTreasure30").getContext("2d"));
                loadNavData($scope.canvasChart30, 1);
              } else if($scope.product.productCode == 'ZS0002'){ //熊猫宝
                loadCharts();
              }
            });

            //必须为afterEnter，否则标题不能更新(将其移动到了顶部)
            /*$scope.$on("$ionicView.afterEnter", function (event) {
                //获取参数
                $scope.backViewName = $state.params.fromName;
                $scope.provider = $stateParams.provider;
                $scope.product = $stateParams.product;

                $scope.product.productDesc = $scope.product.productDesc;
                $scope.product.productFeature = $scope.product.productFeature;
                convertAgreement($scope.product.productDetail, $scope.productDetails);
                if($scope.product.productCode == 'ZS0005'){ //周周盈
                  loadNavData();
                }else{ //熊猫宝
                  loadCharts();
                }

                //$ionicHistory.clearCache();
            });*/
        }])
    .controller('FinanceBusinesspandaTreasureSignCtrl', ['$scope', '$ionicHistory', '$PFHttpResource', 'RestFulURLConstants', '$state', '$ionicPopup', '$stateParams',
        function ($scope, $ionicHistory, $PFHttpResource, RestFulURLConstants, $state, $ionicPopup, $stateParams) {

            $scope.provider = $stateParams.provider;
            $scope.product = $stateParams.product;
            $scope.signInfo = $stateParams.signInfo;
            $scope.agreements = [];

            convertAgreement($scope.product.signCode, $scope.agreements);

            function convertAgreement(agreementCodesString, agreements) {
                agreements = agreements || [];
                if (agreementCodesString) {
                    var agreementCodes = agreementCodesString.split(";");
                    angular.forEach(agreementCodes, function (agreementCode) {
                            var agreement = agreementCode.split(":");
                            if (agreement.length === 2) {
                                agreements.push({name: "《" + agreement[1] + "》", code: agreement[0]});
                            }
                        }
                    );
                }
            };

            //签约
            $scope.pandaTreasureSign = function () {
                new $PFHttpResource(RestFulURLConstants.financeBusiness.pandaTreasure.sign, {productType: $scope.product.productCode}).then(function (data) {
                    $ionicPopup.alert({
                        title: "温馨提示",
                        template: "您已成功签约" + $scope.product.productName + "，快去风险评估！",
                        okText: '确定',
                        okType: 'button-panda'
                    }).then(function (res) {
                        $state.go("financeBusiness.pandaTreasureRiskAssessment", $stateParams);
                    });
                });

            };
        }])
    .controller('FinanceBusinesspandaTreasureSignThirdpartCtrl', ['$scope', '$ionicHistory', '$PFHttpResource', 'RestFulURLConstants', '$state', '$ionicPopup', '$stateParams',
        function ($scope, $ionicHistory, $PFHttpResource, RestFulURLConstants, $state, $ionicPopup, $stateParams) {

            $scope.provider = $stateParams.provider;
            $scope.product = $stateParams.product;
            $scope.agreements = [];

            convertAgreement($scope.product.signCode, $scope.agreements);

            function convertAgreement(agreementCodesString, agreements) {
                agreements = agreements || [];
                if (agreementCodesString) {
                    var agreementCodes = agreementCodesString.split(";");
                    var agreement = agreementCodes[0].split(":");
                    agreements.push({name: "《" + agreement[1] + "》", code: agreement[0]});
                    /*angular.forEach(agreementCodes, function (agreementCode) {
                            var agreement = agreementCode.split(":");
                            if (agreement.length === 2) {
                                agreements.push({name: "《" + agreement[1] + "》", code: agreement[0]});
                            }
                        }
                    );*/
                }
            };

            //签约第三方
            $scope.pandaTreasureSignThirtpart = function () {
                new $PFHttpResource(RestFulURLConstants.financeBusiness.pandaTreasure.signThirtpart, {productType: $scope.product.productCode}).then(function (data) {
                    $ionicPopup.alert({
                        title: "温馨提示",
                        template: "您已成功签约第三方协议！",
                        okText: '确定',
                        okType: 'button-panda'
                    }).then(function (res) {
                        $ionicHistory.goBack();
                    });
                });

            };
        }])
    .controller('FinanceBusinesspandaTreasureRiskAssessmentCtrl', ['$scope', '$state', '$ionicHistory', '$PFHttpResource', 'RestFulURLConstants', '$cordovaToast', '$stateParams',
        function ($scope, $state, $ionicHistory, $PFHttpResource, RestFulURLConstants, $cordovaToast, $stateParams) {

            $scope.provider = $stateParams.provider;
            $scope.product = $stateParams.product;

            $scope.hideBackButton = false;

            $scope.questionOptionButtonTitle = '下一题';

            $scope.questionList = [];
            $scope.answerList = [];

            $scope.answerIndex = 0;

            $scope.$watch("answerIndex", function (value) {
                if ($scope.answerIndex == $scope.questionList.length - 1) {
                    $scope.questionOptionButtonTitle = '提交';
                } else {
                    $scope.questionOptionButtonTitle = '下一题';
                }
            });

            $scope.nextQuestion = function () {
                if ($scope.answerList[$scope.answerIndex]) {
                    //下一题
                    if ($scope.answerIndex < $scope.questionList.length - 1) {
                        ++$scope.answerIndex;
                        if ($scope.answerIndex > 0) {
                            $scope.hideBackButton = true;
                        }
                    } else if ($scope.answerIndex == $scope.questionList.length - 1 && $scope.questionList.length > 0) {
                        new $PFHttpResource(RestFulURLConstants.financeBusiness.pandaTreasure.doVenture, {
                            productType: $scope.product.productCode,
                            answers: $scope.answerList.join("|")
                        }).then(function (data) {
                            try {
                                $cordovaToast.show(data.message, 'long', 'center');
                            } catch (e) {

                            }

                            if ("financeBusiness.pandaTreasureSign" == $ionicHistory.backView().stateName) {
                                $ionicHistory.goBack(-2);
                            } else {
                                $ionicHistory.goBack();
                            }

                        });
                    }
                } else {
                    try {
                        $cordovaToast.show("请选择答案", 'long', 'center');
                    } catch (e) {

                    }
                }
            };

            $scope.lastQuestion = function () {
                if ($scope.answerIndex == 0) {
                    $ionicHistory.goBack();
                }
                if ($scope.answerIndex > 0) {
                    --$scope.answerIndex;
                }
            };

            $PFHttpResource(RestFulURLConstants.financeBusiness.pandaTreasure.questionsInfoList, {productType: $scope.product.productCode}).then(function (data) {
                $scope.questionList = data.context.questionDef;

            }, function (error) {

            });


        }])
    .controller('FinanceBusinessPandaTreasureTransactionCtrl', ['$scope', '$state', '$stateParams', '$ionicHistory', '$ionicPopup', '$PFHttpResource', 'RestFulURLConstants', '$ionicModal', 'BusinessConfirmModal', '$cordovaToast', 'EncodePassword', '$transactionPassword', 'UserInfoService', '$filter',
        function ($scope, $state, $stateParams, $ionicHistory, $ionicPopup, $PFHttpResource, RestFulURLConstants, $ionicModal, BusinessConfirmModal, $cordovaToast, EncodePassword, $transactionPassword, UserInfoService, $filter) {

            $scope.provider = {};
            $scope.product = {};

            $scope.agreements = [];

            $scope.transaction = {};

            $scope.availavleAmount = 0.00;

            $scope.buyFinance = function () {

                var pFirstamt = $scope.product.pfirstamt ? $scope.product.pfirstamt : 1;

                if('ZS0002' == $scope.product.productCode) {
                    if (parseFloat($scope.transaction.applicationAmount) < parseFloat(pFirstamt)) {
                        $ionicPopup.alert({
                            title: "温馨提示",
                            template: "购买金额不能小于最低购买金额",
                            okText: '确定',
                            okType: 'button-panda'
                        });
                        return;
                    }
                }
                if ($scope.transaction.applicationAmount > parseFloat($scope.availavleAmount)) {

                    $ionicPopup.confirm({
                        title: '温馨提示',
                        template: '电子账户可用余额不足，去充值？',
                        cancelText: '取消',
                        okText: '确定',
                        okType: 'button-panda'
                    }).then(function (res) {
                        if (res) {
                            $state.go("financeCenter.recharge");
                        }
                    });

                    return;
                }

                var _parameters = {
                    userAccount: UserInfoService.getUserInfo().userAccount,
                    transamount: $scope.transaction.applicationAmount.toString().trim(),
                    type: "trans",
                    transType: "2",//购买:2
                    key: $filter('uppercase')(CryptoJS.SHA1(UserInfoService.getUserInfo().userAccount + $scope.transaction.applicationAmount.toString().trim()).toString())
                };

                $PFHttpResource(RestFulURLConstants.unitResource.generateTransactionSerialNo, _parameters).then(function (data) {

                    var _serialNo = data.context.result.serialNo;
                    $scope.confirmTransamount = data.context.result.transamount;

                    $transactionPassword({scope: $scope}).then(function (password) {
                        EncodePassword.encrypt("11", password).then(function (superPassword) {
                            $PFHttpResource(RestFulURLConstants.financeBusiness.pandaTreasure.buyFund, {
                                trandPassWord: superPassword,
                                productType: $scope.product.productCode,
                                serialNo: _serialNo
                            }).then(function (data) {
                                $scope.resultObjs = data.context;
                                if($scope.resultObjs.transDate) {
                                    $scope.resultObjs.transDate=$scope.resultObjs.transDate.replace(/^(\d{4})(\d{2})(\d{2})$/,'$1'+'-'+'$2'+'-'+'$3');
                                }
                                var confirmObj = {
                                    type: "success",
                                    header: "购买成功",
                                    title: "交易成功",
                                    subTitle: "购买金额：" + $filter("currency")($scope.transaction.applicationAmount, "") + "元",
                                    message: ''
                                };
                                /*if ('ZS0005' == $scope.product.productCode) {
                                  var date = new Date();
                                  var dateStr = date.getFullYear()+ '-' + (date.getMonth() > 8 ? '':'0') + (date.getMonth()+1)+'-'+(date.getDate()>9?'':'0')+ date.getDate();
                                  confirmObj.subTitle = "<div style=\"height: 30px; font-size: 18px;\">申购基金："+ $scope.product.productName+" </div> <div style=\"height: 30px; font-size: 18px;\">申购金额：<span style=\"color: red;\">" + ($scope.transaction.applicationAmount) + "元</span></div><div style=\"height: 30px; font-size: 18px;\">交易申请日：" + dateStr+"</div>" ;
                                }*/
                                if ('ZS0002' == $scope.product.productCode) {
                                    confirmObj.message = "<span style='font-weight: bold;'>购买</span><br><span style='padding-left: 32px'>每个工作日15点前完成购买，T+1个工作日开始计算收益，T+2个工作日可看到收益；15点后完成购买，计算收益及看到收益时间顺延一个工作日。</span><br>" +
                                        "<span style='font-weight: bold;'>赎回</span><br><span style='padding-left: 32px'>单笔限额20万（含），每日限额100万（含），赎回实时到账。</span>";
                                } else if ('ZS0003' == $scope.product.productCode) {
                                    confirmObj.message = "<span style='font-weight: bold;'>购买</span> <br> <span style='padding-left: 32px'>每个工作日15点前完成购买，T+1个工作日开始计算收益，T+2个工作日可看到收益；15点后完成购买，计算收益及看到收益时间顺延一个工作日。</span>" +
                                        "<br><span style='font-weight: bold;'>赎回</span> <br><span style='padding-left: 32px'>每日100万（含）以下赎回实时到账，100万以上赎回T+2个工作日内到账。</span>";
                                } else if ('ZS0005' == $scope.product.productCode) {
                                  confirmObj.message = "<span style=\"color:red; font-size:14px;\" class=\"ion-ios-information-outline\"></span> <span style=''>温馨提示：账户资金冻结，交易申请将于"+$scope.resultObjs.transDate+"提交给基金公司</span>";
                                }

                                BusinessConfirmModal(confirmObj).then(function (result) {
                                    $state.go($state.params.from);
                                });
                            });
                        }, function () {
                            $cordovaToast.show("交易失败", 'long', 'center');
                        });
                    }, function (error) {

                    }, function (notify) {

                    });
                });

            };

            function convertAgreement(agreementCodesString, agreements) {
                agreements = agreements || [];
                if (agreementCodesString) {
                    var agreementCodes = agreementCodesString.split(";");
                    angular.forEach(agreementCodes, function (agreementCode) {
                            var agreement = agreementCode.split(":");
                            if (agreement.length === 2) {
                                agreements.push({name: "《" + agreement[1] + "》", code: agreement[0]});
                            }
                        }
                    );
                }
            };

            $scope.$on("$ionicView.beforeEnter", function (event) {
                $scope.provider = $stateParams.provider;
                $scope.product = $stateParams.product;

                convertAgreement($scope.product.buyCode, $scope.agreements);

                $PFHttpResource(RestFulURLConstants.finance.assets.queryOnlyElectronicAccount, {productType: $scope.product.productCode}).then(function (data) {
                    $scope.availavleAmount = data.context.result.acctAmount.availBal;
                }, function (error) {
                    $ionicPopup.alert({
                        title: "温馨提示",
                        template: "查询余额失败",
                        okText: '确定',
                        okType: 'button-panda'
                    }).then(function () {
                        $ionicHistory.goBack();
                    });
                });

              if ($scope.product.productCode === 'ZS0005') {
                $scope.inputKeyDown = function(event) {
                  if(event.keyCode === 190) {
                    event.preventDefault();
                  }
                };
              }
            });
    }])
    .controller('FinanceBusinessOrderListCtrl', ['$scope', '$state', '$stateParams', '$ionicHistory', '$ionicPopup', '$PFHttpResource', 'RestFulURLConstants', '$ionicModal', 'BusinessConfirmModal', '$cordovaToast', 'EncodePassword', '$transactionPassword', 'UserInfoService', '$filter',
      function ($scope, $state, $stateParams, $ionicHistory, $ionicPopup, $PFHttpResource, RestFulURLConstants, $ionicModal, BusinessConfirmModal, $cordovaToast, EncodePassword, $transactionPassword, UserInfoService, $filter) {

        $scope.totalAmount = {};
        $scope.copies = {};

        $scope.orderList = [];

        $scope.$on("$ionicView.beforeEnter", function (event) {
          $scope.totalAmount = $stateParams.totalAmount;
          $scope.copies = $stateParams.copies;
          $scope.productType = $stateParams.productType;

          $PFHttpResource(RestFulURLConstants.financeBusiness.pandaTreasure.queryKillOrderList, {productType: $scope.productType}).then(function (data) {
            $scope.orderList = data.context.confirmOrderList;
          }, function (error) {
            $ionicPopup.alert({
              title: "温馨提示",
              template: "查询余额失败",
              okText: '确定',
              okType: 'button-panda'
            }).then(function () {
              $ionicHistory.goBack();
            });
          });
        });

        $scope.goBack = function (){
          $ionicHistory.goBack();
        }

        $scope.killOrder = function(orderNo) {
          $transactionPassword({scope: $scope}).then(function (password) {
            EncodePassword.encrypt("11", password).then(function (superPassword) {
              $PFHttpResource(RestFulURLConstants.financeBusiness.pandaTreasure.killOrder, {
                orderNo: orderNo,
                trandPassWord: superPassword
              }).then(function (data) {
                $scope.resultObjs = data.context;

                var confirmObj = {
                  type: "success",
                  header: "撤单成功",
                  title: "撤单成功",
                  subTitle: "<div style=\"height: 30px; font-size: 18px;\">撤单单号："+ $scope.resultObjs.orderNo+" </div> <div style=\"height: 30px; font-size: 18px;\">赎回申请日：" + $scope.resultObjs.transDate+"</div>" ,
                  message: ''
                };
                BusinessConfirmModal(confirmObj).then(function (result) {
                    $ionicHistory.goBack();
                });
              });
            }, function () {
              $cordovaToast.show("交易失败", 'long', 'center');
            });
          }, function (error) {

          }, function (notify) {

          });
        }
      }])
    .controller('FinanceBusinessNavListCtrl', ['$scope', '$state', '$stateParams', '$ionicHistory', '$ionicPopup', '$PFHttpResource', 'RestFulURLConstants', '$ionicModal', 'BusinessConfirmModal', '$cordovaToast', 'EncodePassword', '$transactionPassword', 'UserInfoService', '$filter',
        function ($scope, $state, $stateParams, $ionicHistory, $ionicPopup, $PFHttpResource, RestFulURLConstants, $ionicModal, BusinessConfirmModal, $cordovaToast, EncodePassword, $transactionPassword, UserInfoService, $filter) {

            $scope.provider = {};
            $scope.product = {};

            //$scope.queryDates = '30';

            $scope.rowData = [];

            $scope.$on("$ionicView.beforeEnter", function (event) {
              $scope.provider = $stateParams.provider;
              $scope.product = $stateParams.product;
              //$scope.queryDates = $stateParams.queryDates;

              $PFHttpResource(RestFulURLConstants.financeBusiness.pandaTreasure.navList, {productType: $scope.product.productCode, rowNumber: 1}).then(function (data) {
                $scope.rowData = data.context.navList;
              }, function (error) {
                $ionicPopup.alert({
                  title: "温馨提示",
                  template: "获取净值列表失败",
                  okText: '确定',
                  okType: 'button-panda'
                }).then(function () {
                  $ionicHistory.goBack();
                });
              });
            });

            $scope.goBack = function (){
              $ionicHistory.goBack();
            }
}]);

angular.module('pfApp')
    .controller('InvitationFinanceCtrl', ['$scope', '$state', '$stateParams', '$ionicHistory', 'WebShareURLConstants', 'UserInfoService', function ($scope, $state, $stateParams, $ionicHistory, WebShareURLConstants, UserInfoService) {

        var oid = "15311621031";

        $scope.shareWeiXin = function (isSendToTimeline) {
            var args = {
                type: 'webpage',
                url: $scope.shareUrl,
                imgUrl: 'https://www.baidu.com/img/bdlogo.png',
                title: $scope.product.productName,
                desc: $scope.product.productDesc,
                isSendToTimeline: isSendToTimeline
            };
            navigator.WechatShare.send(args);
        };

        $scope.$on("$ionicView.beforeEnter", function (event) {
            $scope.provider = $stateParams.provider;
            $scope.product = $stateParams.product;

            $scope.shareUrl = WebShareURLConstants.foundProductShare + "?productCode=" + $scope.product.productCode + "&cellPhone=" + oid;

            if (UserInfoService.getUserInfo() != null && UserInfoService.getUserInfo().oid != null) {
                oid = UserInfoService.getUserInfo().oid;
            }
        });

    }])
    .controller('changeFundCardCtrl', ['$scope', '$ionicHistory', '$PFHttpResource', 'RestFulURLConstants', '$state', '$ionicPopup', '$stateParams', '$transactionPassword', 'FinanceService', 'DevelopmentModeConstants', 'EncodePassword', '$cordovaToast',
    function ($scope, $ionicHistory, $PFHttpResource, RestFulURLConstants, $state, $ionicPopup, $stateParams, $transactionPassword, FinanceService, DevelopmentModeConstants, EncodePassword, $cordovaToast) {

        $scope.provider = $stateParams.provider;
        $scope.product = $stateParams.product;
        $scope.signInfo = $stateParams.signInfo;
        $scope.agreements = [];

        $scope.account = {};

        convertAgreement($scope.product.signCode, $scope.agreements);

        function convertAgreement(agreementCodesString, agreements) {
            agreements = agreements || [];
            if (agreementCodesString) {
                var agreementCodes = agreementCodesString.split(";");
                angular.forEach(agreementCodes, function (agreementCode) {
                        var agreement = agreementCode.split(":");
                        if (agreement.length === 2) {
                            agreements.push({name: "《" + agreement[1] + "》", code: agreement[0]});
                        }
                    }
                );
            }
        }

        //签约
        $scope.pandaTreasureSign = function () {
            //下面的代码是从FinanceBusinessPandaTreasureCtrl（熊猫金融产品页）124行那里移过来的，以前的弹窗直接改签，现在是在新页面改签。
            $scope.account = {};

            $transactionPassword({scope: $scope})
                .then(function (password) {
                    if (!DevelopmentModeConstants.debug) {
                        var _promise = EncodePassword.encrypt("11", password);
                        _promise.then(function (ret) {
                            $scope.account.trandPassWord = ret;
                            var _promise = FinanceService.changeFundCard({"productType": $scope.product.productCode,"trandPassWord":$scope.account.trandPassWord});
                            _promise.then(function (ret) {
                                $cordovaToast.show("更换签约卡成功", "long", "center");
                                //签约卡成功后跳转到产品详情
                                $ionicHistory.goBack();
                            })
                        }, function (error) {
                            //alert('12');
                        })
                    } else {

                        $scope.account.trandPassWord = password;
                        var _promise = FinanceService.changeFundCard({"productType": $scope.product.productType});
                        _promise.then(function (ret) {
                            $cordovaToast.show("更换签约卡成功", "long", "center");
                            //签约卡成功后跳转到产品详情
                            $ionicHistory.goBack();
                        });
                        //FinanceService.xmbFundBuy(angular.extend($scope.account, {"productType": productType}));
                    }
                },function(ret){

            });

        };
    }]);

