/**
 * Created by Z.JM on 2015/11/10.
 */

"use strict";
angular.module('pfApp').config(['$stateProvider', '$urlRouterProvider', '$ocLazyLoadProvider', 'RouterLevel', function ($stateProvider, $urlRouterProvider, $ocLazyLoadProvider, RouterLevel) {
    $stateProvider

    // setup an abstract state for the tabs directive
        .state('tab', {
            url: '/tab',
            abstract: true,
            resolve: $ocLazyLoadProvider.ocLazyLoadDependency('homeModule'),
            controller: 'TabCtrl',
            templateUrl: 'modules/home/templates/tabs.html'
        })

        // Each tab has its own nav history stack:

        .state('tab.home', {
            url: '/home',
            params: {
                goLogin: false
            },
            views: {
                'home': {
                    templateUrl: 'modules/home/templates/home.html',
                    controller: 'HomeCtrl'
                }
            },
            data: {
                $stateLevel: RouterLevel.ANY_ONE
            }
        })
        .state('tab.financeManagement', {
            url: '/financeManagement',
            views: {
                'financeManagement': {
                    templateUrl: 'modules/home/templates/financeManagement.html',
                    controller: 'FinanceManagementCtrl'
                }
            },
            data: {
                $stateLevel: RouterLevel.ANY_ONE
            }
        })
        .state('tab.self', {
            url: '/self',
            params: {'reloadFlag': false},
            views: {
                'self': {
                    templateUrl: 'modules/home/templates/self.html',
                    controller: 'FinanceCtrl'
                }
            },
            resolve: $ocLazyLoadProvider.ocLazyLoadDependency('finance'),
            data: {
                $stateLevel: RouterLevel.LOGIN_USER
            }
        })
        .state('tab.surround', {
            url: '/surround',
            views: {
                'surround': {
                    templateUrl: 'modules/home/templates/surround.html',
                    controller: 'SurroundCtrl'
                }
            },
            data: {
                $stateLevel: RouterLevel.ANY_ONE
            }
        })
        .state('tab.auctionList', {
            url: '/auctionList',
            resolve: $ocLazyLoadProvider.ocLazyLoadDependency('auctionModule'),
            views: {
                'surround': {
                    templateUrl: 'modules/auction/templates/auctionList.html',
                    controller: 'AuctionListCtrl'
                }
            },
            data: {
                $stateLevel: RouterLevel.ANY_ONE
            }
        })
        .state('tab.securityGuarantee', {
            url: '/securityGuarantee',
            views: {
                '@': {
                    templateUrl: 'modules/home/templates/securityGuarantee.html'
                }
            },
            data: {
                $stateLevel: RouterLevel.ANY_ONE
            }
        })
        .state('tab.invitationFriend', {
            url: '/invitationFriend',
            views: {
                '@': {
                    templateUrl: 'modules/home/templates/invitationFriend.html',
                    controller: 'InvitationFriendCtrl'
                }
            },
            data: {
                $stateLevel: RouterLevel.LOGIN_USER
            }
        })
        .state('tab.invitationFriendList', {
            url: '/invitationFriendList',
            views: {
                '@': {
                    templateUrl: 'modules/home/templates/invitationFriendList.html',
                    controller: 'InvitationFriendCtrl'
                }
            },
            data: {
              $stateLevel: RouterLevel.LOGIN_USER
            }
        })
        .state('tab.rewardRule', {
            url: '/rewardRule',
            views: {
                '@': {
                    templateUrl: 'modules/home/templates/rewardRule.html'
                }
            },
            data: {
                $stateLevel: RouterLevel.ANY_ONE
            }
        })
        .state('tab.dingLiangCard', {
            url: '/dingLiangCard',
            views: {
                '@': {
                    templateUrl: 'modules/home/templates/dingLiangCard.html'
                }
            },
            data: {
                $stateLevel: RouterLevel.ANY_ONE
            }
        })
      .state('tab.h5', {
        url: '/h5',
        params: {title: null, url: null},
        views: {
          '@': {
            templateUrl: 'templates/h5.html',
            controller: 'H5Ctrl'
          }
        },
        data: {
          $stateLevel: RouterLevel.ANY_ONE
        }
      });

    $stateProvider.state('showFinanceAgreement', {
        url: '/showFinanceAgreement',
        params: {
            title: null,
            code: null
        },
        views: {
            '@': {
                templateUrl: 'modules/home/templates/financeAgreementView.html',
                controller: 'ShowFinanceAgreementCtrl'
            }
        },
        data: {
            $stateLevel: RouterLevel.ANY_ONE
        }
    });


}]);
