/**
 * Created by Z.ZR on 2015/11/11.
 */
"use strict";
angular.module('pfApp').config(['$stateProvider', '$urlRouterProvider', '$ocLazyLoadProvider', 'RouterLevel', function ($stateProvider, $urlRouterProvider, $ocLazyLoadProvider, RouterLevel) {
	$stateProvider

	// setup an abstract state for the tabs directive
		.state('personCenter', {
			url: '/personCenter',
			abstract: true,
			template: '<div></div>',
			resolve: $ocLazyLoadProvider.ocLazyLoadDependency('personCenterModule'),
			data: {
				$stateLevel: RouterLevel.LOGIN_USER
			}
		})
		.state('personCenter.accountSafe', {
			url: '/accountSafe',
			views: {
				'@': {
					templateUrl: 'modules/personCenter/templates/accountSafe.html',
					controller: 'PersonAccountSafeCtrl'
				}
			}
		})
		.state('personCenter.pwReset', {
			url: '/pwReset',
			views: {
				'@': {
					templateUrl: 'modules/personCenter/templates/pwReset.html',
					controller: 'pwResetConfirmCtrl'
				}
			},
			data: {
				$stateLevel: RouterLevel.AUTHEN_USER
			}
		}).state('personCenter.addressEdit', {
		url: '/addressEdit',
		params: {address: null},
		views: {
			'@': {
				templateUrl: 'modules/personCenter/templates/addressEdit.html',
				controller: 'addressEditCtrl'
			}
		},
		data: {
			$stateLevel: RouterLevel.AUTHEN_USER
		}
	}).state('personCenter.address', {
		url: '/address',
		views: {
			'@': {
				templateUrl: 'modules/personCenter/templates/address.html',
				controller: 'AddressCtrl'
			}
		},
		data: {
			$stateLevel: RouterLevel.LOGIN_USER
		}
	}).state('personCenter.pwResetConfirm', {
			url: '/pwResetConfirm',
			views: {
				'@': {
					templateUrl: 'modules/personCenter/templates/pwResetConfirm.html',
					controller: 'pwResetConfirmCtrl'
				}
			},
			params: {"pwdResetTokenId": null, "verificationCode": null, "userIdNo": null},
			data: {
				$stateLevel: RouterLevel.AUTHEN_USER
			}
		})
		.state('personCenter.pwdmodify', {
			url: '/pwModify',
			views: {
				'@': {
					templateUrl: 'modules/personCenter/templates/pwdModify.html',
					controller: 'PersonAccountPwdModifyCtrl'
				}
			},
			data: {
				$stateLevel: RouterLevel.AUTHEN_USER
			}
		})
		.state('personCenter.resetGesturePwd', {
			url: '/resetGesturePw',
			params: {"type": 'reset'},
			views: {
				'@': {
					templateUrl: 'modules/personCenter/templates/pwdGesture.html',
					controller: 'PersonAccountPwdGestureCtrl'
				}
			}
		})
		.state('personCenter.setGesturePwd', {
			url: '/setGesturePw',
			params: {"type": 'set'},
			views: {
				'@': {
					templateUrl: 'modules/personCenter/templates/setPwdGesture.html',
					controller: 'PersonAccountPwdGestureCtrl'
				}
			}
		})
		.state('personCenter.identification', {
			url: '/identification',
			params: {"returnUrl": null},
			views: {
				'@': {
					templateUrl: 'modules/personCenter/templates/identification.html',
					controller: 'PersonIdentificationCtrl'
				}
			},
			data: {
				$stateLevel: RouterLevel.LOGIN_USER
			}
		}).state('personCenter.messageNotice', {
			url: '/messageNotice',
			params: {"notification": null, activeType: 'public'},
			views: {
				'@': {
					templateUrl: 'modules/personCenter/templates/messageNotice.html',
					controller: 'PersonMessageNoticeCtrl'
				}
			},
			data: {
				$stateLevel: RouterLevel.LOGIN_USER
			}
		})
		.state('personCenter.modifyPassword', {
			url: '/modifyPassword',
			views: {
				'@': {
					templateUrl: 'modules/personCenter/templates/modifyLoginPassword.html',
					controller: 'PersonLoginModifyPasswordCtrl'
				}
			},
			data: {
				$stateLevel: RouterLevel.LOGIN_USER
			}
		})
		.state('personCenter.electronicAccountCard', {
			url: '/electronicAccountCard',
			params: {
				branchName: null,
				electronAcct: null
			},
			views: {
				'@': {
					templateUrl: 'modules/personCenter/templates/electronicAccountCard.html',
					controller: 'personCenterElectronicAccountCardCtrl'
				}
			},
			data: {
				$stateLevel: RouterLevel.AUTHEN_USER
			}
		})
		.state('personCenter.userInformation', {
			url: '/userInformation',
			views: {
				'@': {
					templateUrl: 'modules/personCenter/templates/userInformation.html',
					controller: 'personCenterUserInformationCtrl'
				}
			},
			data: {
				$stateLevel: RouterLevel.LOGIN_USER
			}
		})
    .state('personCenter.messageTextDetail', {
      url: '/messageTextDetail',
	    params:{msg:null,type:'public',from:null},
      views: {
        '@': {
          templateUrl: 'modules/personCenter/templates/messageTextDetail.html',
          controller: 'messageTextDetailCtrl'
        }
      },
      data: {
        $stateLevel: RouterLevel.LOGIN_USER
      }
    })
    .state('personCenter.messageTextDetailNotLogin', {
      url: '/messageTextDetailNotLogin',
      params:{msg:null,type:'public'},
      views: {
        '@': {
          templateUrl: 'modules/personCenter/templates/messageTextDetail.html',
          controller: 'messageTextDetailCtrl'
        }
      },
      data: {
        $stateLevel: RouterLevel.ANY_ONE
      }
    })

}]);
