/**
 * Created by Z.ZR on 2015/11/11.
 */
"use strict";
angular.module('pfApp')

    .controller('PersonCenterCtrl', ['$scope', '$state', function ($scope) {

    }])

    .controller('PersonAccountSafeCtrl', ['$scope', '$state', 'localStorageServices', 'UserInfoService', 'GestureService', '$timeout', '$ionicHistory', '$gestureLock', 'GestureLockConstants',
        function ($scope, $state, localStorageServices, UserInfoService, GestureService, $timeout, $ionicHistory, $gestureLock, GestureLockConstants) {
            /**从个人设置返回到主页面*/
            $scope.goBack = function () {
                $ionicHistory.clearHistory();
                $state.go("financeCenter.setting");
            };

            //测试数据 具体key : 用户的注册账户+类型
            $scope.user = {
                gesturePwdStatus: null
            };

            $scope.user.gesturePwdStatus = GestureService.isSetGesture();

            $scope.user.isAuthenUser = UserInfoService.isAuthenUser();


            $scope.changeGestureLockStatus = function () {

                var oldValue = !$scope.user.gesturePwdStatus;
                if (oldValue) {
                    //如果原来有手势密码，则表示关闭手势
                    //验证旧手势密码
                    $gestureLock.reset(GestureService.getGesture(), GestureService.verificationFunction, GestureLockConstants, true)
                        .then(function (res) {
                            //验证成功，关闭手势密码
                            GestureService.removeGesture();
                        }, function (error) {
                            //其他账户验证
                            if ($gestureLock.GESTURE_LOCK_STATUS.OTHER_VERIFICATION == error.status) {
                                //退出并清除手势密码，参照蚂蚁的做法
                                GestureService.removeGesture();
                                UserInfoService.removeUserInfo();
                                $state.go("tab.home", {goLogin: true});
                            } else {
                                $scope.user.gesturePwdStatus = GestureService.isSetGesture();
                            }
                        }, function (notify) {
                            //打开密码验证
                            if ($gestureLock.GESTURE_LOCK_STATUS.OPENED == notify.status) {

                            } else if ($gestureLock.GESTURE_LOCK_STATUS.CLOSE == notify.status) {
                                $scope.user.gesturePwdStatus = GestureService.isSetGesture();
                            }
                        });
                } else {
                    //如果原来没有手势密码，则表示设置手势
                    $gestureLock.set(GestureLockConstants)
                        .then(function (res) {
                            GestureService.setGesture(res.password);
                        }, function (error) {
                            $scope.user.gesturePwdStatus = GestureService.isSetGesture();
                        }, function (notify) {
                            if ($gestureLock.GESTURE_LOCK_STATUS.OPENED == notify.status) {

                            } else if ($gestureLock.GESTURE_LOCK_STATUS.CLOSE == notify.status) {
                                $scope.user.gesturePwdStatus = GestureService.isSetGesture();
                            }
                        });
                }
            };

            $scope.resetGesture = function () {
                $gestureLock.reset(GestureService.getGesture(), GestureService.verificationFunction, GestureLockConstants)
                    .then(function (res) {
                        GestureService.setGesture(res.password);
                        $scope.user.gesturePwdStatus = GestureService.isSetGesture();
                    }, function (error) {
                        //其他账户验证
                        if ($gestureLock.GESTURE_LOCK_STATUS.OTHER_VERIFICATION == error.status) {
                            //退出并清除手势密码
                            GestureService.removeGesture();
                            UserInfoService.removeUserInfo();
                            $state.go("tab.home", {goLogin: true});
                        }
                    }, function (notify) {
                        //打开密码验证
                        if ($gestureLock.GESTURE_LOCK_STATUS.OPENED == notify.status) {

                        }
                    });
            };

        }])

    .controller('pwResetConfirmCtrl', ['$scope', '$state', '$stateParams', 'sessionStorageServices', '$transactionPassword', 'WebStorageConstants', 'SendValidateCodeService', 'AccountPwdService', 'DevelopmentModeConstants', 'EncodePassword', 'ValidateFactory', 'MobileValidateCodeTypeConstants', '$cordovaToast', 'JudgmentSimplePwdService',
        function ($scope, $state, $stateParams, sessionStorageServices, $transactionPassword, WebStorageConstants, SendValidateCodeService, AccountPwdService, DevelopmentModeConstants, EncodePassword, ValidateFactory, MobileValidateCodeTypeConstants, $cordovaToast, JudgmentSimplePwdService) {

            /**
             * 注：此手机号从当前登录的用户信息中获取，此为测试数据
             * @type {{mobile: string}}
             */
            $scope.user = sessionStorageServices.getStorage(WebStorageConstants.USER_INFO);

            $scope.card = {};
            $scope.isSending = false;
            $scope.isSendTimeLimit = false;
            $scope.sendTimeOut = null;
            $scope.shortMessageValidateCode = function () {
                SendValidateCodeService.sendValidateCode($scope, MobileValidateCodeTypeConstants.RESETPAYPASSWORD);
            };
            //判断身份证号
            function judgeIdNo(newValue) {
                if (newValue) {
                    if (newValue.length == 18) {
                        if (!ValidateFactory.idNoValidate(newValue)) {
                            $scope.user.idNolegalFlag = ValidateFactory.idNoValidate(newValue);
                            $scope.user.idNolegalFlagBtn = true;
                        } else {
                            $scope.user.idNolegalFlagBtn = false;
                        }
                    } else {
                        $scope.user.idNolegalFlag = true;
                        if (newValue.length > 18) {
                            if (!ValidateFactory.idNoValidate(newValue.substr(0, 18))) {
                                $scope.user.idNolegalFlag = ValidateFactory.idNoValidate(newValue.substr(0, 18));
                            }
                            $scope.user.idNo = newValue.substr(0, 18);
                        }

                    }
                }
            }

            $scope.$watch("user.idNo", judgeIdNo);
            /**
             * 下一步操作  根据后管当前登录用户的信息 验证客户输入的信息：
             * 1、验证客户输入的卡号和身份证号和验证码  身份证号必须为客户实名认证时输入的身份证号
             * 2、卡号为客户实名认证后绑定的卡号
             * 3、手机号为 客户预留的手机号还是 绑定卡的手机号待定
             */
            $scope.pwResetNext = function () {
                $scope.user.verificationType = "resetPayPassword";
                AccountPwdService.resetPwdValidate($scope);
            }
            //弹出密码输入框
            $scope.showPasswordModal = function (flag) {
                $transactionPassword({scope: $scope})
                    .then(function (password) {
                      if (flag == 1) {
                        if (JudgmentSimplePwdService.judgmentSimplePwd(password, $stateParams.userIdNo))
                          $scope.card.trandPassWord = password;
                      }
                      if (flag == 2) {
                        if (JudgmentSimplePwdService.judgmentSimplePwd(password, $stateParams.userIdNo))
                          $scope.card.conTrandPassWord = password;
                      }
                    });
            };
          $scope.resetPayPassword = function () {
            var password = $scope.card.trandPassWord;
            if (!DevelopmentModeConstants.debug) {
              if (JudgmentSimplePwdService.judgmentSimplePwd(password, $stateParams.userIdNo)) {
                var _promise = EncodePassword.encrypt("11", password);
                _promise.then(function (ret) {
                  $scope.card.trandPassWord = ret;
				          $scope.card.conTrandPassWord = ret;
                  AccountPwdService.resetPwdConfirm({
                    "pwdResetTokenId": $stateParams.pwdResetTokenId,
                    "verificationCode": $stateParams.verificationCode,
                    "trandPassWord": ret
                  }, $scope);
                }, function (error) {
                })
              }

            } else {
              if (JudgmentSimplePwdService.judgmentSimplePwd(password, $stateParams.userIdNo)) {
                $scope.card.trandPassWord = password;
                $cordovaToast.show('交易密码重置成功!', "short", "bottom");
                $state.go("personCenter.accountSafe");
              }
            }
          }
        }])

    .controller('PersonAccountPwdModifyCtrl', ['$scope', '$state', 'localStorageServices', '$stateParams', '$transactionPassword', 'WebStorageConstants', 'AccountPwdService', 'JudgmentSimplePwdService',
        function ($scope, $state, localStorageServices, $stateParams, $transactionPassword, WebStorageConstants, AccountPwdService, JudgmentSimplePwdService) {
            /**
             * 交易密码修改
             * 1、根据客户输入的电子账户的交易密码进行 验证
             * 2、验证通过后进行交易密码的修改
             */
            $scope.user = localStorageServices.getStorage(WebStorageConstants.USER_INFO);
            $scope.card = {};
            var flag = null;
            //查询身份证信息
            var promise = AccountPwdService.getUserIdNo();
            var idNo = '';
            promise.then(function(data){
              if(data && data.context){
                idNo = data.context.idNo;
              }
            },function(data){
            });
            //查询结束

            $scope.showPasswordModal = function (type) {
                flag = type;
                $transactionPassword({scope: $scope})
                    .then(function (password) {
                        if (flag == 0) {
                            $scope.card.oldTrandPassWord = password;
                        }
                        if (flag == 1) {
                            if (JudgmentSimplePwdService.judgmentSimplePwd(password, idNo))
                                $scope.card.trandPassWord = password;
                        }
                        if (flag == 2) {
                            if (JudgmentSimplePwdService.judgmentSimplePwd(password, idNo))
                                $scope.card.conTrandPassWord = password;
                        }
                    });
            }
            //提交 2、交易密码修改
            $scope.pwdModifyConfirm = function () {
                if (JudgmentSimplePwdService.judgmentSimplePwd($scope.card.trandPassWord) && JudgmentSimplePwdService.judgmentSimplePwd($scope.card.conTrandPassWord))
                    AccountPwdService.pwdModifyConfirm($scope);
            }
        }])

    .controller('PersonAccountPwdGestureCtrl', ['$scope', 'GestureService', '$state', '$stateParams', 'UserInfoService', function ($scope, GestureService, $state, $stateParams, UserInfoService) {


    }])

    .controller('PersonIdentificationCtrl', ['JudgmentSimplePwdService', 'GestureLockConstants', '$gestureLock', 'BaiduLocation', '$scope', '$state', '$stateParams', 'GestureService', '$transactionPassword', 'IdentificationService', 'SendValidateCodeService', 'DistinguishBankTypeService', 'UserInfoService', '$timeout', 'ValidateFactory', '$ionicHistory', 'MobileValidateCodeTypeConstants', 'ViewSupportBank', '$ionicModal', 'BranchService', '$ionicPopup',
        function (JudgmentSimplePwdService, GestureLockConstants, $gestureLock, BaiduLocation, $scope, $state, $stateParams, GestureService, $transactionPassword, IdentificationService, SendValidateCodeService, DistinguishBankTypeService, UserInfoService, $timeout, ValidateFactory, $ionicHistory, MobileValidateCodeTypeConstants, ViewSupportBank, $ionicModal, BranchService, $ionicPopup) {
            $scope.user = {
                idNolegalFlag: true,
                idNolegalFlagBtn: true,
                branchName: null,
                defaultBranchName: '南充市商业银行成都分行锦江支行'
            };
            $scope.card = {};
            BaiduLocation.nearlySearch({seachQ: "", seachTag: "cgnb", seachGeoTableId: "129374", size: 3})
                .then(function (ret) {
                    if (ret.status == "00") {
                        $scope.user.branchName = null == ret.ps0 ? "" : ret.ps0.name;
                        BaiduLocation.close();
                    }
                }, function (err) {
		    BaiduLocation.close(function(){},function(){BaiduLocation.close();});
                    $scope.user.branchName = "";
                });
            var returnUrl = $stateParams.returnUrl;
            //手势回调函数
            $scope.setGesture = function () {
                $gestureLock.set(GestureLockConstants)
                    .then(function (res) {
                        GestureService.setGesture(res.password);
                        $scope.goBack();
                    }, function (error) {
                        $scope.user.gesturePwdStatus = GestureService.isSetGesture();
                    }, function (notify) {
                        if ($gestureLock.GESTURE_LOCK_STATUS.OPENED == notify.status) {

                        } else if ($gestureLock.GESTURE_LOCK_STATUS.CLOSE == notify.status) {
                            $scope.user.gesturePwdStatus = GestureService.isSetGesture();
                        }
                    });
            };

            /**
             * 实名认证  分 本行卡认证和它行卡认证两种模式
             * 1、本行卡认证
             *    1.1首先根据卡号 查询客户信息 与客户输入的姓名、身份证号 进行比对 检验是否信息一致
             *    1.2验证输入的卡号密码
             *    1.3创建电子账户（密码为客户输入的交易密码）
             * 2、它行卡认证
             *    2.1 根据卡号去查询客户信息 与客户输入的姓名、身份证号 进行比对 检验是否信息一致
             *    2.2 发短信验证码
             *    2.3 ECIF创建客户信息 并创建电子账户
             */
            $scope.goBack = function () {
                returnUrl == null ? $ionicHistory.goBack() : $state.go(returnUrl);
            }
            //密码输入（绑定卡）
            var flag = null;

            $scope.showPasswordModal = function (type) {
                flag = type;
                $transactionPassword({scope: $scope})
                    .then(function (password) {
                        if (flag == 1) {
                            $scope.card.cardPassword = password;
                        }

                        if (flag == 2) {
                            if (JudgmentSimplePwdService.judgmentSimplePwd(password, $scope.user.idNo)) {
                                $scope.card.trandPassWord = password;
                            }
                        }

                        if (flag == 3) {
                            if (JudgmentSimplePwdService.judgmentSimplePwd(password, $scope.user.idNo)) {
                                $scope.card.repeatTrandPassWord = password;
                            }
                        }
                    });
            }
            //根据卡号判断银行
            function calculateDiscount(newValue) {
                if (newValue && newValue.length == 6) {
                    DistinguishBankTypeService.distinguishBankType(newValue, $scope);
                } else if (newValue && newValue.length < 6) {
                    $scope.card.banktype = null;
                    $scope.card.bankname = null;
                    $scope.card.showFlag = false;
                }
            }

            //银行卡输入域离开 校验
            $scope.validBankCardType = function () {
                var _bankAcctNo = $scope.card.bankacct;
                var _bankType = $scope.card.banktype;
                if (_bankAcctNo != null && _bankType == null) {
                    DistinguishBankTypeService.distinguishBankType(_bankAcctNo.substr(0, 6), $scope);
                }
            }
            $scope.$watch("card.bankacct", calculateDiscount);
            //判断身份证号
            function judgeIdNo(newValue) {
                if (newValue) {
                    if (newValue.length == 18) {
                        if (!ValidateFactory.idNoValidate(newValue)) {
                            $scope.user.idNolegalFlag = ValidateFactory.idNoValidate(newValue);
                            $scope.user.idNolegalFlagBtn = true;
                        } else {
                            $scope.user.idNolegalFlagBtn = false;
                        }
                    } else {
                        $scope.user.idNolegalFlag = true;
                        if (newValue.length > 18) {
                            if (!ValidateFactory.idNoValidate(newValue.substr(0, 18))) {
                                $scope.user.idNolegalFlag = ValidateFactory.idNoValidate(newValue.substr(0, 18));
                            }
                            $scope.user.idNo = newValue.substr(0, 18);
                        }

                    }
                }
            }

            $scope.$watch("user.idNo", judgeIdNo);
            //绑定卡类型
            $scope.bindCardType = "";
            //1.1&1.2业务逻辑   验证客户信息&验证卡密
            $scope.bankValidate = function () {
                $scope.user.verificationType = "bankPhoneCertification";
                IdentificationService.validateBindBank($scope);
            }
            //发送验证码
            $scope.isSending = false;
            $scope.isSendTimeLimit = false;
            $scope.sendTimeOut = null;
            $scope.shortMessageValidateCode = function () {
                SendValidateCodeService.sendValidateCode($scope, MobileValidateCodeTypeConstants.BANKPHONECERTIFICATION);
            };
            //创建电子账户
            $scope.createAccount = function () {
                if(!$scope.user.branchName) {
                    $scope.user.branchName = $scope.user.defaultBranchName;
                }
                if (JudgmentSimplePwdService.judgmentSimplePwd($scope.card.trandPassWord) && JudgmentSimplePwdService.judgmentSimplePwd($scope.card.repeatTrandPassWord)) {
                    IdentificationService.createElecAccount($scope);
                }

            };

            //设置手势
            $scope.gestureSet = function () {
                $scope.setGesture();
            }

            //步骤导航
            $scope.currentStep = 1;
            $scope.navStep = {
                setStep: function (goStep) {
                    $scope.currentStep = goStep;
                },
                next: function (type) {
                    nextStep();
                },
                prev: function (type) {
                    prevStep();
                },
                goTo: function (type, i) {
                    if (parseInt($scope.currentStep) > parseInt(i)) {
                        goToStep(i);
                    } else {
                        goToStep(i);
                    }
                }
            };
            var nextStep = function () {
                $scope.currentStep++;
            };

            var prevStep = function () {
                $scope.currentStep--;
            };

            var goToStep = function (i) {
                $scope.currentStep = i;
            };

            $scope.viewSupportBank = function () {
                ViewSupportBank();
            };

            //选择城市模态框
            $ionicModal.fromTemplateUrl('modules/personCenter/templates/selectCityModal.html', {
                scope: $scope,
                animation: 'slide-in-right'
            }).then(function (modal) {
                $scope.selectCityModal = modal;
                BranchService.getCity()
                    .then(function(data) {
                        var res = data.context.result;
                        var cityArr = [];
                        for(var i in res) {
                            if(res.hasOwnProperty(i)) {
                                for(var j in res[i]) {
                                    if(res[i].hasOwnProperty(j)) {
                                        cityArr.push({
                                            "name":j,
                                            "area":res[i][j]
                                        });
                                    }
                                }
                            }
                        }
                        $scope.cityList = cityArr;
                    },function(error) {
                    });
            });

            //选择支行模态框
            $ionicModal.fromTemplateUrl('modules/personCenter/templates/selectBankModal.html', {
                scope: $scope,
                animation: 'slide-in-right'
            }).then(function(modal) {
                $scope.selectBankModal = modal;
            });

            $scope.selectCity = function() {
                $scope.selectCityModal.show();
            };
            $scope.selectBank = function(obj) {
                var param = {
                    province: obj.province,
                    city: obj.cityName,
                    area: obj.areaName
                };
                BranchService.getBranch(param)
                    .then(function(data) {
                        var res = data.context.result;
                        angular.forEach(res, function(obj) {
                            if(BranchService.currentBranchData && (BranchService.currentBranchData.branchName==obj.branchName)) {
                                obj.show=true;
                            }
                        });
                        $scope.bankList = res;
                    }, function(error) {
                    });
                $scope.selectBankModal.show();
            };
            $scope.closeCityModal = function(bankItem, bank) {
                $scope.selectCityModal.hide();
            };
            $scope.closeSelectBankModal = function() {
                $scope.selectBankModal.hide();
            };

            $scope.saveBank = function() {
                if(!BranchService.currentBranchData) {
                    $ionicPopup.alert({
                        title: '温馨提示',
                        template: '请选择一个支行！',
                        okText: '确定',
                        okType: 'button-panda'
                    });
                    return;
                }
                $scope.user.branchName = BranchService.currentBranchData.branchName;
                $scope.user.branchAddress = BranchService.currentBranchData.branchAddress;
                $scope.selectBankModal.hide();
                $scope.selectCityModal.hide();
            };

            $scope.switchBank = function(bank) {
                BranchService.currentBranchData = bank;
            };
        }])

    .controller('PersonMessageNoticeCtrl', ['$scope', '$rootScope', '$state', '$stateParams', 'UserManagementService', 'BusinessConfirmModal', '$sce', '$PFHttpResource', 'RestFulURLConstants', '$ionicScrollDelegate', 'DevelopmentModeConstants', '$cordovaToast', 'loadingTextService', function ($scope, $rootScope, $state, $stateParams, UserManagementService, BusinessConfirmModal, $sce, $PFHttpResource, RestFulURLConstants, $ionicScrollDelegate, DevelopmentModeConstants, $cordovaToast, loadingTextService) {
        var notifyMsgUrl = RestFulURLConstants.messageCenter.getNotifyMsgList;
        var userMsgUrl = RestFulURLConstants.messageCenter.getUserMsgList;

        var detailState = 'personCenter.messageTextDetail';
        //type类型对应后端的type
        var typeMap = {
            push: 1,
            system: 2
        };
        //翻页条数
        var pageMap = {
            public: 1,
            push: 1,
            system: 1
        };

        (function () {
            //动态消息、系统系统消息未读状态
            $scope.notReadFlagObj = {
                push: false,
                system: false
            };

            //查询'动态消息'是否有未读
            new $PFHttpResource(RestFulURLConstants.messageCenter.getUserMsgReadFlag,{type:1}).then(function (data) {
                $scope.notReadFlagObj.push = data.context.result;
            });
            //查询'系统消息'是否有未读
            new $PFHttpResource(RestFulURLConstants.messageCenter.getUserMsgReadFlag,{type:2}).then(function (data) {
                $scope.notReadFlagObj.system = data.context.result;
            });

        })();


        $scope.banckFlag = $stateParams.notification == null ? 0 : 1;
        $scope.user = {};

        // UserManagementService.queryMessageNotices()
        //     .then(function (data) {
        //         if (data && data.context.result) {
        //             $scope.user.notices = data.context.result;
        //         }
        //     }, function (data) {
        //
        //     });

        //返回
        $scope.goBack = function () {
            if ($scope.banckFlag == 0) {
                $state.go("financeCenter.setting", {
                  comeFrom: 'messageCenter'
                });
            } else {
                $state.go("tab.home");
            }
        };

        //全部设置已读
        $scope.setAllRead = function () {
            new $PFHttpResource(RestFulURLConstants.messageCenter.setMsgReadFlag,{read_flag:'Y'}).then(function (data) {
                $cordovaToast.show('全部已设置为已读!', "long", "center");
                angular.forEach($scope.noticeMessage_push,function (item) {
                    item.readFlag = false;
                });
                angular.forEach($scope.noticeMessage_system,function (item) {
                    item.readFlag = false;
                });

                //全局设置为已读
                $rootScope.hasUnReadMessage = false;
                $scope.notReadFlagObj.push = false;
                $scope.notReadFlagObj.system = false;
            })
        };

        $scope.$on('$destroy', function (e) {
            $rootScope.messageNotice_activeType = $scope.activeType;
        });
        $scope.activeType = $rootScope.messageNotice_activeType || $rootScope.messageActiveType || $stateParams.activeType || 'public';
        $rootScope.messageActiveType = null;
        $scope["active_"+$scope.activeType] = true;
        var activeTypeKey = ['active_'+$scope.activeType];
        $scope.changeTab = function (type) {
            $scope.activeType = type;
            activeTypeKey = ['active_'+$scope.activeType];
            $scope[activeTypeKey] = true;
        };

        $scope.noticeMessage_public = [];
        $scope.noticeMessage_push = [];
        $scope.noticeMessage_system = [];

        function completeLoadData() {
            if(DevelopmentModeConstants.debug){
                window.setTimeout(function () {
                    $scope.$broadcast('scroll.infiniteScrollComplete');
                },500);
            }else
                $scope.$broadcast('scroll.infiniteScrollComplete');
        }

        //刷新文字初始化
        $scope.isLoading = false;
        $scope.loadMoreData = function (type,init) {
            var dataKey = ['noticeMessage_'+type];

            $scope.isLoading = true;
            if(init){
                //向下拉动，顶部刷新，页数从1重新开始
                pageMap[type] = 1;
            }

            var url = type === 'public' ? notifyMsgUrl : userMsgUrl;
            var params = {
                type: typeMap[type],
                page: pageMap[type]
            };

            new $PFHttpResource(url,params,null,{show:false}).then(function (data) {
                pageMap[type] ++;
                //如果是下拉重新刷新，重置数据
                if(init){
                    //对应页面数据初始化
                    $scope[dataKey] = [];
                }
                //合并前面获取的数据
                $scope[dataKey] = $scope[dataKey].concat(data.context.result);

                if (
                    !data.context.hasMore ||
                    //debug
                    (DevelopmentModeConstants.debug && $scope[dataKey].length > 20)
                ){
                    //对应类型没有下一页数据了
                    $scope['noMoreData_'+type] = true;
                }else {
                    //本来就是false要再次设置false是因为有可能使用的是下拉刷新，重置刷新状态
                    $scope['noMoreData_'+type] = false;
                }
                if(init){
                    //下拉刷新完成
                    $scope.$broadcast('scroll.refreshComplete');
                }else
                    completeLoadData();

                //加载完成
                $scope.isLoading = false;
            });
            console.log('load '+type);
        };

        /**
         * 去公告详情页面
         * @param msg
         */
        $scope.toDetail = function (msg) {
            var externalUrl = msg.notifyUrl || msg.pushUrl;
            if(externalUrl){
                //如果后管没有在url上加 http头（或https），则自动加上http
                /*var ref = window.open(externalUrl.indexOf('http') == 0 ? externalUrl : ('http://'+externalUrl), '_blank', 'location=yes')
                ref.addEventListener('loaderror', function(event) {
                    $cordovaToast.show('打开外部页面失败','short', 'center');
                });*/
                $rootScope.messageActiveType = $scope.activeType;
                $state.go('tab.h5', {title: msg.msgTypeName,url: externalUrl});
                //如果是个人信息，发送请求设置为已读
                new $PFHttpResource(RestFulURLConstants.messageCenter.getUserMsg, {msg_id: msg.oid}).then(function (data) {
                    msg.readFlag = 'Y';
                    $scope.notReadFlagObj[$scope.activeType] = $scope['noticeMessage_'+$scope.activeType].some(function (item) {
                        return item.readFlag == 'N';
                    })
                });

            }else {
                $state.go(detailState,{msg:msg, type:$scope.activeType, from: 'msgCenter'});
            }
        }

    }])

    .controller('PersonLoginModifyPasswordCtrl', ['$scope', '$transactionPassword', 'UserManagementService', function ($scope, $transactionPassword, UserManagementService) {
        $scope.user = {};
        //密码修改
        $scope.modfiyLoginPassword = function () {
            UserManagementService.modifyLoginPassword($scope.user);
        };
    }])

    .controller('PersonCenterContackAddressCtrl', ['$scope', '$state', '$PFHttpResource', 'RestFulURLConstants', function ($scope, $state, Resource, URLConstants) {
        $scope.address = {
            isDefault: true
        }
        $scope.addContackUserAddress = function () {
            if ($scope.address.isDefault) {
                $scope.address.isDefault = 'Y';
            } else {
                $scope.address.isDefault = 'N';
            }
            var _promise = Resource(URLConstants.personCenter.addContactAddress, $scope.address);
            _promise.then(function (data) {
                $state.go("personCenter.userDetailsInfo");
            }, function (data) {
            });
        }
    }])

    .controller('personCenterElectronicAccountCardCtrl', ['$scope', '$stateParams', function ($scope, $stateParams) {

        $scope.$on('$ionicView.beforeEnter', function (e) {
            $scope.branchName = $stateParams.branchName;
            $scope.electronAcct = $stateParams.electronAcct;
        });

    }])
    .controller('AddressCtrl', ['$scope',  '$ionicHistory', '$state', 'UserInfoService', '$PFHttpResource', 'RestFulURLConstants', '$ionicModal', '$ionicPopup', '$cordovaToast',
        function ($scope, $ionicHistory, $state, UserInfoService, Resource, URLConstants, $ionicModal, $ionicPopup, $cordovaToast) {
            //查询用户联系地址信息
            $scope.address = [];
            $scope.$on("$ionicView.beforeEnter", function (event) {
                queryUserContactAddress();
            });
            $scope.backViewName = $ionicHistory.backView().title;
            function queryUserContactAddress() {
                var _promise = Resource(URLConstants.personCenter.queryUserContactAddress);
                _promise.then(function (data) {
                    if (data && data.context.result) {
                        $scope.address = [];
                        for (var item in data.context.result) {
                            if (data.context.result[item].isDefault == 'Y') {
                                $scope.address.push(data.context.result[item]);
                                break;
                            }
                        }
                        for (var item in data.context.result) {
                            if (data.context.result[item].isDefault != 'Y') {
                                $scope.address.push(data.context.result[item]);
                            }
                        }
                        //$scope.address = data.context.result;
                    }
                }, function (data) {
                });
            };

            //更新用户联系方式信息
            $scope.changeContactAddress = function (address) {
                if (address.isDefault == 'Y') {
                    address.isDefault = true;
                } else {
                    address.isDefault = false;
                }
                $state.go("personCenter.addressEdit", {"address": address});
            };
            $scope.deleteContactAddress = function (address) {
                $ionicPopup.confirm({
                    title: '温馨提示',
                    template: '确定要删除此地址？',
                    cancelText: '取消',
                    okText: '确定',
                    okType: 'button-panda'
                }).then(function (res) {
                    if (res) {
                        //增加删除功能
                        var _promise = Resource(URLConstants.personCenter.deleteAddress, address);
                        _promise.then(function (data) {
                            $cordovaToast.show('地址删除成功!', "short", "center");
                                queryUserContactAddress();
                        }, function (data) {
                        });
                    }
                });
            };
            //设置默认地址
            $scope.setDefault = function (address) {
                var _promise = Resource(URLConstants.personCenter.setDefaultAddress, address);
                _promise.then(function (data) {
                    if (data) {
                        queryUserContactAddress();
                    }
                }, function (data) {
                });
            }
            //跳转新增
            $scope.addContactUserAddress = function () {
                $state.go("personCenter.addressEdit", {"address": ''});
            };
            //返回
            $scope.goBack = function () {
                //$state.go("financeCenter.setting");
                $ionicHistory.goBack();
            };

        }]).controller('addressEditCtrl', ['$scope', '$ionicHistory', '$state', 'UserInfoService', '$PFHttpResource', 'RestFulURLConstants', '$ionicModal', '$ionicPopup', '$stateParams',
        function ($scope, $ionicHistory, $state, UserInfoService, Resource, URLConstants, $ionicModal, $ionicPopup, $stateParams) {
            //更新用户联系方式信息
            $scope.address = $stateParams.address || {};
            var fromAuction = ($ionicHistory.backView().url == '/auction/auctionDoPay');
            $scope._submitUserAddressModal = function (address) {
                if (address && address.oid) {
                    if (address.isDefault) {
                        address.isDefault = 'Y';
                    } else {
                        address.isDefault = 'N';
                    }
                    //更新
                    var _promise = Resource(URLConstants.personCenter.updateUserContactAddress, address);
                    _promise.then(function (data) {
                        if (data) {
                            $state.go("personCenter.address");
                        }
                    }, function (data) {
                    });
                } else {
                    //添加
                    if ($scope.address.recipient && $scope.address.cellPhone && $scope.address.addr) {
                        if ($scope.address.isDefault || fromAuction) {
                            $scope.address.isDefault = 'Y';
                        } else {
                            $scope.address.isDefault = 'N';
                        }
                        var _promise = Resource(URLConstants.personCenter.addContactAddress, $scope.address);
                        _promise.then(function (data) {
                            //$state.go("personCenter.address");
                            $ionicHistory.goBack();
                        }, function (data) {
                        });
                    }
                }
                //$state.go("personCenter.address");
                //$ionicHistory.goBack();
            };
        }])
    .controller('personCenterUserInformationCtrl', ['$scope', '$stateParams', '$PFHttpResource', 'RestFulURLConstants',
        function ($scope, $stateParams,Resource,URLConstants) {
            $scope.$on("$ionicView.beforeEnter", function (event) {
                getUserInfo();
            });
            $scope.keyMap={
                //nikeName:'昵称',
                cellPhone:'手机号',
                //openDate:'开户日期',
                lastLoginDate:'上次登录',
                loginTotalTimes:'登录次数'
            };
            $scope.showArray = [];
            function getUserInfo() {
                var _promise = Resource(URLConstants.personCenter.queryUserInformation);
                _promise.then(function (data) {
                    if (data && data.context.result) {
                        for(var key in $scope.keyMap){
                            var obj={key:'',value:''};
                            obj.key=$scope.keyMap[key];
                            obj.value=data.context.result[key];
                            $scope.showArray.push(obj);
                        }
                    }
                }, function (data) {
                });
            };
    }])
  .controller('messageTextDetailCtrl', ['$scope', '$ionicHistory', '$stateParams', 'RestFulURLConstants', '$PFHttpResource', '$state', '$sce',
    function($scope, $ionicHistory, $stateParams, RestFulURLConstants, $PFHttpResource, $state, $sce) {
        var msg = $stateParams.msg || {};
        var type = $scope.type = $stateParams.type;
        $scope.goBack = function() {
          if(msg.msgtype == 1) { //没有登录进来的
            $ionicHistory.backView() ? $ionicHistory.goBack() : $state.go("tab.home");
          } else {
            $state.go('personCenter.messageNotice', {activeType:$stateParams.type});
          }
        };

        switch (type) {
            case 'public' :
                $scope.msgTypeName = '公告';
                break;
            case 'push' :
                $scope.msgTypeName = '动态消息';
                break;
            case 'system' :
                $scope.msgTypeName = '系统消息';
                break;
        }

        var id = msg.oid;
        (function () {
            if(type === 'public'){
                //获取公告详情
                new $PFHttpResource(RestFulURLConstants.messageCenter.getNotifyMsg,{msg_id: id}).then(function (data) {
                    $scope.content = data.context.result;
                    $scope.content.content = $sce.trustAsHtml(data.context.result.content);
                });
            }else if(type === 'system' || $stateParams.from === 'msgCenter'){
                new $PFHttpResource(RestFulURLConstants.messageCenter.getUserMsg, {msg_id: id}).then(function (data) {
                    $scope.content = data.context.result;
                    $scope.content.content = $sce.trustAsHtml(data.context.result.content);
                });
            } else {
                new $PFHttpResource(RestFulURLConstants.messageCenter.getMsg, {msg_id: id, msg_type: 2}).then(function (data) {
                  $scope.content = data.context.result;
                  $scope.content.content = $sce.trustAsHtml(data.context.result.content);
                });
            }
        })();

  }]);
