/**
 * Created by Z.ZR on 2015/11/15.
 */

"use strict";
angular.module('pfApp')
    .factory('AccountPwdService', ['$state', '$PFHttpResource', 'RestFulURLConstants', 'DevelopmentModeConstants', 'EncodePassword', '$ionicHistory', '$cordovaToast', function ($state, Resource, URLConstants, DevelopmentModeConstants, EncodePassword, $ionicHistory, $cordovaToast) {
        /**
         * 密码修改前验证
         * @param obj
         * @private
         */
        var _modifyPayPasswordValidate = function (obj) {
            //密码加密
            if (!DevelopmentModeConstants.debug) {
                var _promise = EncodePassword.encrypt("11", obj.card.trandPassWord);
                _promise.then(function (ret) {
                    obj.card.trandPassWord = ret;
                    var _promise = Resource(URLConstants.personCenter.modify_paypassword, obj.card);
                    _promise.then(function (data) {
                        $state.go("personCenter.pwdModifyConfirm", {"oldPassword": obj.card.trandPassWord});
                    }, function (data) {
                    });
                }, function (error) {
                })
            } else {
                $state.go("personCenter.pwdModifyConfirm", {"oldPassword": obj.card.trandPassWord});
            }
        }
        /**
         * 交易密码修改提交
         * @param obj
         * @private
         */
        var _pwdModifyConfirm = function (obj) {
            //密码加密
            if (!DevelopmentModeConstants.debug) {
                EncodePassword.encrypt("11", obj.card.oldTrandPassWord).then(function (ret) {
                    obj.card.oldTrandPassWord = ret;
                    var _promise = EncodePassword.encrypt("11", obj.card.trandPassWord);
                    _promise.then(function (ret) {
                        obj.card.trandPassWord = ret;
                        obj.card.conTrandPassWord = ret;
                        var _promise = Resource(URLConstants.personCenter.confirm_paypassword, obj.card);
                        _promise.then(function (data) {
                            $cordovaToast.show('交易密码修改成功!', "short", "bottom");
                            $state.go("personCenter.accountSafe");
                        }, function (data) {
                            obj.card.oldTrandPassWord = null;
                            obj.card.trandPassWord = null;
                            obj.card.conTrandPassWord = null;
                        });
                    }, function (error) {
                    })
                }, function (err) {
                });
            } else {
                $cordovaToast.show('交易密码修改成功!', "short", "bottom");
                $state.go("personCenter.accountSafe");
            }
        }
        /**
         * 获取身份信息
         * @param
         * @private
         */
        var _getUserIdNo = function () {
          var _promise = Resource(URLConstants.personCenter.getUserIdNo);
          return _promise;
        }
        /**
         * 交易密码重置前 信息验证
         * @param obj
         * @private
         */
        var _resetPwdValidate = function (obj) {
            var _promise = Resource(URLConstants.personCenter.reset_paypassword, obj.user);
            _promise.then(function (data) {
                if (data && data.context) {
                    $state.go("personCenter.pwResetConfirm", {
                        "pwdResetTokenId": data.context.pwdResetTokenId,
                        "verificationCode": obj.user.verificationCode,
                        "userIdNo": obj.user.idNo
                    });
                } else {
                    $cordovaToast.show("产生流水号失败!", 'long', 'center');
                }
            }, function (data) {
            });
        }
        /**
         * 交易密码重置
         * @param obj
         * @private
         */
        var _resetPwdConfirm = function (obj, scopeObj) {
            var _promise = Resource(URLConstants.personCenter.confirmreset_paypassword, obj);
            _promise.then(function (data) {
                $cordovaToast.show('交易密码重置成功!', "short", "bottom");
                $ionicHistory.clearHistory();
                $state.go("personCenter.accountSafe");
            }, function (data) {
                scopeObj.card.trandPassWord = null;
                scopeObj.card.conTrandPassWord = null;
            });
        }
        return {
            modifyPayPasswordValidate: function (obj) {
                return _modifyPayPasswordValidate(obj);
            },
            pwdModifyConfirm: function (obj) {
                return _pwdModifyConfirm(obj);
            },
            getUserIdNo: function () {
              return _getUserIdNo();
            },
            resetPwdValidate: function (obj) {
                return _resetPwdValidate(obj);
            },
            resetPwdConfirm: function (obj, scopeObj) {
                return _resetPwdConfirm(obj, scopeObj);
            }
        }
    }])
    .factory('IdentificationService', ['$PFHttpResource', 'RestFulURLConstants', 'UserInfoService', 'sessionStorageServices', 'WebStorageConstants', 'DevelopmentModeConstants', 'EncodePassword', function (Resource, URLConstants, UserInfoService, sessionStorageServices, WebStorageConstants, DevelopmentModeConstants, EncodePassword) {
        /**
         * 卡的实名认证包括本行卡和它行卡
         * @param obj
         * @private
         */
        var _validateBindBank = function (obj) {
            // var param = {"tag": "11", "passPlain": obj.card.cardPassword, "acno": obj.card.bankacct};
            if (!DevelopmentModeConstants.debug && obj.card.isThisBank == "Y") {
                var _promise = EncodePassword.encrypt("11", obj.card.cardPassword, obj.card.bankacct);
                _promise.then(function (ret) {
                    obj.card.cardPassword = ret;
                    var _promise = Resource(URLConstants.personCenter.indentification_card_pwd, angular.extend(obj.card, obj.user));
                    _promise.then(function (data) {
                        obj.navStep.next();
                    }, function (data) {
                        obj.card.cardPassword = null;
                    });
                }, function (error) {
                })
            } else {
                var _promise = Resource(URLConstants.personCenter.indentification_card_pwd, angular.extend(obj.card, obj.user));
                _promise.then(function (data) {
                    obj.navStep.next();
                }, function (data) {
                });
            }
        }
        /**
         * 创建电子账户
         * @param obj
         * @private
         */
        var _createElecAccount = function (obj) {
            var pwd = obj.card.trandPassWord;
            var param = {"tag": "10", "passPlain": pwd};
            if (!DevelopmentModeConstants.debug) {
                encode.encodepassword(function (ret) {
                    if (ret.status === '00') {
                        obj.card.trandPassWord = ret.midPass;
                        obj.card.repeatTrandPassWord = ret.midPass;
                        obj.card.bindCardType = '01'; //只绑定借记卡
                        var _promise = Resource(URLConstants.personCenter.electron_account_create, angular.extend(obj.card, obj.user));
                        _promise.then(function (data) {
                          obj.card.bankacct = data.context.elecAcct;
                          obj.card.bankname = data.context.branchName;

                            //签约随心存
                            if (data && data.context.result) {
                                //设置电子账户 交易中加密使用
                                UserInfoService.setElectronAcct(data.context.result.cardNumber);
                                UserInfoService.updateUserInfoAuthen();
                                var param = {"tag": "11", "passPlain": pwd, "acno": data.context.result.cardNumber};
                                encode.encodepassword(function (ret) {
                                    if (ret.status === '00') {

                                        var _promise = Resource(URLConstants.personCenter.signFreeDeposit, {
                                            "trandPassWord": ret.midPass,
                                            "idNo": obj.user.idNo
                                        });

                                        _promise.then(function (data) {
                                            UserInfoService.updateUserInfoAuthen();
                                            obj.navStep.next();
                                        }, function (data) {
                                            obj.card.trandPassWord = null;
                                            obj.card.repeatTrandPassWord = null;
                                        });

                                    }
                                }, function (ret) {
                                }, param);
                            }
                        }, function (data) {
                            obj.card.trandPassWord = null;
                            obj.card.repeatTrandPassWord = null;
                        });
                    }
                }, function (ret) {
                }, param);
            } else {
                UserInfoService.updateUserInfoAuthen();
                obj.navStep.next();
            }

        }
        return {
            validateBindBank: function (obj) {
                _validateBindBank(obj);
            },
            createElecAccount: function (obj) {
                _createElecAccount(obj);
            }
        }
    }])
    .factory('UserManagementService', ['GestureService', '$state', '$PFHttpResource', 'RestFulURLConstants', 'localStorageServices', 'WebStorageConstants', 'UserInfoService', '$cordovaToast',
        function (GestureService, $state, Resource, URLConstants, localStorageServices, WebStorageConstants, UserInfoService, $cordovaToast) {

            //修改登录密码
            var _modifyLoginPassword = function (obj) {
                if (obj.newUserPassword != obj.repeatUserPassword) {
                    $cordovaToast
                        .show('两次密码不一致!', 'long', 'center');
                    return;
                }

                if (obj.userPassword == obj.newUserPassword) {
                    $cordovaToast
                        .show('新密码不能与原始密码一致！', 'long', 'center')
                        .then(function () {
                            obj.newUserPassword = "";
                            obj.repeatUserPassword = "";
                        });
                    return;
                }

                new Resource(URLConstants.userManagement.modifyLoginPassword, {
                    "userPassword": CryptoJS.MD5(CryptoJS.SHA1(obj.userPassword).toString()).toString(),
                    "newUserPassword": CryptoJS.MD5(CryptoJS.SHA1(obj.newUserPassword).toString()).toString(),
                    "repeatUserPassword": CryptoJS.MD5(CryptoJS.SHA1(obj.repeatUserPassword).toString()).toString()
                }).then(function (data) {
                    GestureService.removeGesture();
                    UserInfoService.removeUserInfo();
                    $state.go("tab.home", {goLogin: true});
                });
            }
            //退出
            var _signOut = function () {
                var _promise = Resource(URLConstants.userManagement.signOut);
                _promise.then(function (data) {
                    GestureService.removeGesture();
                    UserInfoService.removeUserInfo();
                    $state.go("tab.home", {goLogin: true});
                }, function (data) {
                    GestureService.removeGesture();
                    UserInfoService.removeUserInfo();
                    $state.go("tab.home", {goLogin: true});
                });
            };

            return {
                modifyLoginPassword: _modifyLoginPassword,
                signOut: _signOut,
                queryMessageNotices: function () {
                    return Resource(URLConstants.messageCenter.queryNotificationMessage);
                }
            };
        }])
    .factory('BranchService', ['$PFHttpResource', 'RestFulURLConstants',
        function($PFHttpResource, RestFulURLConstants) {
        var _getCity = function() {
            return $PFHttpResource(RestFulURLConstants.getCity, null, null, {show: false});
        };
        var _getBranch = function(param) {
            return $PFHttpResource(RestFulURLConstants.getBranch, param, null, {show: false});
        };
        return {
            getCity: function() {
                return _getCity();
            },
            getBranch: function(param) {
                return _getBranch(param);
            },
            currentBranchData: null
        }
    }]);
