/**
 * Created by Z.JM on 2015/11/10.
 */

"use strict";
angular.module('pfApp').config(['$stateProvider', '$urlRouterProvider', '$ocLazyLoadProvider', 'RouterLevel', function ($stateProvider, $urlRouterProvider, $ocLazyLoadProvider, RouterLevel) {
    $stateProvider

    // setup an abstract state for the tabs directive
        .state('security', {
            url: '/security',
            abstract: true,
            resolve: $ocLazyLoadProvider.ocLazyLoadDependency('securityModule'),
            cache: false,
            data: {
                $stateLevel: RouterLevel.ANY_ONE
            }
        })

        // Each tab has its own nav history stack:

        .state('security.login', {
            url: '/login',
            params: {
                hideBackButton: false,
                backTo: null,
                toStateObj: null
            },
            cache: false,
            views: {
                '@': {
                    templateUrl: 'modules/security/templates/login.html',
                    controller: 'SecurityLoginCtrl'
                }
            }
        })
        .state('security.register', {
            url: '/register',
            cache: false,
            views: {
                '@': {
                    templateUrl: 'modules/security/templates/register.html',
                    controller: 'SecurityRegisterCtrl'
                }
            }
        })
        .state('security.findPassword', {
            url: '/findPassword',
            cache: false,
            views: {
                '@': {
                    templateUrl: 'modules/security/templates/findPassword.html',
                    controller: 'SecurityFindPasswordCtrl'
                }
            }
        })
        .state('security.familiarBreakdown', {
            url: '/familiarBreakdown',
            cache: false,
            views: {
                '@': {
                    templateUrl: 'modules/security/templates/familiarBreakdown.html',
                    controller: 'SecurityFamiliarBreakdownCtrl'
                }
            }
        })
      .state('security.commQuestion', {
        url: '/commQuestion',
        cache: true,
        params:{question:''},
        views: {
          '@': {
            templateUrl: 'modules/security/templates/commQuestion.html',
            controller: 'commQuestionCtrl'
          }
        }
      })
        .state('security.securityCenter', {
            url: '/securityCenter',
            cache: false,
            views: {
                '@': {
                    templateUrl: 'modules/security/templates/securityCenter.html',
                    controller: 'SecuritySecurityCenterCtrl'
                }
            }
        })
        .state('security.gestureUnlock', {
            url: '/gestureUnlock',
            cache: false,
            views: {
                '@': {
                    templateUrl: 'modules/security/templates/gestureUnlock.html',
                    controller: 'SecurityGestureUnlockCtrl'
                }
            }
        })
        //熊猫手机银行登录
        .state('security.pandaBankLogin', {
            url: '/pandaBankLogin',
            cache: false,
            views: {
                '@': {
                    templateUrl: 'modules/security/templates/pandaBankLogin.html',
                    controller: 'pandaBankLoginCtrl'
                }
            }
        })
        //手机银行的快速注册
        .state('security.quickRegister', {
            url: '/quickRegister',
            cache: false,
            params: {params:{}},
            views: {
                '@': {
                    templateUrl: 'modules/security/templates/quickRegister.html',
                    controller: 'quickRegisterCtrl'
                }
            }
        })
        //账号互通，手机银行开通电子账户
        .state('security.quickOpenAcc', {
            url: '/quickOpenAcc',
            cache: false,
            params:{params:null},
            views: {
                '@': {
                    templateUrl: 'modules/security/templates/quickOpenAcc.html',
                    controller: 'quickOpenAccCtrl'
                }
            }
        })
        .state('security.channelQuickRegister', {
          url:'/channelQuickRegister',
          cache: false,
          params: {currentStep: 1, paramsData: null},
          views: {
            '@': {
              templateUrl: 'modules/security/templates/channelQuickRegister.html',
              controller: 'channelQuickRegisterCtrl'
            }
          }
        });
}]);
