/**
 * Created by Z.JM on 2015/11/10.
 */
;
"use strict";

angular.module('pfApp')

    .controller('SecurityLoginCtrl', ['$rootScope', '$scope', 'SecurityLoginService', '$ionicActionSheet', '$state', '$PFHttpResource', 'RestFulURLConstants', '$cordovaToast', 'UserInfoService', 'MSGManage', '$ionicHistory', 'localStorageServices', 'WebStorageConstants', '$ionicPopover', 'FinanceAgreementService', 'SendValidateCodeService', 'MobileValidateCodeTypeConstants','$ionicPopup', 'ChannelConstants', 'ChannelApplicationService', 'MessageService', '$stateParams',
        function ($rootScope, $scope, SecurityLoginService, $ionicActionSheet, $state, $PFHttpResource, RestFulURLConstants, $cordovaToast, UserInfoService, MSGManage, $ionicHistory, localStorageServices, WebStorageConstants, $ionicPopover, FinanceAgreementService, SendValidateCodeService, MobileValidateCodeTypeConstants,$ionicPopup, ChannelConstants, ChannelApplicationService, MessageService, $stateParams) {
            if(UserInfoService.getUserInfo()) {
                $ionicHistory.backView() ? $ionicHistory.goBack() : $state.go("tab.home");
            }
            $scope.enterPandaBankLogin = function () {
                $state.go('security.pandaBankLogin');
            }

            $scope.loginHelpLink = ChannelConstants.loginHelpLink;
            $scope.registerType = ChannelConstants.registerType;
            $scope.hideBackButton = $state.params.hideBackButton;
            if ($scope.hideBackButton) {
                $ionicHistory.clearHistory();
            }
            var localStorageUserInfo = localStorageServices.getStorage(WebStorageConstants.CURRENT_USER_INFO);

            $scope.hasBackButton = $ionicHistory.backView() ? true : false;

            $scope.goBack = function () {
                if($state.params.backTo === 'index') {
                    $state.go('tab.home', {goLogin: false});
                } else {
                    $ionicHistory.goBack();
                }
            };
            $scope.user = {};
            $scope.user.userAccount = localStorageUserInfo ? parseInt(localStorageUserInfo.userAccount) : null;
            $scope.channelData = ChannelApplicationService.channelParamsData || {};

            $scope.login = function () {
                new $PFHttpResource(RestFulURLConstants.security.login, angular.extend(angular.copy($scope.user), {
                    isAutoLogin: 'N',
                    userPassword: CryptoJS.MD5(CryptoJS.SHA1($scope.user.userPassword).toString()).toString(),
                    channelUserId: $scope.channelData?$scope.channelData.channelUserId:null
                }))
                    .then(function (data) {
                        //通过type判断是否此账号是首次用此设备登录，需要手机验证码登录
                        if (data.type == 'verify_code_required'){
                            //账号肯定是手机号
                            $scope.user.cellPhone = $scope.user.userAccount;
                            $ionicPopup.confirm({
                                title: "提醒",
                                template: '你是首次在此设备上登录'+$scope.user.userAccount+"账号，请输入手机码验证！",
                                cancelText: '取消',
                                okText: '发送',
                                okType: 'button-panda'
                            }).then(function (type) {
                                if (type){
                                    $scope.needVerificationCode = true;
                                    $scope.shortMessageValidateCode();
                                }
                            });

                            return;
                        }

                        data.context.sysUserInfo.userPassword = CryptoJS.SHA1($scope.user.userPassword).toString();
                        UserInfoService.setUserInfo(data.context.sysUserInfo);
                        UserInfoService.setUserTokenId(data.context.tokenId);
                        UserInfoService.setElectronAcct(data.context.electronAcct);

                        $rootScope.$broadcast("LOGIN:SUCCESS");
                        if(data.context.auth==='N') {
                            $state.go('security.channelQuickRegister', {
                                currentStep: 2,
                                paramsData:{
                                    mobileNo: $scope.user.userAccount,
                                    channelUserId: $scope.channelData.channelUserId,
                                    channelId: $scope.channelData.channelId
                                }
                            });
                        } else {
                          if($stateParams.toStateObj&&$stateParams.toStateObj.url) {
                              $state.go($stateParams.toStateObj.url, $stateParams.toStateObj.params);
                          } else {
                            $ionicHistory.backView() && $state.params.backTo != 'index' ? $ionicHistory.goBack() : $state.go("tab.home");
                          }
                        }
                        //链接消息服务器并获取离线信息
                        try {
                            var _promise = MSGManage.wsconnect();
                        } catch (e) {
                        }
                        //熊猫金融激光推送
                        if(ChannelConstants.id === 25) {
                          var saveData = {
                            deviceId: $rootScope.appFeatures._IMEI,
                            deviceType: ionic.Platform.isAndroid()? 'android': 'ios'
                          };
                          if(navigator.pushmessage && navigator.pushmessage.pushinit) { //android
                            navigator.pushmessage.pushinit({ success: null, error: null, mills: { 'key': saveData.deviceId } });
                            new $PFHttpResource(RestFulURLConstants.security.saveDevice, saveData, null, {show: false});
                          } else if($rootScope.iosPushMessageDeviceId) { //ios
                            saveData.deviceId = $rootScope.iosPushMessageDeviceId;
                            new $PFHttpResource(RestFulURLConstants.security.saveDevice, saveData, null, {show: false});
                          }
                        }

                        //是否有未读消息
                        MessageService.getUserMsgReadFlag();
                    }, function (error) {
                        //输入手机验证码错误，则不展示图形码
                        if(!error.data || !error.data.message || error.data.message.indexOf('验证码') == -1){
                            //登录一次失败后,启用图片验证码
                            $scope.needPicVerification = true;
                        }
                        $rootScope.$broadcast("LOGIN:ERROR");
                    });
            };

            $scope.help = function () {
                var hideHelpSheet = $ionicActionSheet.show({
                    titleText: "通过以下途径寻求帮助",
                    buttons: [
                        {text: "<i class='icon ion-ios-unlocked-outline'></i>找回登录密码"},
                        {text: "<i class='icon ion-ios-paper-outline'></i>常见问题"}
                        /*,{text: "<i class='icon ion-ios-cog-outline'></i>安全中心"}*/
                    ],
                    buttonClicked: function (index) {
                        if (0 == index) {
                            $state.go("security.findPassword");
                        }
                        else if (1 == index) {
                            var scope = $scope.$new();
                            //scope.title = "常见问题";
                            //scope.code = "commonProblem";
                            //scope.viewType = "view";
                            //FinanceAgreementService(scope).show();
                            $state.go("security.familiarBreakdown");
                        }
                        //else if (2 == index) {
                        //    $state.go("security.securityCenter");
                        //}
                        return true;
                    },
                    cancelText: "取消",
                    cancel: function () {
                        //	hideHelpSheet(); 关闭
                    }
                });
            };

            /*$scope.availavlePasswordShow = false;

            $scope.seePassword = function () {
                $scope.availavlePasswordShow = $scope.availavlePasswordShow ? false : true;
            };

            $scope.$watch("availavlePasswordShow", function (value) {
                if (value) {
                    angular.element(document.getElementById("password")).attr("type", "text");
                } else {
                    angular.element(document.getElementById("password")).attr("type", "password");
                }
            });*/


            //(20160822 add by yanliang)用户在新设备上登录此账号时需要手机验证码
            $scope.shortMessageValidateCode = function () {
                SendValidateCodeService.sendValidateCode($scope, MobileValidateCodeTypeConstants.USER_LOGIN);
            };

            //ng-model上的图片验证码需要绑定在对象上才能正常
            $scope.picCode = {};
            //提交前需要验证图片验证码(如果需要的话)
            $scope.submit = function () {
                if ($scope.needPicVerification){
                    //$rootScope.appFeatures._UUID
                    new $PFHttpResource(RestFulURLConstants.publicService.checkVerificationCode,{userAccount:$rootScope.appFeatures._UUID,type:MobileValidateCodeTypeConstants.PIC_VERIFICATION.type,verificationCode:$scope.picCode.picVerificationCode})
                        .then(function (data) {
                            //校验码成功后再提交业务数据，并且清除图片验证
                            $scope.picCode = {};
                            $scope.needPicVerification = false;
                            $scope.login();
                        });
                }else
                    $scope.login();
            };


        }])

    .controller('SecurityRegisterCtrl', ['$scope', 'SecurityRegisterService', '$ionicActionSheet', '$state', '$cordovaToast', '$cordovaImagePicker', '$cordovaCamera', 'MobileValidateCodeService', 'MobileValidateCodeTypeConstants', '$PFHttpResource', '$interval', 'RestFulURLConstants', '$ionicPopup', '$http', '$ionicHistory',
        function ($scope, SecurityRegisterService, $ionicActionSheet, $state, $cordovaToast, $cordovaImagePicker, $cordovaCamera, MobileValidateCodeService, MobileValidateCodeTypeConstants, $PFHttpResource, $interval, RestFulURLConstants, $ionicPopup, $http, $ionicHistory) {

            $scope.user = {};


            var sendMobileValidateCodetTnterval = null;

            $scope.isSending = false;
            $scope.isSendTimeLimit = false;
            $scope.sendTimeOut = null;

            $scope.user.photo = "img/png/photo.png";

            $scope.shortMessageValidateCode = function () {

                if ($scope.isSending || $scope.isSendTimeLimit) {
                    return;
                }
                $scope.isSending = true;

                MobileValidateCodeService.sendMobileValidateCode({userAccount: $scope.user.userAccount}, MobileValidateCodeTypeConstants.REGISTER)
                    .then(function (data) {
                        $scope.user.verificationCode = parseInt(data.context.result);

                        $scope.isSending = false;
                        sendMobileValidateCodetTnterval == null ? null : $interval.cancel(sendMobileValidateCodetTnterval);

                        var timeCount = MobileValidateCodeTypeConstants.REGISTER.timeOut;
                        $scope.isSendTimeLimit = true;
                        $scope.sendTimeOut = --timeCount + "秒";
                        sendMobileValidateCodetTnterval = $interval(function () {
                            if (timeCount > 0) {
                                $scope.sendTimeOut = --timeCount + "秒";
                            } else {
                                $scope.isSendTimeLimit = false;
                                $interval.cancel(sendMobileValidateCodetTnterval);
                                sendMobileValidateCodetTnterval = null;
                            }
                        }, 1000);
                        $cordovaToast.show('验证码已发送，请注意查收', 'long', 'center');

                    }, function (error) {
                        $scope.isSending = false;
                        $scope.isSendTimeLimit = false;
                    });

            };

            $scope.register = function () {

                if ($scope.user.recommendPhone == $scope.user.userAccount) {
                    $ionicPopup.alert({
                        title: "提示",
                        template: "推荐人不能是自己",
                        okText: '知道了',
                        okType: 'button-panda'
                    });
                    return;
                }

                var parameters = {
                    userAccount: $scope.user.userAccount,
                    verificationCode: $scope.user.verificationCode,
                    userPassword: CryptoJS.MD5(CryptoJS.SHA1($scope.user.userPassword).toString()).toString(),
                    recommendPhone: $scope.user.recommendPhone
                };

                $PFHttpResource(RestFulURLConstants.security.register, parameters).then(function (data) {
                    $ionicPopup.alert({
                        title: "提示",
                        template: "注册成功，去登录？",
                        okText: '好的',
                        okType: 'button-panda'
                    }).then(function (res) {
                        $ionicHistory.goBack();
                    });
                }, function (error) {

                });
            };

            $scope.uploadPhoto = function () {

                var hideHelpSheet = $ionicActionSheet.show({
                    titleText: "请选择照片的获取方式",
                    buttons: [
                        {text: "<i class='icon ion-camera'></i>拍照"},
                        {text: "<i class='icon ion-images'></i>从相册选择"}
                    ],
                    buttonClicked: function (index) {
                        if (0 == index) {
                            //拍照
                            getPictureFromCamera();
                        } else if (1 == index) {
                            //从相机选择
                            getPictureFromImagePicker();
                        }
                        return true;
                    },
                    cancelText: "取消",
                    cancel: function () {
                        //
                        //	hideHelpSheet(); 关闭
                    }
                });
            };


            $scope.$on("$destroy", function (event) {
                if (sendMobileValidateCodetTnterval) {
                    $interval.cancel(sendMobileValidateCodetTnterval);
                }
            });


            function getPictureFromImagePicker() {
                var options = {
                    maximumImagesCount: 1,
                    width: 128,
                    height: 256,
                    quality: 100
                };
                document.addEventListener("deviceready", function () {
                    $cordovaImagePicker.getPictures(options)
                        .then(function (results) {
                            if (results.length > 0) {
                                $scope.user.photo = results[0] + "?" + Math.random() * 999999;
                            }
                        }, function (error) {
                            $cordovaToast.show(JSON.stringify(error), 'long', 'center');
                        });
                });
            };

            function getPictureFromCamera() {
                document.addEventListener("deviceready", function () {
                    var options = {
                        quality: 100,
                        destinationType: Camera.DestinationType.DATA_URL,
                        sourceType: Camera.PictureSourceType.CAMERA,
                        allowEdit: true,
                        encodingType: Camera.EncodingType.JPEG,
                        targetWidth: 256,
                        targetHeight: 256,
                        popoverOptions: CameraPopoverOptions,
                        saveToPhotoAlbum: true,
                        correctOrientation: true
                    };

                    $cordovaCamera.getPicture(options).then(function (imageData) {
                        $scope.user.photo = "data:image/jpeg;base64," + imageData;
                    }, function (err) {
                        $cordovaToast.show(JSON.stringify(error), 'long', 'center');
                    });

                }, false);
            };

        }])
    .controller('SecurityFindPasswordCtrl', ['$scope', 'SecurityFindPasswordService', 'MobileValidateCodeService', '$interval', 'MobileValidateCodeTypeConstants', '$cordovaToast', '$PFHttpResource', 'RestFulURLConstants', '$ionicHistory', '$state', 'ValidateFactory', '$rootScope',
        function ($scope, SecurityFindPasswordCtrlService, MobileValidateCodeService, $interval, MobileValidateCodeTypeConstants, $cordovaToast, $PFHttpResource, RestFulURLConstants, $ionicHistory, $state, ValidateFactory, $rootScope) {

            var sendMobileValidateCodetTnterval = null;

            $scope.user = {};
            $scope.isSending = false;
            $scope.isSendTimeLimit = false;
            $scope.sendTimeOut = null;
            $scope.currentStep = 1;

            $scope.shortMessageValidateCode = function () {

                if ($scope.isSending || $scope.isSendTimeLimit) {
                    return;
                }
                $scope.isSending = true;

                MobileValidateCodeService.sendMobileValidateCode({userAccount: $scope.user.userAccount}, MobileValidateCodeTypeConstants.FORGET_PASSWORD)
                    .then(function (data) {

                        $scope.user.validateCode = parseInt(data.context.result);
                        $scope.user.isCertificated = true;

                        sendMobileValidateCodetTnterval == null ? null : $interval.cancel(sendMobileValidateCodetTnterval);

                        var timeCount = MobileValidateCodeTypeConstants.REGISTER.timeOut;
                        $scope.isSending = false;
                        $scope.isSendTimeLimit = true;
                        $scope.sendTimeOut = --timeCount + "秒";
                        sendMobileValidateCodetTnterval = $interval(function () {
                            if (timeCount > 0) {
                                $scope.sendTimeOut = --timeCount + "秒";
                            } else {
                                $scope.isSendTimeLimit = false;
                                $interval.cancel(sendMobileValidateCodetTnterval);
                                sendMobileValidateCodetTnterval = null;
                            }
                        }, 1000);
                        $cordovaToast.show('验证码已发送，请注意查收', 'long', 'center');

                    }, function (error) {
                        $scope.isSending = false;
                        $scope.isSendTimeLimit = false;
                    });

            };

            //第一步验证
            var validateFirstStep = function () {
                var parameters = {
                    userAccount: $scope.user.userAccount,
                    verificationCode: $scope.user.validateCode
                };

                $PFHttpResource(RestFulURLConstants.security.forgetPassword, parameters).then(function (data) {
                        $scope.currentStep = 2;
                        $scope.isShowValidated = (data.context.result.userLevel != 'RegisterUser');
                    }, function (error) {

                    }
                );
            };

          //下一步
          $scope.next = function() {
              $scope.validatePicCode(validateFirstStep);
          }

          //判断身份证号
          function judgeIdNo(newValue) {
            if(newValue == undefined) {
              return;
            }
            var len = newValue&&newValue.length;
            if(len < 18) {
              $scope.user.idShowError = true;
            } else {
              newValue = newValue.substr(0, 18);
              $scope.user.idNo = newValue;
              if (ValidateFactory.idNoValidate(newValue)) {
                $scope.user.idShowError = false;
              } else {
                $scope.user.idShowError = true;
              }
            }
          }
          $scope.$watch("user.idNo", judgeIdNo);

          //重置密码
          $scope.resetPassword = function() {
            var parameters = {
              userAccount: $scope.user.userAccount,
              userName: $scope.isShowValidated?$scope.user.validateName:'',
              idNo: $scope.isShowValidated?$scope.user.idNo:'',
              newPassword: CryptoJS.MD5(CryptoJS.SHA1($scope.user.userPassword).toString()).toString(),
              repeatPassword: CryptoJS.MD5(CryptoJS.SHA1($scope.user.userRepeatPassword).toString()).toString()
            };

            $PFHttpResource(RestFulURLConstants.security.forgetPasswordNext, parameters).then(function (data) {
              $state.go("security.login");
            }, function (error) {
            });
          }

            //发送短信之前，需要通过图片验证码
            $scope.picActions = {
                changePic:function () {
                    delete $scope.validatedPicCode;
                }
            };
            //重置图片验证码
            var cachedUserAccount = null;
            $scope.resetPicVerCode = function () {
                if ($scope.user.userAccount == cachedUserAccount || !$scope.user.userAccount)
                    return;
                $scope.showPicVerCode ? $scope.picActions.resetPicVerCode() : $scope.showPicVerCode = true;
                cachedUserAccount = $scope.user.userAccount;
            };
            //发送手机验证码之前，需要验证图片验证码
            $scope.validatePicCode = function (succCallback) {
                if($scope.validatedPicCode && ($scope.validatedPicCode == $scope.user.picVerificationCode)){
                    succCallback();
                }else if ($scope.validatedPicCode && ($scope.validatedPicCode != $scope.user.picVerificationCode)){
                    if ($scope.validatedPicCode != $scope.user.picVerificationCode){
                        $cordovaToast.show('图形码错误', 'short', 'center');
                        return;
                    }
                }else {
                    var params = {
                        userAccount:$rootScope.appFeatures._UUID,
                        type:MobileValidateCodeTypeConstants.PIC_VERIFICATION.type,
                        verificationCode:$scope.user.picVerificationCode
                    };
                    new $PFHttpResource(RestFulURLConstants.publicService.checkVerificationCode,params)
                        .then(function (data) {
                            //图片验证码验证成功后才能发送手机验证码
                            succCallback();
                            // $scope.shortMessageValidateCode();
                            //图片验证码验证成功后，保存下输入的验证码，用于后面点击‘下一步’时再进行一次比较
                            //防止用户又去改验证码
                            $scope.validatedPicCode = $scope.user.picVerificationCode;
                        })
                }

            };

        }])
    .controller('SecurityFamiliarBreakdownCtrl', ['$scope','$state', 'SecurityFamiliarBreakdownService', '$rootScope', '$ionicPlatform', function ($scope,$state, SecurityFamiliarBreakdownService, $rootScope, $ionicPlatform) {
        $scope.toQuestion=function(question){
            $state.go('security.commQuestion',{'question':question});
        };
      $scope.questionList = [
        {
          title: '熊猫金融',
          questionKey: 'panda'
        },
        {
          title: '会员',
          questionKey: 'member'
        },
        {
          title: '充值',
          questionKey: 'recharge'
        },
        {
          title: '提现',
          questionKey: 'withdraw'
        },
        {
          title: '熊猫宝',
          questionKey: 'lingqianbao'
        },
        /*{
          title: '润金宝',
          questionKey: 'runjinbao'
        },*/
        {
          title: 'e票通',
          questionKey: 'epiaotong'
        },

        {
          title: '安全',
          questionKey: 'safety'
        }
      ];
    }])
    .controller('commQuestionCtrl', ['$scope','$rootScope', '$ionicPlatform','$stateParams','CommonQuestionService',
        function ($scope, $rootScope, $ionicPlatform ,$stateParams,QuestionService) {
            $scope.questionKey=$stateParams.question||'panda';
            if($scope.questionKey=='panda'){
                $scope.title='熊猫金融';
            }else if($scope.questionKey=='member'){
                $scope.title='会员';
            }else if($scope.questionKey=='recharge'){
                $scope.title='充值';
            }else if($scope.questionKey=='withdraw'){
                $scope.title='提现';
            }else if($scope.questionKey=='lingqianbao'){
                $scope.title='熊猫宝';
            }else if($scope.questionKey=='runjinbao'){
                $scope.title='润金宝';
            }else if($scope.questionKey=='safety'){
                $scope.title='安全';
            }else if($scope.questionKey=='epiaotong'){
              $scope.title='e票通';
            }
            QuestionService.getQuestions($scope.questionKey,$scope);

            $scope.isAnswerArr = function (ans) {
                return ans instanceof Array;
            }

        }])
    .controller('SecuritySecurityCenterCtrl', ['$scope', '$rootScope', 'SecuritySecurityCenterService', '$cordovaStatusbar', function ($scope, $roorScope, SecuritySecurityCenterService) {


    }])
    .controller('pandaBankLoginCtrl',['$scope', '$ionicHistory', 'localStorageServices', 'WebStorageConstants', '$ionicPopup', '$state', 'SecurityPandaBankService', '$ionicScrollDelegate', function ($scope , $ionicHistory, localStorageServices, WebStorageConstants, $ionicPopup, $state, SecurityPandaBankService, $ionicScrollDelegate) {
        $scope.scrollToBottom = function () {
            //防止ion-footer遮住提交按钮，打开键盘时，滚到底部
            window.setTimeout(function(){
                $ionicScrollDelegate.scrollBottom(true);
            },100)
        };

        $scope.goBack = function () {
            $state.go('security.login');
        };

        $scope.showHidePwd = function (e) {
            $scope.showPwd = !$scope.showPwd
        };

        var localStorageUserInfo = localStorageServices.getStorage(WebStorageConstants.CURRENT_USER_INFO);

        $scope.user = {
            userAccount: '',
            code: '',
            oldUserPassword:''
        };
        $scope.user.userAccount = localStorageUserInfo ? parseInt(localStorageUserInfo.userAccount) : null;

        /**************** START 20160922 从熊猫银行 LoginCtrl 中拷过来的代码 ***************/

        // $scope.user = {
        //     userAccount: '',
        //     code: '',
        //     oldUserPassword:'',
        //     currentType:'password',
        //     currentClass:'icon-password-show',
        // };
        // $scope.placeholder = Validation.loginData.placeholder;
        $scope.validation = {
            userName: SecurityPandaBankService.RULES.USER_ACCOUNT.rule,
            password: SecurityPandaBankService.RULES.PASSWORD_LOGIN.rule
        };

        $scope.checkLogin = SecurityPandaBankService.login.bind(SecurityPandaBankService,$scope.user, $scope);

        $scope.cancel = function(type){
            if(type == 1){
                $scope.user.userAccount = '' ;
            }else{
                $scope.user.userPassword = '' ;
            }
        };

        /********************* END 20160922 从熊猫银行 LoginCtrl 中拷过来的代码   *********************/


    }])
    //20160923 create by yanliang 账号互通，手机银行跳转快速注册
    .controller('quickRegisterCtrl',['$rootScope', '$scope', '$state', '$stateParams', '$ionicHistory', '$PFHttpResource', 'RestFulURLConstants', 'DevelopmentModeConstants',function ($rootScope, $scope, $state, $stateParams, $ionicHistory, $PFHttpResource, RestFulURLConstants, DevelopmentModeConstants) {
        $scope.goBack = function () {
            $ionicHistory.goBack();
        };

        $scope.scrollToBottom = function () {
            //防止ion-footer遮住提交按钮，打开键盘时，滚到底部
            window.setTimeout(function(){
                $ionicScrollDelegate.scrollBottom(true);
            },100)
        };

        $scope.modelObj = {};
        $scope.modelObj.userAccount = $stateParams.params.userAccount;
        $scope.modelObj.bindId = $stateParams.params.bindId;
        $scope.modelObj.imei = $rootScope.appFeatures._IMEI;

        $scope.register = function () {
            var cryptPassword = null;
            try {
                cryptPassword = CryptoJS.MD5(CryptoJS.SHA1($scope.modelObj.userPassword).toString()).toString();
            } catch (e){
                cryptPassword = $scope.modelObj.userPassword;
            }
            new $PFHttpResource(RestFulURLConstants.security.pandaBankRegister,angular.extend({},$scope.modelObj,{userPassword:cryptPassword})).then(function (data) {
                $ionicHistory.nextViewOptions({
                    disableBack: true
                });
                //如果未返回任何银行卡列表，则给出提示，跳回熊猫金融页面
                if(!data.context.cardList || data.context.cardList.length == 0){
                    BusinessConfirmModal({
                        type: "success",
                        header: "提示",
                        title: "注册成功",
                        subTitle: "已为你快速注册熊猫金融账户，但未检测到银行卡",
                        okText: '去登陆'
                    }).then(function (result) {
                        $state.go('security.login',{backTo:'index'});
                    });
                    return;
                }

                //注册成功，跳转到快速开户
                $state.go('security.quickOpenAcc',{params:data.context});
            });

        };
    }])
    //20160923 create by yanliang 账号互通，手机银行开通账户
    .controller('quickOpenAccCtrl',['$scope', '$state', '$stateParams', '$ionicModal', '$PFHttpResource', 'RestFulURLConstants', '$ionicBackdrop', '$transactionPassword', 'JudgmentSimplePwdService', 'BusinessConfirmModal', 'EncodePassword', '$ionicHistory', 'DevelopmentModeConstants', '$ionicPlatform', function ($scope, $state, $stateParams, $ionicModal, $PFHttpResource, RestFulURLConstants, $ionicBackdrop, $transactionPassword, JudgmentSimplePwdService, BusinessConfirmModal, EncodePassword, $ionicHistory, DevelopmentModeConstants, $ionicPlatform) {
        $scope.goBack = function () {
            $state.go('security.pandaBankLogin');
        };

        var params = $scope.params = $stateParams.params || {};
        $scope.userModel = {
            bindId:params.bindId
        };

        var chooseCard = function (card) {
            $scope.userModel.cardNo = card.cardNo;
            $scope.userModel.bankName = card.bankName;
        };

        (function () {

            $scope.cards = $stateParams.params.cardList;
            if($scope.cards){
                chooseCard($scope.cards[0]);
            }

        })();

        // registerBackButtonAction() returns a function which can be used to deregister it
        var deregisterHardBack= $ionicPlatform.registerBackButtonAction(
            function () {
                $state.go('security.pandaBankLogin');
            }, 101
        );

        $scope.$on('$destroy', function() {
            deregisterHardBack();
        });

        //银行卡每四位隔开空字符
        $scope.fourSpaceStr = function (data) {
            var index = 0;
            var resultText = "";
            while (index < data.length){
                var lastIndex = index + (data.length - index > 4 ? 4 : data.length - index);
                resultText += (data.substring(index,lastIndex)+" ");

                index = lastIndex;
            }
            return resultText;
        };

        $ionicModal.fromTemplateUrl('modules/security/templates/chooseSecondAcc.html', {
            scope: $scope,
            animation: 'slide-in-up',
            //Whether to close the modal on clicking the backdrop. Default: true.
            backdropClickToClose: false,
            //Whether the modal can be closed using the hardware back button on Android and similar devices. Default: true.
            hardwareBackButtonClose: false
        }).then(function(modal) {
            $scope.modal = modal;
        });
        $scope.openModal = function() {
            $scope.modal.show();
        };
        $scope.closeModal = function(card) {
            if(card){
                chooseCard(card);
            }
            $scope.modal.hide();
        };
        // Cleanup the modal when we're done with it!
        $scope.$on('$destroy', function() {
            $scope.modal.remove();
        });

        // Execute action on show modal
        $scope.$on('modal.shown', function() {
            $ionicBackdrop.retain();
        });

        // Execute action on hide modal
        $scope.$on('modal.hidden', function() {
            $ionicBackdrop.release();
        });
        // Execute action on remove modal
        $scope.$on('modal.removed', function() {
            $ionicBackdrop.release();
        });

        $scope.chooseCard = function () {
            if (!$scope.cards || $scope.cards.length == 1)
                return;
            $scope.openModal();
        };

        //输入交易密码
        $scope.showPasswordModal = function (key) {
            $transactionPassword({scope: $scope})
                .then(function (password) {
                    if(JudgmentSimplePwdService.judgmentSimplePwd(password, $scope.userModel.cardNo))
                        $scope.userModel[key] = password;
                });
        };

        //提交请求
        var submitRequest = function () {
            //需要传的参数
            // trandPassWord
            // bankName
            // bindId
            //TODO 支行名称和卡号，查看实名第二步如何从GPS中定位获取
            // branchName
            // branchNo
            // cardPassword

            //交易密码加密
            EncodePassword.encrypt("10", $scope.userModel.password).then(function (cryptPwd) {
                $scope.userModel.trandPassWord = cryptPwd;

                var params = angular.copy($scope.userModel);
                delete params.password;
                delete params.uncryptCardPassword;
                new $PFHttpResource(RestFulURLConstants.security.quickOpenAccount,params).then(function (data) {

                    BusinessConfirmModal({
                        type: "success",
                        header: "开通成功",
                        title: "开通成功",
                        subTitle: "已为你快速开通熊猫金融账户，登陆后即享受高收益理财",
                        okText: '去登陆'
                    }).then(function (result) {
                        $state.go('security.login',{backTo:'index'});
                    });

                })
            });
        };

        //提交
        $scope.submit = function () {
            if($stateParams.params.needPwd == '1'){
                if(!DevelopmentModeConstants.debug){
                    EncodePassword.encrypt("11", $scope.userModel.uncryptCardPassword, $scope.userModel.cardNo).then(function (cryptPwd) {
                        //需要验证的他行卡密
                        $scope.userModel.cardPassword = cryptPwd;
                        submitRequest();
                    });
                }else {
                    submitRequest();
                }
            }else {
                submitRequest();
            }




        };

    }])
    .controller('channelQuickRegisterCtrl', ['$rootScope', '$scope', '$ionicHistory', 'ChannelApplicationService', '$PFHttpResource', 'RestFulURLConstants', 'UserInfoService', 'MSGManage', '$state', '$stateParams', 'UserDataService',
    function($rootScope, $scope, $ionicHistory, ChannelApplicationService, $PFHttpResource, RestFulURLConstants, UserInfoService, MSGManage, $state, $stateParams, UserDataService) {
      $scope.currentStep = $stateParams.currentStep || 1;
      $scope.paramsData = $stateParams.paramsData || {};
      $scope.channelData = ChannelApplicationService.channelParamsData || {};
      $scope.user = {
        //mobileNo: $scope.channelData.mobileNo
      };
      $scope.goBack = function() {
        $ionicHistory.goBack();
      };
      $scope.prev = function() {
        $PFHttpResource(RestFulURLConstants.userManagement.signOut);
        UserDataService.userData={};
        UserInfoService.removeUserInfo();
        $scope.user = { };
        $ionicHistory.goBack();
      };


      $scope.channelQuickRegister = function() {
        var _param = {
          mobileNo: $scope.user.mobileNo,
          channelUserId: $scope.channelData.channelUserId,
          channelId: $scope.channelData.channelId,
          password: CryptoJS.MD5(CryptoJS.SHA1($scope.user.password).toString()).toString(),
          smsCode: $scope.user.validateCode
        };
        $PFHttpResource(RestFulURLConstants.security.channelQuickRegister, _param)
          .then(function(data) {
            if(!data.context.result) {
              if(data.context.message) {
                try {
                  $cordovaToast.show(data.context.message, 'long', 'center');
                } catch (e) {
                  console.info("toast info");
                }
              }
            } else {
              if(data.context.sysUserInfo) {
                UserInfoService.setUserInfo(data.context.sysUserInfo);
                UserInfoService.setUserTokenId(data.context.tokenId);
                $rootScope.$broadcast("LOGIN:SUCCESS");
                //链接消息服务器并获取离线信息
                try {
                  var _promise = MSGManage.wsconnect();
                } catch (e) {
                }
                $scope.currentStep = 2;
                $scope.paramsData = {
                  mobileNo: _param.mobileNo,
                  channelUserId: _param.channelUserId,
                  channelId: _param.channelId
                };
              }
            }
          }, function(error) {

          });
      };


      $scope.channelAuth = function() {
        $PFHttpResource(RestFulURLConstants.security.channelAuthority, $scope.paramsData)
          .then(function(data) {
            if(data.context) {
              if(data.context.result) {
                $ionicHistory.goBack();
              } else {
                $cordovaToast.show(data.context.message || '绑定失败！', 'long', 'center');
              }
            }
          }, function(error) {

          });
      };
    }]);
