/**
 * Created by Z.JM on 2015/11/10.
 */

"use strict";
angular.module('pfApp')
    .factory('SecurityLoginService', [function () {
        return {};
    }])
    .factory('SecurityRegisterService', [function () {
        return {};
    }])
    .factory('SecurityFindPasswordService', [function () {
        return {};
    }])
    .factory('SecurityFamiliarBreakdownService', [function () {
        return {};
    }])
    .factory('SecuritySecurityCenterService', [function () {
        return {};
    }])
    .factory('SecurityGestureUnlockService', [function () {
        return {};
    }])
    //手机银行相关服务，指令等，从手机银行提取过来的
    .factory('SecurityPandaBankService',['$rootScope', '$state', '$ionicPopup', 'RestFulURLConstants', '$PFHttpResource', 'UserInfoService', 'DevelopmentModeConstants', 'BusinessConfirmModal', function ($rootScope, $state, $ionicPopup, RestFulURLConstants, $PFHttpResource, UserInfoService, DevelopmentModeConstants, BusinessConfirmModal) {
        /*********** START 提出自sha1.js ********************/
        /**
         *@param username
         *@param passwordOrgin
         *@return encrypt password for $username who use orign password $passwordOrgin
         *
         **/

        function encrypt(username, passwordOrgin) {
            return hex_sha1(username+hex_sha1(passwordOrgin));
        }



        function hex_sha1(s, hexcase) {
            if (!(arguments) || !(arguments.length) || arguments.length < 1) {
                return binb2hex(core_sha1(AlignSHA1("aiact@163.com")), true);
            } else {
                if (arguments.length == 1) {
                    return binb2hex(core_sha1(AlignSHA1(arguments[0])), true);
                } else {
                    return binb2hex(core_sha1(AlignSHA1(arguments[0])), arguments[1]);
                }
            }
            // return binb2hex(core_sha1(AlignSHA1(s)),hexcase);
        }
        /**/
        /*
         * Perform a simple self-test to see if the VM is working
         */
        function sha1_vm_test() {
            return hex_sha1("abc",false) == "a9993e364706816aba3e25717850c26c9cd0d89d";
        }
        /**/
        /*
         * Calculate the SHA-1 of an array of big-endian words, and a bit length
         */
        function core_sha1(blockArray) {
            var x = blockArray;  //append padding
            var w = Array(80);
            var a = 1732584193;
            var b = -271733879;
            var c = -1732584194;
            var d = 271733878;
            var e = -1009589776;
            for (var i = 0; i < x.length; i += 16) {  //每次处理512位 16*32
                var olda = a;
                var oldb = b;
                var oldc = c;
                var oldd = d;
                var olde = e;
                for (var j = 0; j < 80; j += 1) {  //对每个512位进行80步操作
                    if (j < 16) {
                        w[j] = x[i + j];
                    } else {
                        w[j] = rol(w[j - 3] ^ w[j - 8] ^ w[j - 14] ^ w[j - 16], 1);
                    }
                    var t = safe_add(safe_add(rol(a, 5), sha1_ft(j, b, c, d)), safe_add(safe_add(e, w[j]), sha1_kt(j)));
                    e = d;
                    d = c;
                    c = rol(b, 30);
                    b = a;
                    a = t;
                }
                a = safe_add(a, olda);
                b = safe_add(b, oldb);
                c = safe_add(c, oldc);
                d = safe_add(d, oldd);
                e = safe_add(e, olde);
            }
            return new Array(a, b, c, d, e);
        }
        /**/
        /*
         * Perform the appropriate triplet combination function for the current iteration
         * 返回对应F函数的值
         */
        function sha1_ft(t, b, c, d) {
            if (t < 20) {
                return (b & c) | ((~b) & d);
            }
            if (t < 40) {
                return b ^ c ^ d;
            }
            if (t < 60) {
                return (b & c) | (b & d) | (c & d);
            }
            return b ^ c ^ d;  //t<80
        }
        /**/
        /*

         * Determine the appropriate additive constant for the current iteration
         * 返回对应的Kt值
         */
        function sha1_kt(t) {
            return (t < 20) ? 1518500249 : (t < 40) ? 1859775393 : (t < 60) ? -1894007588 : -899497514;
        }
        /**/
        /*
         * Add integers, wrapping at 2^32. This uses 16-bit operations internally
         * to work around bugs in some JS interpreters.
         * 将32位数拆成高16位和低16位分别进行相加，从而实现 MOD 2^32 的加法
         */
        function safe_add(x, y) {
            var lsw = (x & 65535) + (y & 65535);
            var msw = (x >> 16) + (y >> 16) + (lsw >> 16);
            return (msw << 16) | (lsw & 65535);
        }
        /**/
        /*
         * Bitwise rotate a 32-bit number to the left.
         * 32位二进制数循环左移
         */
        function rol(num, cnt) {
            return (num << cnt) | (num >>> (32 - cnt));
        }
        /**/
        /*

         * The standard SHA1 needs the input string to fit into a block

         * This function align the input string to meet the requirement

         */
        function AlignSHA1(str) {
            var nblk = ((str.length + 8) >> 6) + 1, blks = new Array(nblk * 16);
            for (var i = 0; i < nblk * 16; i += 1) {
                blks[i] = 0;
            }
            for (i = 0; i < str.length; i += 1) {
                blks[i >> 2] |= str.charCodeAt(i) << (24 - (i & 3) * 8);
            }
            blks[i >> 2] |= 128 << (24 - (i & 3) * 8);
            blks[nblk * 16 - 1] = str.length * 8;
            return blks;
        }
        /**/
        /*
         * Convert an array of big-endian words to a hex string.
         */
        function binb2hex(binarray, hexcase) {
            var hex_tab = hexcase ? "0123456789ABCDEF" : "0123456789abcdef";
            var str = "";
            for (var i = 0; i < binarray.length * 4; i += 1) {
                str += hex_tab.charAt((binarray[i >> 2] >> ((3 - i % 4) * 8 + 4)) & 15) + hex_tab.charAt((binarray[i >> 2] >> ((3 - i % 4) * 8)) & 15);
            }
            return str;
        }


        /************ END 提出自sha1.js ***************/



        /****************  START 提取自 cgnb.js  ********************************/

        /**
         *@param username
         *@param passwordOrgin
         *@return encrypt password for $username who use orign password $passwordOrgin
         *
         **/

        function enoup(username, passwordOrgin) {
            return hex_sha1(username+"/"+hex_sha1(passwordOrgin));
        }



        function hex_sha1(s, hexcase) {
            if (!(arguments) || !(arguments.length) || arguments.length < 1) {
                return binb2hex(core_sha1(AlignSHA1("aiact@163.com")), true);
            } else {
                if (arguments.length == 1) {
                    return binb2hex(core_sha1(AlignSHA1(arguments[0])), true);
                } else {
                    return binb2hex(core_sha1(AlignSHA1(arguments[0])), arguments[1]);
                }
            }
            // return binb2hex(core_sha1(AlignSHA1(s)),hexcase);
        }
        /**/
        /*
         * Perform a simple self-test to see if the VM is working
         */
        function sha1_vm_test() {
            return hex_sha1("abc",false) == "a9993e364706816aba3e25717850c26c9cd0d89d";
        }
        /**/
        /*
         * Calculate the SHA-1 of an array of big-endian words, and a bit length
         */
        function core_sha1(blockArray) {
            var x = blockArray;  //append padding
            var w = Array(80);
            var a = 1732584193;
            var b = -271733879;
            var c = -1732584194;
            var d = 271733878;
            var e = -1009589776;
            for (var i = 0; i < x.length; i += 16) {  //每次处理512位 16*32
                var olda = a;
                var oldb = b;
                var oldc = c;
                var oldd = d;
                var olde = e;
                for (var j = 0; j < 80; j += 1) {  //对每个512位进行80步操作
                    if (j < 16) {
                        w[j] = x[i + j];
                    } else {
                        w[j] = rol(w[j - 3] ^ w[j - 8] ^ w[j - 14] ^ w[j - 16], 1);
                    }
                    var t = safe_add(safe_add(rol(a, 5), sha1_ft(j, b, c, d)), safe_add(safe_add(e, w[j]), sha1_kt(j)));
                    e = d;
                    d = c;
                    c = rol(b, 30);
                    b = a;
                    a = t;
                }
                a = safe_add(a, olda);
                b = safe_add(b, oldb);
                c = safe_add(c, oldc);
                d = safe_add(d, oldd);
                e = safe_add(e, olde);
            }
            return new Array(a, b, c, d, e);
        }
        /**/
        /*
         * Perform the appropriate triplet combination function for the current iteration
         * 返回对应F函数的值
         */
        function sha1_ft(t, b, c, d) {
            if (t < 20) {
                return (b & c) | ((~b) & d);
            }
            if (t < 40) {
                return b ^ c ^ d;
            }
            if (t < 60) {
                return (b & c) | (b & d) | (c & d);
            }
            return b ^ c ^ d;  //t<80
        }
        /**/
        /*

         * Determine the appropriate additive constant for the current iteration
         * 返回对应的Kt值
         */
        function sha1_kt(t) {
            return (t < 20) ? 1518500249 : (t < 40) ? 1859775393 : (t < 60) ? -1894007588 : -899497514;
        }
        /**/
        /*
         * Add integers, wrapping at 2^32. This uses 16-bit operations internally
         * to work around bugs in some JS interpreters.
         * 将32位数拆成高16位和低16位分别进行相加，从而实现 MOD 2^32 的加法
         */
        function safe_add(x, y) {
            var lsw = (x & 65535) + (y & 65535);
            var msw = (x >> 16) + (y >> 16) + (lsw >> 16);
            return (msw << 16) | (lsw & 65535);
        }
        /**/
        /*
         * Bitwise rotate a 32-bit number to the left.
         * 32位二进制数循环左移
         */
        function rol(num, cnt) {
            return (num << cnt) | (num >>> (32 - cnt));
        }
        /**/
        /*

         * The standard SHA1 needs the input string to fit into a block

         * This function align the input string to meet the requirement

         */
        function AlignSHA1(str) {
            var nblk = ((str.length + 8) >> 6) + 1, blks = new Array(nblk * 16);
            for (var i = 0; i < nblk * 16; i += 1) {
                blks[i] = 0;
            }
            for (i = 0; i < str.length; i += 1) {
                blks[i >> 2] |= str.charCodeAt(i) << (24 - (i & 3) * 8);
            }
            blks[i >> 2] |= 128 << (24 - (i & 3) * 8);
            blks[nblk * 16 - 1] = str.length * 8;
            return blks;
        }
        /**/
        /*
         * Convert an array of big-endian words to a hex string.
         */
        function binb2hex(binarray, hexcase) {
            var hex_tab = hexcase ? "0123456789ABCDEF" : "0123456789abcdef";
            var str = "";
            for (var i = 0; i < binarray.length * 4; i += 1) {
                str += hex_tab.charAt((binarray[i >> 2] >> ((3 - i % 4) * 8 + 4)) & 15) + hex_tab.charAt((binarray[i >> 2] >> ((3 - i % 4) * 8)) & 15);
            }
            return str;
        }




        /*******************  END 提出自 cgnb.js ******************************************/

        /************************* START 提取自 md5.js ************************************/
        /*
         * A JavaScript implementation of the RSA Data Security, Inc. MD5 Message
         * Digest Algorithm, as defined in RFC 1321.
         * Version 2.1 Copyright (C) Paul Johnston 1999 - 2002.
         * Other contributors: Greg Holt, Andrew Kepert, Ydnar, Lostinet
         * Distributed under the BSD License
         * See http://pajhome.org.uk/crypt/md5 for more info.
         */

        /*
         * Configurable variables. You may need to tweak these to be compatible with
         * the server-side, but the defaults work in most cases.
         */
        var hexcase = 0;  /* hex output format. 0 - lowercase; 1 - uppercase        */
        var b64pad  = ""; /* base-64 pad character. "=" for strict RFC compliance   */
        var chrsz   = 8;  /* bits per input character. 8 - ASCII; 16 - Unicode      */

        /*
         * These are the functions you'll usually want to call
         * They take string arguments and return either hex or base-64 encoded strings
         */
        function hex_md5(s){ return binl2hex(core_md5(str2binl(s), s.length * chrsz));}
        function b64_md5(s){ return binl2b64(core_md5(str2binl(s), s.length * chrsz));}
        function str_md5(s){ return binl2str(core_md5(str2binl(s), s.length * chrsz));}
        function hex_hmac_md5(key, data) { return binl2hex(core_hmac_md5(key, data)); }
        function b64_hmac_md5(key, data) { return binl2b64(core_hmac_md5(key, data)); }
        function str_hmac_md5(key, data) { return binl2str(core_hmac_md5(key, data)); }

        /*
         * Perform a simple self-test to see if the VM is working
         */
        function md5_vm_test()
        {
            return hex_md5("abc") == "900150983cd24fb0d6963f7d28e17f72";
        }

        /*
         * Calculate the MD5 of an array of little-endian words, and a bit length
         */
        function core_md5(x, len)
        {
            /* append padding */
            x[len >> 5] |= 0x80 << ((len) % 32);
            x[(((len + 64) >>> 9) << 4) + 14] = len;

            var a =  1732584193;
            var b = -271733879;
            var c = -1732584194;
            var d =  271733878;

            for(var i = 0; i < x.length; i += 16)
            {
                var olda = a;
                var oldb = b;
                var oldc = c;
                var oldd = d;

                a = md5_ff(a, b, c, d, x[i+ 0], 7 , -680876936);
                d = md5_ff(d, a, b, c, x[i+ 1], 12, -389564586);
                c = md5_ff(c, d, a, b, x[i+ 2], 17,  606105819);
                b = md5_ff(b, c, d, a, x[i+ 3], 22, -1044525330);
                a = md5_ff(a, b, c, d, x[i+ 4], 7 , -176418897);
                d = md5_ff(d, a, b, c, x[i+ 5], 12,  1200080426);
                c = md5_ff(c, d, a, b, x[i+ 6], 17, -1473231341);
                b = md5_ff(b, c, d, a, x[i+ 7], 22, -45705983);
                a = md5_ff(a, b, c, d, x[i+ 8], 7 ,  1770035416);
                d = md5_ff(d, a, b, c, x[i+ 9], 12, -1958414417);
                c = md5_ff(c, d, a, b, x[i+10], 17, -42063);
                b = md5_ff(b, c, d, a, x[i+11], 22, -1990404162);
                a = md5_ff(a, b, c, d, x[i+12], 7 ,  1804603682);
                d = md5_ff(d, a, b, c, x[i+13], 12, -40341101);
                c = md5_ff(c, d, a, b, x[i+14], 17, -1502002290);
                b = md5_ff(b, c, d, a, x[i+15], 22,  1236535329);

                a = md5_gg(a, b, c, d, x[i+ 1], 5 , -165796510);
                d = md5_gg(d, a, b, c, x[i+ 6], 9 , -1069501632);
                c = md5_gg(c, d, a, b, x[i+11], 14,  643717713);
                b = md5_gg(b, c, d, a, x[i+ 0], 20, -373897302);
                a = md5_gg(a, b, c, d, x[i+ 5], 5 , -701558691);
                d = md5_gg(d, a, b, c, x[i+10], 9 ,  38016083);
                c = md5_gg(c, d, a, b, x[i+15], 14, -660478335);
                b = md5_gg(b, c, d, a, x[i+ 4], 20, -405537848);
                a = md5_gg(a, b, c, d, x[i+ 9], 5 ,  568446438);
                d = md5_gg(d, a, b, c, x[i+14], 9 , -1019803690);
                c = md5_gg(c, d, a, b, x[i+ 3], 14, -187363961);
                b = md5_gg(b, c, d, a, x[i+ 8], 20,  1163531501);
                a = md5_gg(a, b, c, d, x[i+13], 5 , -1444681467);
                d = md5_gg(d, a, b, c, x[i+ 2], 9 , -51403784);
                c = md5_gg(c, d, a, b, x[i+ 7], 14,  1735328473);
                b = md5_gg(b, c, d, a, x[i+12], 20, -1926607734);

                a = md5_hh(a, b, c, d, x[i+ 5], 4 , -378558);
                d = md5_hh(d, a, b, c, x[i+ 8], 11, -2022574463);
                c = md5_hh(c, d, a, b, x[i+11], 16,  1839030562);
                b = md5_hh(b, c, d, a, x[i+14], 23, -35309556);
                a = md5_hh(a, b, c, d, x[i+ 1], 4 , -1530992060);
                d = md5_hh(d, a, b, c, x[i+ 4], 11,  1272893353);
                c = md5_hh(c, d, a, b, x[i+ 7], 16, -155497632);
                b = md5_hh(b, c, d, a, x[i+10], 23, -1094730640);
                a = md5_hh(a, b, c, d, x[i+13], 4 ,  681279174);
                d = md5_hh(d, a, b, c, x[i+ 0], 11, -358537222);
                c = md5_hh(c, d, a, b, x[i+ 3], 16, -722521979);
                b = md5_hh(b, c, d, a, x[i+ 6], 23,  76029189);
                a = md5_hh(a, b, c, d, x[i+ 9], 4 , -640364487);
                d = md5_hh(d, a, b, c, x[i+12], 11, -421815835);
                c = md5_hh(c, d, a, b, x[i+15], 16,  530742520);
                b = md5_hh(b, c, d, a, x[i+ 2], 23, -995338651);

                a = md5_ii(a, b, c, d, x[i+ 0], 6 , -198630844);
                d = md5_ii(d, a, b, c, x[i+ 7], 10,  1126891415);
                c = md5_ii(c, d, a, b, x[i+14], 15, -1416354905);
                b = md5_ii(b, c, d, a, x[i+ 5], 21, -57434055);
                a = md5_ii(a, b, c, d, x[i+12], 6 ,  1700485571);
                d = md5_ii(d, a, b, c, x[i+ 3], 10, -1894986606);
                c = md5_ii(c, d, a, b, x[i+10], 15, -1051523);
                b = md5_ii(b, c, d, a, x[i+ 1], 21, -2054922799);
                a = md5_ii(a, b, c, d, x[i+ 8], 6 ,  1873313359);
                d = md5_ii(d, a, b, c, x[i+15], 10, -30611744);
                c = md5_ii(c, d, a, b, x[i+ 6], 15, -1560198380);
                b = md5_ii(b, c, d, a, x[i+13], 21,  1309151649);
                a = md5_ii(a, b, c, d, x[i+ 4], 6 , -145523070);
                d = md5_ii(d, a, b, c, x[i+11], 10, -1120210379);
                c = md5_ii(c, d, a, b, x[i+ 2], 15,  718787259);
                b = md5_ii(b, c, d, a, x[i+ 9], 21, -343485551);

                a = safe_add(a, olda);
                b = safe_add(b, oldb);
                c = safe_add(c, oldc);
                d = safe_add(d, oldd);
            }
            return Array(a, b, c, d);

        }

        /*
         * These functions implement the four basic operations the algorithm uses.
         */
        function md5_cmn(q, a, b, x, s, t)
        {
            return safe_add(bit_rol(safe_add(safe_add(a, q), safe_add(x, t)), s),b);
        }
        function md5_ff(a, b, c, d, x, s, t)
        {
            return md5_cmn((b & c) | ((~b) & d), a, b, x, s, t);
        }
        function md5_gg(a, b, c, d, x, s, t)
        {
            return md5_cmn((b & d) | (c & (~d)), a, b, x, s, t);
        }
        function md5_hh(a, b, c, d, x, s, t)
        {
            return md5_cmn(b ^ c ^ d, a, b, x, s, t);
        }
        function md5_ii(a, b, c, d, x, s, t)
        {
            return md5_cmn(c ^ (b | (~d)), a, b, x, s, t);
        }

        /*
         * Calculate the HMAC-MD5, of a key and some data
         */
        function core_hmac_md5(key, data)
        {
            var bkey = str2binl(key);
            if(bkey.length > 16) bkey = core_md5(bkey, key.length * chrsz);

            var ipad = Array(16), opad = Array(16);
            for(var i = 0; i < 16; i++)
            {
                ipad[i] = bkey[i] ^ 0x36363636;
                opad[i] = bkey[i] ^ 0x5C5C5C5C;
            }

            var hash = core_md5(ipad.concat(str2binl(data)), 512 + data.length * chrsz);
            return core_md5(opad.concat(hash), 512 + 128);
        }

        /*
         * Add integers, wrapping at 2^32. This uses 16-bit operations internally
         * to work around bugs in some JS interpreters.
         */
        function safe_add(x, y)
        {
            var lsw = (x & 0xFFFF) + (y & 0xFFFF);
            var msw = (x >> 16) + (y >> 16) + (lsw >> 16);
            return (msw << 16) | (lsw & 0xFFFF);
        }

        /*
         * Bitwise rotate a 32-bit number to the left.
         */
        function bit_rol(num, cnt)
        {
            return (num << cnt) | (num >>> (32 - cnt));
        }

        /*
         * Convert a string to an array of little-endian words
         * If chrsz is ASCII, characters >255 have their hi-byte silently ignored.
         */
        function str2binl(str)
        {
            var bin = Array();
            var mask = (1 << chrsz) - 1;
            for(var i = 0; i < str.length * chrsz; i += chrsz)
                bin[i>>5] |= (str.charCodeAt(i / chrsz) & mask) << (i%32);
            return bin;
        }

        /*
         * Convert an array of little-endian words to a string
         */
        function binl2str(bin)
        {
            var str = "";
            var mask = (1 << chrsz) - 1;
            for(var i = 0; i < bin.length * 32; i += chrsz)
                str += String.fromCharCode((bin[i>>5] >>> (i % 32)) & mask);
            return str;
        }

        /*
         * Convert an array of little-endian words to a hex string.
         */
        function binl2hex(binarray)
        {
            var hex_tab = hexcase ? "0123456789ABCDEF" : "0123456789abcdef";
            var str = "";
            for(var i = 0; i < binarray.length * 4; i++)
            {
                str += hex_tab.charAt((binarray[i>>2] >> ((i%4)*8+4)) & 0xF) +
                    hex_tab.charAt((binarray[i>>2] >> ((i%4)*8  )) & 0xF);
            }
            return str;
        }

        /*
         * Convert an array of little-endian words to a base-64 string
         */
        function binl2b64(binarray)
        {
            var tab = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
            var str = "";
            for(var i = 0; i < binarray.length * 4; i += 3)
            {
                var triplet = (((binarray[i   >> 2] >> 8 * ( i   %4)) & 0xFF) << 16)
                    | (((binarray[i+1 >> 2] >> 8 * ((i+1)%4)) & 0xFF) << 8 )
                    |  ((binarray[i+2 >> 2] >> 8 * ((i+2)%4)) & 0xFF);
                for(var j = 0; j < 4; j++)
                {
                    if(i * 8 + j * 6 > binarray.length * 32) str += b64pad;
                    else str += tab.charAt((triplet >> 6*(3-j)) & 0x3F);
                }
            }
            return str;
        }

        /*************** END md5.js **************************/





        return {
            //验证规则，提出自validation-rule.js RULES
            RULES: {
                USER_ACCOUNT: {
                    msg:'请输入手机号',
                    rule:/^[0-9A-Za-z_]{1,20}$/
                },
                PASSWORD_LOGIN:{
                    msg:'请输入数字英文或符号,长度为6-20',
                    rule:/^.{6,20}$/
                },
                TRANSACTION_PASSWORD:{
                    msg:'请输入数字，长度为6位',
                    rule:/^[0-9]{6}$/
                }
            },
            //登录代码，提出自js/service.js Validation服务中checkLogin方法
            login: function(user, scope) {
                var url = RestFulURLConstants.security.pandaBankLogin;
                /*加入验证，点击登录时，验证用户名和密码*/
                if(!user.userAccount){
                    // popupbox_custom.popup({
                    //     head: '提示',
                    //     code: 'A1_U_00102'
                    //     //'cont':'请输入用户名'
                    // });
                    //TODO 提示方式需要完全按照手机银行完全一样吗？
                    return;
                }else if(!user.userPassword){
                    // popupbox_custom.popup({
                    //     head: '提示',
                    //     code: 'A1_U_00103'
                    //     //'cont':'请输入登录密码'
                    // });
                    return;
                }

                //TODO 登录的时候需要隐藏密码？
                user.currentType = 'password';
                user.currentClass = 'icon-password-show';
                function makeRandom(len){
                    var str = ['1','2','3','4','5','6','7','8','9','0','a','b','c','d','e','f','g','h','i','j','k','l','m','n','o','p','q','r','s','t','u','v','w','x','y','z'];
                    var count = str.length;
                    var result = '';
                    for(var i = 0; i < len; i++){
                        result += str[parseInt(Math.random()*count)] || 'A';
                    }
                    return result;
                };
                var code = makeRandom(12);

                // console.log(user);
                user.channelType = 'MBL';
                var rePassword = user.userPassword;
                var encryptPassword = encrypt(user.userAccount,user.userPassword);
                user.oldUserPassword = enoup(user.userAccount,rePassword);

                try {
                    //TODO 发送请求从手机银行获取version
                    user.version = $cordovaDevice.getPlatform() + '_' + $cordovaDevice.getVersion();
                }catch(err) {
                    user.version = 'pc';
                }
                var userData = {
                    code: code,
                    userAccount: user.userAccount,
                    userPassword: encryptPassword,
                    oldUserPassword: user.oldUserPassword,
                    channelType: user.channelType,
                    deviceId: hex_md5(code.substring(1, 10) + $rootScope.appFeatures._IMEI),
                    deviceType: $rootScope.isAndroid ? 'android' : 'ios',
                    imei:$rootScope.appFeatures._IMEI
                };

                // Request.post(url,userData,successCall,errorCall);
                new $PFHttpResource(url,userData).then(successCall,errorCall);

                function successCall(data) {

                    //debug测试
                    if(DevelopmentModeConstants.debug){
                        var testArr = [
                            {startIndex:'1',type:'ws'},
                            {startIndex:'2',type:'bound',message:'此账号已绑定过熊猫金融，请前往登录'},
                            {startIndex:'3',type:'pbUnAuth',message:'未实名认证，请前往手机银行实名认证'},
                            {startIndex:'4',type:'pfUnAuth',message:'该手机号已经注册熊猫金融但未实名认证，请先登录熊猫金融进行实名认证'},
                            {startIndex:'5',type:'doAuth'},
                            {startIndex:'6',type:'done',message:'绑定此账号成功'}
                        ];

                        for(var i in testArr){
                            var item = testArr[i];
                            if ((user.userAccount+"").indexOf(item.startIndex) == 0){
                                data.type = item.type;
                                data.message = item.message;
                                break;
                            }
                        }
                    }

                    var message = data.message;

                    //slide-in encapsulated function
                    var slideInHint = function (callback,okText) {
                        BusinessConfirmModal({
                            type: "error",
                            header: "提示",
                            title: "绑定失败",
                            subTitle: message,
                            okText: okText || '确认'
                        }).then(function (result) {
                            if (callback)
                                callback();
                        });
                    };

                    if (!data.type || data.type == 'ws') {
                        //正常情况是熊猫金融未实名，未注册,跳转到快速注册页面
                        data.context.userAccount = user.userAccount;
                        $state.go('security.quickRegister', {params:data.context});
                    }else if(data.type == 'done'){
                        //自动绑定成功
                        BusinessConfirmModal({
                            type: "success",
                            header: "提示",
                            title: "绑定成功",
                            subTitle: message,
                            okText: '去登录'
                        }).then(function (result) {
                            $state.go('security.login');
                        });
                    }else if (data.type == 'bound'){
                        //已经绑定过，提示跳转到熊猫金融登录
                        // $ionicPopup.alert({
                        //     title: '提示',
                        //     template: message,
                        //     okText:'确认',
                        //     okType:'button-panda'
                        // }).then(function () {
                        //     $state.go('security.login');
                        // });

                        //采用右侧slide-in方式
                        slideInHint(function (result) {
                            $state.go('security.login',{backTo:'index'});
                        },'去登录');

                        return;
                    }else if(data.type == 'pbUnAuth') {
                        //手机银行未实名
                        // $ionicPopup.alert({
                        //     title: '提示',
                        //     template: message,
                        //     okText:'确认',
                        //     okType:'button-panda'
                        // });
                        slideInHint();
                        return;
                    }else if(data.type == 'pfUnAuth'){
                        //熊猫金融未实名，已注册
                        // $ionicPopup.alert({
                        //     title: '提示',
                        //     template: message,
                        //     okText:'确认',
                        //     okType:'button-panda'
                        // }).then(function () {
                        //     $state.go('security.login');
                        // });
                        slideInHint(function () {
                            $state.go('security.login');
                        },'去登录');
                        return;
                    }else if(data.type == 'doAuth'){
                        // if(message){
                        //     $ionicPopup.alert({
                        //         title: '提示',
                        //         template: message,
                        //         okText:'确认',
                        //         okType:'button-panda'
                        //     }).then(function () {
                        //         //跳转到快速开户页面
                        //         $state.go('security.quickOpenAcc',{params:data.context});
                        //     });
                        // }else {
                            $state.go('security.quickOpenAcc',{params:data.context});
                        // }

                        return;
                    }


                }

                function errorCall(error) {


                }


            }

        }
    }]);

