/**
 * Created by Z.ZR on 2015/9/11
 */

angular.module('pf.services.storage', [])
    .config(function (localStorageServicesProvider, sessionStorageServicesProvider) {

    })
    .factory('localStorageServices', function (webStorage) {
        var localStorage = {};
        localStorage.setStorage = function (key, value) {
            if (arguments.length === 2) {
                var v = value;
                if (typeof v == 'object') {
                    v = JSON.stringify(v);
                    v = 'obj-' + v;
                } else {
                    v = 'str-' + v;
                }
                webStorage.local.set(key, v);
            }
        };
        localStorage.getStorage = function (key) {
            if (key && webStorage.local.has(key)) {
                var v = webStorage.local.get(key);
                if (!v) {
                    return;
                }
                if (v.indexOf('obj-') === 0) {
                    v = v.slice(4);
                    return JSON.parse(v);
                } else if (v.indexOf('str-') === 0) {
                    return v.slice(4);
                }
            }
            return;
        };
        localStorage.rmStorage = function (key) {
            if (key && webStorage.local.has(key)) {
                webStorage.local.remove(key)
            }
        };
        localStorage.clearStorage = function () {
            webStorage.local.clear();
        };
        return localStorage;
    })
    .factory('sessionStorageServices', function (webStorage) {
        var sessionStorage = {};
        sessionStorage.setStorage = function (key, value) {
            if (arguments.length === 2) {
                var v = value;
                if (typeof v == 'object') {
                    v = JSON.stringify(v);
                    v = 'obj-' + v;
                } else {
                    v = 'str-' + v;
                }
                webStorage.session.set(key, v);
            }
        };
        sessionStorage.getStorage = function (key) {
            if (key && webStorage.session.has(key)) {
                var v = webStorage.session.get(key);
                if (!v) {
                    return;
                }
                if (v.indexOf('obj-') === 0) {
                    v = v.slice(4);
                    return JSON.parse(v);
                } else if (v.indexOf('str-') === 0) {
                    return v.slice(4);
                }
            }
        };
        sessionStorage.rmStorage = function (key) {
            if (key && webStorage.session.has(key)) {
                webStorage.session.remove(key);
            }
        };
        sessionStorage.clearStorage = function () {
            webStorage.session.clear();
        };
        return sessionStorage;
    });
